// AIPlayer.h: interface for the AIPlayer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AIPLAYER_H__2D5F34FD_2B0D_4639_B8EB_4CF9724C3F0D__INCLUDED_)
#define AFX_AIPLAYER_H__2D5F34FD_2B0D_4639_B8EB_4CF9724C3F0D__INCLUDED_


#include "WDPlayer.h"
#include "hazard.h"

#define MAX_HAZARDS 32
//AI sensor messages
//messages comprised of type followed by location
#define AIS_TORNADO 0
#define AIS_FLOOD 1 //location ignored
#define AIS_FIREBALL 2
#define AIS_QUICKSAND 3
#define AIS_ENEMYPOS 4
#define AIS_DANGERAHEAD 5

#define MOOD_WANDERING 0
#define MOOD_AGGRESSIVE 1
#define MOOD_DEFENSIVE 2

class AIPlayer : public WDPlayer  
{
public:
	AIPlayer();
	virtual ~AIPlayer();

	void sendMessage(int message, float pos[3]);
	void doStuff();
	int getType(){return PLAYER_AI;}
	void setSkill(float skill_in);




private:
	bool active;
	float skill;
	void setDest(float x, float y, float radius, float priority);
	void gotoDestination();
	void hazardSensor();
	float testVect(float vect[2]);

	void addHazard(float * pos, float radius, float danger);
	void gotoNearestHighpoint(float priority);
	int getClosestHighpoint(float * location, float &distOut);

	void clearHazards();
	void checkStuck();
	bool attack();

	float attackTimer;
	float timeBetweenAttacks;

	double decisionTimer;
	float dest[2];
	float destRad;
	float destPriority;
	float destNorm[2];
	float destAngle;
	float destDist;
	float travelTime;

	float enemyPos[3];
	float highPoint[3][2];
	int numHighPoints;

	float sensorLength;

	float oldPos[2];
	
	float quickSandPos[3];

	Hazard hazards[MAX_HAZARDS];
	int numHazards;

	double changeMoodTimer;
	int mood;

};

#endif // !defined(AFX_AIPLAYER_H__2D5F34FD_2B0D_4639_B8EB_4CF9724C3F0D__INCLUDED_)
