// ActionManager.h: interface for the ActionManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ACTIONMANAGER_H__C6860A0A_BF36_48D2_AFDA_D5DF3B00F034__INCLUDED_)
#define AFX_ACTIONMANAGER_H__C6860A0A_BF36_48D2_AFDA_D5DF3B00F034__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "b3d.h"

#define MAX_ACTIONS 32

struct Action
{
	char name[50];
	int startFrame;
	int endFrame;
	int numFrames;
	int index;

	int schematicX;
	int schematicY;

	std::vector <int> links;
	//std::vector <int> actionMap; //maps an action number to a link (or -1 if impossible)
};

class ActionManager
{
public:
	ActionManager();
	virtual ~ActionManager();
	void reset();

	bool assignAction(char * name, int startFrame, int endFrame, int schematicX, int schematicY);
	void linkAction(int actionNuma, int actionNumb);
//	void buildActionMap(int aNum, bool * actionsLinked);
//	void buildActionMaps();
	void init();
	void draw();
	int getAction(){return currentActionNo;}
	int getDestAction(){return destActionNo;}
	void gotoNextAction();
	void setAction(int actionID);
	void setDestAction(int actionID);
	float getSchematicDist(int x, int y);
	void setB3D(B3D * b3d){this->b3d=b3d;}
	int getCurrentActionNo(){return currentActionNo;}
	int getCurrentFrame(){return currentFrame;}
	void setFPS(float framesPerSec);
	B3D * getB3D(){return b3d;}

	void speedToAction(int actionID);
	int getRealCurrentFrame(){return currentAction->startFrame+currentFrame;}


protected:
	bool doubleFrameRate;
	int speedAction;
	float oldFPS;

	int currentFrame;
 	int currentActionNo;
	int destActionNo;
	Action * currentAction;
	Action * destAction;

	Action actions[MAX_ACTIONS];
	int numActions;
	int numFrames;
	float framesPerSec;
	float frameTime;

	B3D * b3d;

	timer_c timer;
};

#endif // !defined(AFX_ACTIONMANAGER_H__C6860A0A_BF36_48D2_AFDA_D5DF3B00F034__INCLUDED_)
