// AnimMesh.h: interface for the AnimMesh class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ANIMMESH_H__B85A0185_7A0D_476B_B853_D498FAEC77F5__INCLUDED_)
#define AFX_ANIMMESH_H__B85A0185_7A0D_476B_B853_D498FAEC77F5__INCLUDED_

class CFrame
{
    public:
        CFrame()
        {
            ver=NULL;
			vNorm=NULL;
        }
        ~CFrame()
        {
            if (ver!=NULL)
                delete [] ver;
			if (vNorm!=NULL) delete [] vNorm;
        }
		void calculateVNorms(SimpleTri * tri,int numTris,int numVers);
		void calculateTriNorms(SimpleTri * tri, int numTris,float (* norms) [3]);
		void calculateVerNorms(SimpleTri * tri, float (*tNorm)[3], int numTris, int numVers);
		
        CVertex * ver;
		float (*vNorm)[3];
};


class AnimMesh : public Mesh
{
    public:
		AnimMesh()
        {
            numFrames=0;
            frame=NULL;
			parentB3D=NULL;
			drawb=true;
        }
        ~AnimMesh()
        {
            if (frame!=NULL) delete [] frame;
        }
		float * getVertexPos(int frameNo,int v);
		void draw(int frameNo);
        void CreateFrames(int num);
		bool readFromStream(FILE * str);
		bool writeToStream(FILE * str);
		void calculateVNorms();
        CFrame * frame;		//where all the vertices are
        int numFrames;
};





#endif // !defined(AFX_ANIMMESH_H__B85A0185_7A0D_476B_B853_D498FAEC77F5__INCLUDED_)
