// ArtLight.h: interface for the ArtLight class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ARTLIGHT_H__01BD38C5_FFD7_4EA7_BF9C_AA19FD63CAD8__INCLUDED_)
#define AFX_ARTLIGHT_H__01BD38C5_FFD7_4EA7_BF9C_AA19FD63CAD8__INCLUDED_

#define MAX_ARTLIGHTS 32

//an artlight is a light on a lightmap
struct ArtLight  
{
public:
	ArtLight();
    ArtLight(const ArtLight &src); //copy constructor (required by STL)
	virtual ~ArtLight();

	const ArtLight& operator= (const ArtLight &src); //(required by STL)

	void setImage(CImage * image){this->image=image;}

	void copyFrom(const ArtLight &src);

	//int x,y;
	int originx,originy;
	CImage * image;

	bool exist;
};

class DynTexture
{
public:
	DynTexture();
	virtual ~DynTexture();
	void bind(){tex->bind();}
	void loadImage(char * filename);
	void addImage(CImage * image);
	int drawLight(int x, int y, int imgNo, bool alphaBlend=false);
//	void clearLight(int lightNo, CImage *backupImg);
	void clearLights();

	void addNewLightImage(CImage &image);

	bool loadNewLightImage(char * filename);

	CImage image;
	CTexture * tex;

	//DEBUGGING
//	bool saveMe;
//	SaveImage save;
	/////////////
private:
//	int getNewLightID();
	void removeLight(ArtLight &lite);

	

	std::vector <CImage> lightImages;
	CImage composite;
	//std::vector <ArtLight> lights;
	ArtLight lights[MAX_ARTLIGHTS]; 
	
	int numLights;
};

#endif // !defined(AFX_ARTLIGHT_H__01BD38C5_FFD7_4EA7_BF9C_AA19FD63CAD8__INCLUDED_)
