// BoundingSphere.h: interface for the BoundingSphere class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BOUNDINGSPHERE_H__3B15DD47_8C40_4926_8537_62C70BF83A2F__INCLUDED_)
#define AFX_BOUNDINGSPHERE_H__3B15DD47_8C40_4926_8537_62C70BF83A2F__INCLUDED_

#define COL_OUT 0
#define COL_IN 1 
#define COL_PART 2

class BoundingSphere  
{
public:     
	BoundingSphere();
	virtual ~BoundingSphere();
	void checkFrustum(ViewFrustum &frustum);  //returns COL_IN, COL_OUT, or COL_PART
	int getVis(){return vis;}

	void createChildren(int numChildren);
	BoundingSphere * getChild(int childNum){return &children[childNum];}
	void set(float x, float y, float z, float radius_in)
	{
		pos[0]=x; pos[1]=y; pos[2]=z; 
		radius=radius_in;
	}
	void setPos(float x,float y,float z);
	float getPos(int dim){return pos[dim];}
	float getRadius(){return radius;} 
 
	void moveBy(float v[3]);
	void setDPos(int dim, float amt);
	void moveDBy(int dim, float amt);

	int getNumChildren(){return numChildren;}
	int vis;

protected:
	float pos[3];
	float radius;


	int numChildren;
	BoundingSphere * children;
};

#endif // !defined(AFX_BOUNDINGSPHERE_H__3B15DD47_8C40_4926_8537_62C70BF83A2F__INCLUDED_)
