/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// FloodSpell.cpp: implementation of the FloodSpell class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FloodSpell.h"
#include "Dauntless.h"
#include "ParticleRain.h"
#include "Sea.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

FloodSpell::FloodSpell()
{
	rain=new ParticleRain(250);
	timer=0;
//	thunderSound=mainGM.sounds[0];
	mainGM.sounds[0]->getDuplicate(&thunderSound);
	mainGM.sounds[1]->getDuplicate(&seaSound);
	mainGM.sounds[2]->getDuplicate(&rainSound);
//	rainSound=mainGM.sounds[2];
	thunderSound.play();

	//tell the AI (it's only fair)
	float pos[3]={0,0,0};
	mainGM.AIMessage(AIS_FLOOD, pos);
}

FloodSpell::~FloodSpell()
{
	mainGM.setSeaDepth(20);	//set the seadepth safely
	rainSound.stop();
}

void FloodSpell::doStuff()
{


	double oldTimer=timer;
	timer+=speedmod;

	if (oldTimer==0)
	{
		rainSound.setVolume(0);
		rainSound.playRepeat();
	}
	if (timer<200)
	{
		//fade in
		rainSound.setVolume((timer)/200);
	}
	if (timer>150 && oldTimer<=150) //5 seconds
	{
		mainGM.getSea()->setDesiredDepth(38);
		seaSound.play();
	}
	if (timer>1900 && oldTimer<=1900) //10 seconds
	{
		rain->stop();
	}

	if (timer>1950 && timer<2200)
	{
		//fade out
		rainSound.setVolume(1.0-((float)(timer-1950)/250.0));
	}
	
	if (timer>2200 && oldTimer<=2200)
	{
		rainSound.stop();
	}
	if (timer>2400 && oldTimer<=2400)
	{
		mainGM.getSea()->setDesiredDepth(20);
		seaSound.play();
	}

	if (timer>2600 && oldTimer<=2600)
	{
		exist=false;
	}

}