// Font.cpp: implementation of the Font class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Font.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Font::Font()
{
	colour[0]=1;
	colour[1]=1;
	colour[2]=1;
	tex=NULL;
	alternate=false;
	charOffset=0;
}

Font::~Font()
{

}

void Font::setSize(int sizeX_in,int sizeY_in)
{

	sizeX=sizeX_in;
	sizeY=sizeY_in;
}
void Font::setColour(float r,float g, float b)
{
	colour[0]=r;
	colour[1]=g;
	colour[2]=b;
}


void Font::setTexP(CTexture * tex_in) //sets the font texture pointer
{
	tex=tex_in;
}

void Font::setResolution(int x, int y)
{
	resX=x;
	resY=y;
}


bool Font::load(const char * texFilename, const char * sizeFilename)
{
	FILE * file;
	
	if ((file=fopen(sizeFilename,"rb"))==NULL)
	{
		messageBox("FontSize file %s not found",sizeFilename);
		return false;
	}

	//set the letter widths
	for (int a=0;a<256;++a)
	{
		letter[a].width=fgetc(file);
		
	}
	fclose(file);

/*
	CImage image;
	image.loadBMP(texFilename);
	calculateWidths(image);*/
	setResolution(16,16);
	tex=loadNewTexture(texFilename,TF_LML,TF_LML,UNKNOWN,LOADTEX_ALPHAMAP);

	sizeX=32;
	sizeY=32;

	texCoordHeight=1.0/16.0;

	//set the texcoords
	a=0;
	
	for (int y=0;y<resY;++y)
	{
		for (int x=0;x<resX;++x)
		{
			int charOffset=round(((float)sizeX - (float)letter[a].width)/2.0);
			letter[a].texCoordx[0]=(x/16.0) + charOffset/512.0;
				
				//(float)((float)x+((float)charOffset/16.0))/16.0;
			letter[a].texCoordWidth=(float)letter[a].width/512.0;

			letter[a].texCoordx[1]=	letter[a].texCoordx[0]+
									letter[a].texCoordWidth;

			letter[a].texCoordy[0]=(15.0-(float)y)/16.0;
			letter[a].texCoordy[1]=letter[a].texCoordy[0]+texCoordHeight;
/*
			debug.write("letter[%d]\n",a);

			debug.write("texcoordx %f %f\ntexcoordy %f %f\n\n",
						letter[a].texCoordx[0],
						letter[a].texCoordx[1],
						letter[a].texCoordy[0],
						letter[a].texCoordy[1]);*/
						
			++a;
		}
	}
	return true;
}


void Font::setAlternate(bool alt)
{
	if (alt) charOffset=128;
	else charOffset=0;
}

/*
void Font::calculateWidths(CImage & fontImage)
{
	int x,y;
	int p;

	int lhs,rhs;
	for (y=0;y<16;++y)
	{
		for (x=0;x<16;++x)
		{
			for (b=0;b<16;++b)
			{
				for (c=0;c<16;++c)
				{
				}
			}
			letter[a].width=
			++p;

		}
	}
}
*/