/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// GameClient.cpp: implementation of the GameClient class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GameClient.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


GameClient::GameClient()
{

}

GameClient::~GameClient()
{

}

void GameClient::doStuff()
{
	if (!connected)
	{
		if (host && !connected)
		{
			sendMessage(CMD_HOSTING); //tell player we're here
		}
		if (!host && !connected)
		{
			sendMessage(CMD_JOINING);
		}
	}
	userPlayer->sendState();
}

void GameClient::sendMessage(unsigned msg)
{
		sendto(sock,(char *)&msg,sizeof(unsigned),0,(struct sockaddr*)&addrDest,
			sizeof(addrDest));
}

bool GameClient::init(bool host, NetPlayer * netPlayer, UserPlayer * userPlayer)
{
	this->host=host;

	if (host) id=0;
	else id=1;
	this->netPlayer=netPlayer;
	this->userPlayer=userPlayer;
	client.startMulticastIP();
	return true;
}



void GameClient::readCommand(SOCKET sock)
{
	char buf[256];
	
	if (client.debug) glPrintf("readcommand");
	int size=sizeof(sockaddr);
	int er;
	er=recvfrom(sock,buf,256,0,(struct sockaddr*)&addrDest,&size); //read the command
	if (SOCKET_ERROR==er) 
	{
		//translateError(er);
		return;
	}
	else
	{
		//messageBox("message received ok");
	}

//	connected=true;
	switch(buf[0])
	{
		case CMD_DISCONNECT:
			if (connected)
			{
				connected=false; //client disconnected
				glCls();
				glPrintf("other player disconnected\n");
			}
		break;

		case CMD_JOINING:
			if (host && !connected)
			{
				glCls();
				glPrintf("connected to client\n");
				sendMessage(CMD_ACCEPTED);
				connected=true;
			}
		break;
		case CMD_HOSTING:
			if (!host && !connected)
			{
				glCls();
				glPrintf("server found. Connecting...\n");
				sendMessage(CMD_JOINING);
			}
		break;		
		case CMD_ACCEPTED:
			if (!host && !connected)
			{
				connected=true;
				glCls();
				glPrintf("Connected!\n");
			}
		break;
		case CMD_GAMESTATE:
			if (connected)
			{
				recvGameState(buf);
			}
		break;
		case CMD_DEBUG:
			glPrintf("debug message received\n");
		break;
	}
}


void GameClient::recvGameState(char * buf)
{
	CmdGameState state;

	int *pI=(int *) buf;

	if (pI[1]!=id)
	{
		unsigned time=pI[2];
		if (time<recvTime) return;
		recvTime=time;
		memcpy((void *)&state,(void *)buf,sizeof(CmdGameState));
		netPlayer->recvState(&state);
	}
}

void GameClient::sendGameState(CmdGameState * state)
{
	
	if (connected)
	{

		char buf[128];
		state->id=id;
		state->time=sendTime++;

		memcpy((void *)&buf,(void *)state,sizeof(CmdGameState));

		sendto(sock,buf,128,0,(struct sockaddr*)&addrDest,
				sizeof(addrDest));
	}
	
}

void GameClient::disconnect()
{
	if (connected) 
	{
		sendMessage(CMD_DISCONNECT);
		connected=false;
	}
}

