// GameClient.h: interface for the GameClient class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAMECLIENT_H__AA4E64FA_922C_4AAC_BBB7_176CB4CAFC72__INCLUDED_)
#define AFX_GAMECLIENT_H__AA4E64FA_922C_4AAC_BBB7_176CB4CAFC72__INCLUDED_

#include "netclient.h"
#include "netPlayer.h"
#include "userPlayer.h"
#include "waitForPlayers.h"

#define CMD_JOINING 10
#define CMD_HOSTING 11
#define CMD_ACCEPTED 12
#define CMD_DEBUG 13

struct CmdJoining
{
	CmdJoining(){type=CMD_JOINING;}
	int type;
};

struct CmdHosting
{
	CmdHosting(){type=CMD_HOSTING;}
	int type;
};



class GameClient:public NetClient
{
public:
	GameClient();
	bool init(bool host, NetPlayer * netPlayer,UserPlayer * userPlayer);

	void readCommand(SOCKET sock);
	void recvGameState(char * buf);
	void sendGameState(CmdGameState * state);
	void sendMessage(unsigned msg);
	void doStuff();
	bool isConnected(){return connected;}
	void disconnect();

	virtual ~GameClient();

	NetPlayer * netPlayer;
	UserPlayer * userPlayer;
	WaitForPlayers waitForPlayers;
protected:
	int id;
	unsigned recvTime;
	unsigned sendTime;

//	void HandleM
};

#endif // !defined(AFX_GAMECLIENT_H__AA4E64FA_922C_4AAC_BBB7_176CB4CAFC72__INCLUDED_)
