/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// GameInfoDisplay.cpp: implementation of the GameInfoDisplay class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GameInfoDisplay.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GameInfoDisplay::GameInfoDisplay()
{
}

GameInfoDisplay::~GameInfoDisplay()
{

}

void GameInfoDisplay::display(Wizard * wizards, int userWizardNo, int score[2])
{
	
	font.setColour(1,0,0);
	//font.setSize(64,64);

	float fx=font.sizeX;
	float fy=font.sizeY;
	bool alt=font.getAlternate();

	font.setAlternate(false);
	font.setSize(40,40);
	outText(30, 50,"%d",score[0]);

	font.setColour(0,0,1);
	outText(350, 50,"%d",score[1]);
	font.setSize(fx,fy);
	font.setAlternate(alt);


	//font.setSize(32,32);

	font.setColour(1,1,1);
	setTextureLevel(0);
	screen.push2D();
	glEnable(GL_BLEND);

	float black[4]={0,0,0,0.3};
	float red[4]={1,0,0,0.5};
	float blue[4]={0,0,1,0.5};

	drawEnergyBar(50,22,240,15,wizards[0].getHealth(),black,red);
	drawEnergyBar(370,22,240,15,wizards[1].getHealth(),black,blue);

	setTextureLevel(GL_TEXTURE_2D);
	glEnable(GL_TEXTURE_2D);
	glColor4f(1,1,1,0.9);

	redHealthTex->bind();
	draw2DRect(40,40,20,20);

	blueHealthTex->bind();
	draw2DRect(40,340,20,360);

	//spells
	drawSpells(wizards[userWizardNo].getCurrentSpell(),&wizards[userWizardNo]);
	
	
	screen.pop2D();


	glEnable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	setTextureLevel(GL_TEXTURE_2D);

	
}



void GameInfoDisplay::drawSpells(int selection, Wizard * userWizard)
{
	bool select[4]={false,false,false,false};
	glColor4f(1,1,1,0.4);
	int y=432;
	int x=595;
	int align=35;

	select[selection]=true;


	drawSpell(x,y,earthTex,userWizard->getSpellPower(0),select[0]);
	y-=align;
	drawSpell(x,y,airTex,userWizard->getSpellPower(1),select[1]);
	y-=align;
	drawSpell(x,y,fireTex,userWizard->getSpellPower(2),select[2]);
	y-=align;
	drawSpell(x,y,waterTex,userWizard->getSpellPower(3),select[3]);
}

void GameInfoDisplay::drawSpell(int left, 
								int bottom,
								CTexture * tex,
								float power,
								bool selected)
{
	tex->bind();
	float trans;

	if (selected) trans=1;
	else trans=0.4;
	
	glColor4f(1,1,1,trans);

	//if (!selected) trans=0.9;
	trans=1;
	draw2DRect(bottom+32,left+32,bottom,left);

	//glColor4f(1,1,1,trans);
	float cola[4]={0.5,0.5,1,trans};
	float colb[4]={0.5,0.5,1,trans};

	if (power==1)
	{
		cola[0]+=0.3*screen.getFlasher();
		colb[0]+=0.3*screen.getFlasher();

		cola[1]+=0.3*screen.getFlasher();
		colb[1]+=0.3*screen.getFlasher();
	}


	glDisable(GL_TEXTURE_2D);
	drawEnergyBar(left+10,bottom+10,13,3,power,cola,colb);
	glEnable(GL_TEXTURE_2D);
}

							
void GameInfoDisplay::drawEnergyBar(	int left, 
										int bottom, 
										int width, 
										int height, 
										float full, 
										float cola[4],
										float colb[4])
{
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	glDisable(GL_TEXTURE_2D);

	int top=height+bottom;
	int right=left+width;
	int barTop=top-1;
	int barLeft=left+1;
	int barRight=barRight=barLeft+(width-2)*full;
	int barBottom=bottom+1;

	

	float black[4]={0,0,0,0.2};

	for (int a=0;a<2;++a)
	{
		glBegin(GL_QUADS);
			glColor4fv(black);
			glVertex2i(left,bottom);

			glColor4fv(black);
			glVertex2i(right,bottom);

			glColor4fv(black);
			glVertex2i(right,top);

			glColor4fv(black);
			glVertex2i(left,top);

			
			glColor4fv(cola);
			glVertex2i(barLeft,barBottom);

			glColor4fv(colb);
			glVertex2i(barRight,barBottom);

			glColor4fv(colb);
			glVertex2i(barRight,barTop);

			glColor4fv(cola);
			glVertex2i(barLeft,barTop);
		glEnd();
	}
	glEnable(GL_TEXTURE_2D);
}

void GameInfoDisplay::draw2DRect(int top, int right, int bottom, int left)
{
	glBegin(GL_QUADS);
		glTexCoord2f(0,0);
		glVertex2i(left,bottom);

		glTexCoord2f(1,0);
		glVertex2i(right,bottom);

		glTexCoord2f(1,1);
		glVertex2i(right,top);

		glTexCoord2f(0,1);
		glVertex2i(left,top); 
	glEnd();
}

void GameInfoDisplay::loadTextures()
{
	CImage onImg,offImg,aImage;

	aImage.loadBMP("textures//symbols//healthAlpha.bmp");

	redHealthTex=loadTexAlpha("textures//symbols//redHealth.bmp",aImage);
	blueHealthTex=loadTexAlpha("textures//symbols//blueHealth.bmp",aImage);

	aImage.loadBMP("textures//symbols//spellAlpha.bmp");
	earthTex=loadTexAlpha("textures//symbols//earth.bmp",aImage);
	airTex=loadTexAlpha("textures//symbols//air.bmp",aImage);
	fireTex=loadTexAlpha("textures//symbols//fire.bmp",aImage);
	waterTex=loadTexAlpha("textures//symbols//water.bmp",aImage);

}

CTexture * GameInfoDisplay::loadTexAlpha(const char * fn, CImage & alpha)
{
	CImage image;
	image.loadBMP(fn);
	image.addAlphaChannel(alpha);
	return loadTexFromImage(image,TF_N,TF_N);
}