/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// HelpMenu.cpp: implementation of the HelpMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "HelpMenu.h"
#include "dauntless.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

HelpMenu helpMenu;

HelpMenu::HelpMenu()
{
	page=0;
}

HelpMenu::~HelpMenu()
{
}

void HelpMenu::display()
{
	drawGrayRect(-0.5,20,20,620,460);
	glCls();
	font.setAlternate(true);

	font.setSize(25,25);
	glPrintf("\n  ~Help~~~~~~~~~~~~~~Page %d of 3\n",page+1);
	switch(page)
	{
		case 0:
			glPrintf("  ~~CONTROLS:\n");
			glPrintf("  ~~MouseLook~~~~~~ Right button\n");
			glPrintf("  ~~Cast Spell~~~~~~ Left button\n");
			glPrintf("  ~~Move~~~~~~~ cursor keys\n");
			glPrintf("  ~~Select Spell~~~~~ Middle button or numpad 1/0\n");
			glPrintf("  ~~Zoom in/out~~~~~ MouseWheel or A/Z\n");
			glPrintf("\n  ~~Menu~~~~~~~ Escape\n");
			glPrintf("  ~~This help screen~~~~ F1\n");
			
			glPrintf("\n  ~~Tip:\n");
			glPrintf("  ~~~Spell icons are shown on the right of the screen. They\n");
			glPrintf("  ~~~indicate the currently selected spell and spell power levels.\n");
		break;
		case 1:
			glPrintf("  ~~SPELLS:\n");
			glPrintf("  ~~~QUICKSAND\n");
			glPrintf("  ~~~Send your opponent to a sandy grave with this earth spell\n");
			glPrintf("\n  ~~~TORNADO\n");
			glPrintf("  ~~~Create a swirling magical vortex to blow your enemies away.\n");
			glPrintf("\n  ~~~FIREBALL\n");
			glPrintf("  ~~~Bring flaming death upon your opponents. Pretty simple really.\n");
			glPrintf("\n  ~~~FLOOD\n");
			glPrintf("  ~~~Flowerbeds need watering? Use this spell. (Also useful for\n");
			glPrintf("  ~~~destroying evil wizards)\n");
		break;
		case 2:
			glPrintf("  ~~GENERAL TIPS:\n");
			glPrintf("  ~~~- The camera is pretty flexible. Adjust the zoom level to\n");
			glPrintf("  ~~~to suit your style of play.\n");
			glPrintf("\n  ~~~- Spells need to have full power to cast. Some spells take\n");
			glPrintf("  ~~~longer to recharge than others.\n");
			glPrintf("\n  ~~~- Aiming fireballs can be tricky for novice wizards. Practice\n");
			glPrintf("  ~~~makes perfect, though.\n");
			glPrintf("\n  ~~~- For technical info, see README.TXT\n");
			glPrintf("\n\n");
		break;
	}
	glPrintf("\n  ~~Press UP/DOWN for more pages, or ESCAPE to resume the game\n");
}
void HelpMenu::doStuff()
{
	if (keyJustPressed(DIK_SPACE))
	{
		leave();
	}
	if (keyJustPressed(DIK_ESCAPE))
	{
		leave();
	}
	if (keyJustPressed(DIK_DOWN))
	{
		page++;
		if (page>2) page=0;
	}
	if (keyJustPressed(DIK_UP))
	{
		page--;
		if (page<0) page=2;
	}
}

void HelpMenu::leave()
{
	glCls();
	mainGM.setDisplayHelp(false);
	font.setAlternate(true);
	font.setSize(32,32);
	if (mainGM.getMode()==MODE_INTRO)
	{
		mainMenu.execute();
	}
}
