/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// Image_BMPHeader.cpp: implementation of the Image_BMPHeader class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Image_BMPHeader.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BMPHeader::BMPHeader(unsigned int width_in, unsigned int height_in, unsigned int numChannels)
{
	id[0]='B'; id[1]='M';
	//id='B' || 'M'<<8;


	reserved=0;
	planes=1;
	compression=0;
	hResPerMetre=100000;
	vResPerMetre=100000;
	headerSize=40;

	bpp=numChannels<<3;
	if (bpp==24)
	{
		dataOffset=54;
	}
	else
	{
		dataOffset=1078;
	}
	colours=0;//(int)pow(2,bpp);
	importantColours=0;//colours;
	width=width_in;
	height=height_in;

	int alignBytes=getAlignBytes();
	bitmapDataSize=numChannels*width*height+alignBytes*height;
	filesize=dataOffset+bitmapDataSize;
}

void BMPHeader::writeToFile(FILE * f)
{
	fwrite((void *)id,1,2,f);
	_putw(filesize,f);
	_putw(reserved,f);
	_putw(dataOffset,f);
	_putw(headerSize,f);
	_putw(width,f);
	_putw(height,f);
	fwrite((void *)&planes,2,1,f);
	fwrite((void *)&bpp,2,1,f);
	_putw(compression,f);
	_putw(bitmapDataSize,f);
	_putw(hResPerMetre,f);
	_putw(vResPerMetre,f);
	_putw(colours,f);
	_putw(importantColours,f);

	//write the pallette
	if (bpp==8)
	{
		for (int a=0;a<256;++a)
		{
			fputc(a,f);
			fputc(a,f);
			fputc(a,f);
			fputc(0,f);
		}
	}

}
void BMPHeader:: readFromFile(FILE * f)
{
	fread((void *)id,1,2,f);
	filesize=_getw(f);
	reserved=_getw(f);
	dataOffset=_getw(f);
	headerSize=_getw(f);
	width=_getw(f);
	height=_getw(f);
	fread((void *)&planes,2,1,f);
	fread((void *)&bpp,2,1,f);
	compression=_getw(f);
	bitmapDataSize=_getw(f);
	hResPerMetre=_getw(f);
	vResPerMetre=_getw(f);
	colours=_getw(f);
	importantColours=_getw(f);

	//write the pallette (skip it)
	if (bpp==8)
	{
		for (int a=0;a<256;++a)
		{
			(void)_getw(f);
		}
	}
}

int BMPHeader::getAlignBytes()
{
	int v=4-((width*(bpp>>3))%4);
	if (v==4) return 0;
	return v;
}
