/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// Intro.cpp: implementation of the Intro class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Intro.h"
#include "dauntless.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Intro::Intro()
{
//	pMain=&::mainGM;
	firstInit=true;
}

Intro::~Intro()
{

}


void Intro::mainLoop()
{
	oldTimer=timer;
	timer+=speedmod;

	if (keyJustPressed(DIK_ESCAPE) || mouse.getLButtonClicked() || 
		mouse.getRButtonClicked() || keyJustPressed(DIK_SPACE) ||
		keyJustPressed(DIK_RETURN))
	{
		backToGame();
	}
	if (oldTimer<4400 && timer>=4400)
	{
		backToGame();
	}
}

void Intro::draw()
{
//	float sTime;
/*
	bright=0;
	if (timer>500)
	{
		sTime=timer-600;
		if (sTime<1000)
		{
			bright=-1+(sTime/1000.0);
			//glCls();
			//glPrintf("%f",bright);
		}
		else bright=0;
	}
	*/
	fadeEvent(0,500,1000,0,-1,-0.4,0);
	fadeEvent(1000,1500,2250,0,0,0,0);
	drawFader(bright);
	screen.push2D();
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE,GL_ONE);


		
	slideEvent( 0, 500,750,1000,100,0,0.5,0);

	slideEvent( 1, 1300,1600,2000,300,0,0.45,0);

	fadeEvent(2100,2250,2400,10,0,-1,0);

	if (oldTimer<2250 && timer>=2250)
	{
		mainGM.getCam()->pos[0]=100;
		mainGM.getCam()->pos[2]=150;
		mainGM.getCam()->rot[0]=20;
		mainGM.getCam()->rot[1]=240;
		mainGM.getCam()->radius=160;
	}

	if (timer>=2500 && timer<=3200)
	{
		glPushMatrix();
			glTranslatef(-100,80,0);
			slideEvent( 2, 2500,2800,3200,300,0,0.5,0);
		glPopMatrix();
	}

	fadeEvent(3200,3250,3300,10,0,-1,0);

	if (oldTimer<3250 && timer>=3250)
	{
		mainGM.getCam()->pos[0]=20;
		mainGM.getCam()->pos[2]=100;
		mainGM.getCam()->rot[0]=30;
		mainGM.getCam()->rot[1]=120;
		mainGM.getCam()->radius=100;
	}
	slideEvent( 3, 3400,3600,4100,300,0,0.5,0);
	fadeEvent(4200,4300,4400,10,0,-1,0);

	if (oldTimer<4300 && timer>=4300)
	{
		mainGM.getCam()->pos[0]=0;
		mainGM.getCam()->pos[2]=0;
		mainGM.getCam()->rot[0]=90;
		mainGM.getCam()->rot[1]=180;
		mainGM.getCam()->radius=500;
	}

	glDisable(GL_BLEND);
	screen.pop2D();

}

void Intro::showSlide(float bright)
{
	glColor4f(bright,bright,bright,bright);

	glBegin(GL_QUADS);
		glTexCoord2f(0,0);
		glVertex2i(192,112);

		glTexCoord2f(0,1);
		glVertex2i(192,368);

		glTexCoord2f(1,1);
		glVertex2i(448,368);

		glTexCoord2f(1,0);
		glVertex2i(448,112);
	glEnd();
}

void Intro::drawFader(float bright)
{
	drawGrayRect(bright,0,0,640,480);
}

void Intro::backToGame()
{
//	messageBox("menuexecute");
	mainMenu.execute();
}

void Intro::init()
{
	if (!firstInit)
	{
		mainGM.getThemeTune()->stop();
	}
	if (firstInit)
	{
		chdir("textures\\intro");
		slideshow[0]=loadNewTexture("elfstone.bmp",TF_N,TF_N,BMP);
		slideshow[1]=loadNewTexture("wizardduel2.bmp",TF_N,TF_N,BMP,LOADTEX_ALPHAMAP);
		slideshow[2]=loadNewTexture("benWoodhouse.bmp",TF_N,TF_N,BMP,LOADTEX_ALPHAMAP);
		slideshow[3]=loadNewTexture("davidBlake.bmp",TF_N,TF_N,BMP,LOADTEX_ALPHAMAP);
		chdir("..\\..");

		
		firstInit=false;
	}
	mainGM.getThemeTune()->play();
	mainGM.getCam()->pos[0]=0;
	mainGM.getCam()->pos[1]=20;
	mainGM.getCam()->pos[2]=0;
	mainGM.getCam()->rot[0]=5;
	mainGM.getCam()->rot[1]=170;
	mainGM.getCam()->radius=600;
	timer=0;
	bright=-1;
	mouse.hideCursor();
}

void Intro::slideEvent(int slideNo, 
					   float begin, 
					   float middle, 
					   float end, 
					   float sustain, 
					   float startBright, 
					   float midBright, 
					   float endBright)
{
	if (timer<begin || timer>end) return;
	float b=getEventBrightness(begin,middle,end,sustain,startBright,midBright,endBright);
	slideshow[slideNo]->bind();
	showSlide(b);
}

void Intro::fadeEvent(float begin, 
					  float middle, 
					  float end, 
					  float sustain,
					  float startBright, 
					  float midBright, 
					  float endBright)
{
	if (timer<begin || timer>end) return;
	bright=getEventBrightness(begin,middle,end,sustain,startBright,midBright,endBright);
}

float Intro::getEventBrightness(float begin, 
								float middle, 
								float end, 
								float sustain,
								float startBright, 
								float midBright, 
								float endBright)
{
	float rTime=timer-begin;
	float rMid=middle-begin;
	float rEnd=end-begin;
	float u;


	if (rTime<rMid)
	{
		//go from startbright to midbright
		u=rTime/rMid;
		return u*midBright+(1.0-u)*startBright;
	}
	else
	{
		if (rTime-rMid<sustain)
		{
			return midBright;
		}
		else
		{
			float endSus=rMid+sustain;
			u=(rTime-endSus)/(rEnd-endSus);
			return u*endBright+(1.0-u)*midBright;
		}
	}
}
