/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// Land.cpp: implementation of the Land class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Land.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLand::CLand()
{
	setScale(6.25,0.235294117);
}

CLand::~CLand()
{
}

void CLand::loadSeabedTex(char * filename)
{
	CImage mapImage;
	mapImage.loadBMP(filename);
	seabedTex=loadTexFromImage(mapImage,TF_LML,TF_LML);
}

void CLand::loadLightmap(char * filename)
{
	lightmap.loadImage(filename);
}

void CLand::addLightMapLightImg(char * filename)
{
	lightmap.loadNewLightImage(filename);
}

void CLand::addBaseTexAlphaLight(char * colourfn,char * alphafn)
{
	CImage image;
	CImage alpha;

	image.loadBMP(colourfn);
	alpha.loadBMP(alphafn);
	image.addAlphaChannel(alpha);

	image.RGBAToARGB(); //convert to ARGB

	baseTex.addNewLightImage(image);
}

void CLand::draw()
{
	/*
	BYTE img[100]=
	{
		0,20,40,60,80,100,80,60,100,40,20,
		0,20,40,60,80,100,80,60,100,40,20,
		0,20,40,60,80,100,80,60,100,40,20,
		0,20,40,60,80,100,80,60,100,40,20,
		0,20,40,60,80,100,80,60,100,40,20,
		0,20,40,60,80,100,80,60,100,40,20,
		0,20,40,60,80,100,80,60,100,40,20,
		0,20,40,60,80,100,80,60,100,40,20,
		0,20,40,60,80,100,80,60,100,40,20,
		0
	};
	*/
 	array->multiTexture=true;
	glPushAttrib(GL_ENABLE_BIT);
	glDisable(GL_LIGHTING);

	
	setTexChannel(1); 
	lightmap.bind();

	setTextureLevel(GL_TEXTURE_2D);
	setTexChannel(0); 
	setTextureLevel(GL_TEXTURE_2D);

	drawHM();

	setTexChannel(1);
	setTextureLevel(0);

	setTexChannel(0);
	setTextureLevel(GL_TEXTURE_2D);

	//glEnable(GL_TEXTURE_2D);    


//		lightmap.clearLights();
	

	seabedTex->bind();
	glBegin(GL_QUADS); 
		glTexCoord2f(0,1);
		glVertex3f(-250,-1,250);

		glTexCoord2f(1,1);
		glVertex3f(250,-1,250);
		
		glTexCoord2f(1,0);
		glVertex3f(250,-1,-250);

		glTexCoord2f(0,0);
		glVertex3f(-250,-1,-250);
	glEnd();
	glPopAttrib(); 


//	glEnable(GL_TEXTURE_2D);


}



void CLand::clearLights()
{
	lightmap.clearLights();
	baseTex.clearLights();
}

int CLand::drawQuicksand(float x,float y,float z,int imgNo)
{
	float xi=((x/400.0)+0.5)*256.0;
	float yi=(0.5-(z/400.0))*256.0;

	if (xi>238 || yi>238 || xi<33 || yi<33) return -1;

	int lightno=baseTex.drawLight((int)xi,(int)yi,imgNo,true);

	return lightno;
}

bool CLand::checkQuicksandPos(float x,float y,float z)
{
	float xi=((x/400.0)+0.5)*256.0;
	float yi=(0.5-(z/400.0))*256.0;

	if (xi>238 || yi>238 || xi<33 || yi<33) return false;
	return true;
}

/*
void CLand::clearQuicksand(int id, CImage * backupImg)
{
	baseTex.clearLight(id,backupImg);
}*/

int CLand::drawLight(float x,float y,float z,float bright)
{
	float xi=((x/400.0)+0.5)*512.0;
	float yi=(0.5-(z/400.0))*512.0;

	if (xi>478 || yi>478 || xi<33 || yi<33) return -1;



	int lightLev=4-(bright*4);

	if (lightLev<0) lightLev=0;



	int lightno=lightmap.drawLight((int)xi,(int)yi,lightLev);
	return lightno;

}

void CLand::loadBaseTex(char * filename)
{
	baseTex.loadImage(filename);
	tex=baseTex.tex;
}