// Land.h: interface for the Land class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LAND_H__E29A078E_A5F4_4703_A972_6C55CBC2F748__INCLUDED_)
#define AFX_LAND_H__E29A078E_A5F4_4703_A972_6C55CBC2F748__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "heightmap.h"
#include "ArtLight.h"

class CLand : public CHeightmap  
{
public:
	CLand();
	virtual ~CLand();
	void draw();
	void loadSeabedTex(char * filename);
	void loadLightmap(char * filename);
	void loadBaseTex(char * filename);
	void addLightMapLightImg(char * filename);
	void addBaseTexAlphaLight(char * colourfn,char * alphafn);

	DynTexture * getLightmap(){return &lightmap;}
	DynTexture * getBaseTex(){return &baseTex;}
	void clearLights();
	int drawQuicksand(float x,float y,float z,int imgNo);
	bool checkQuicksandPos(float x,float y,float z);
	//void clearQuicksand(int id,CImage * backupImg);

	int drawLight(float x,float y,float z,float bright);
	void addQuicksand();

private:

	CTexture * seabedTex;
	DynTexture lightmap;
	DynTexture baseTex;
};

#endif // !defined(AFX_LAND_H__E29A078E_A5F4_4703_A972_6C55CBC2F748__INCLUDED_)
