/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// Light.cpp: implementation of the Light class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Light.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Light::Light()
{
	pos[3]=1; //positional
	GLlite=GL_LIGHT1;
	enabled=false;
}

Light::~Light()
{

}

void Light::setParamf(unsigned int name, float param)
{
	glLightf(GLlite,name,param);
}

void Light::setParamfv(unsigned int name, float * param)
{
	glLightfv(GLlite,name,param);
}

void Light::specify()
{
	glLightfv(GLlite, GL_POSITION, pos);
}

void Light::enable()
{
	glEnable(GLlite);
	enabled=true;
}

void Light::disable()
{
	glDisable(GLlite);
	enabled=false;
}
 
void Light::setPos(float pos_in[3])
{
	pos[0]=pos_in[0];
	pos[1]=pos_in[1];
	pos[2]=pos_in[2];
}

void Light::setColour(float red, float green, float blue)
{
	colour[0]=red;
	colour[1]=green;
	colour[2]=blue;
	colour[4]=1;

	float white[4]={1,1,1,1};
	float black[4]={0,0,0,1};
	float redc[4]={1,0,0,0};

	glLightfv(GLlite, GL_AMBIENT, black);
	glLightfv(GLlite, GL_DIFFUSE, colour);
	glLightfv(GLlite, GL_SPECULAR, colour);

	glLightf(GLlite, GL_QUADRATIC_ATTENUATION, 0.0005);
}

void Light::setGLLight(unsigned int GLlite_in)
{
	GLlite=GLlite_in;
}
