/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// LightManager.cpp: implementation of the LightManager class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "LightManager.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

LightManager::LightManager()
{
	numLights=0;

	for (int a=0;a<MAX_LIGHTS;++a)
	{
		lights[a].setGLLight(GL_LIGHT1+a);
	}
}

LightManager::~LightManager()
{
}

void LightManager::specifyAll()
{
	//lights[0].specify();
	
	for (int a=0;a<MAX_LIGHTS;++a)
	{
		if (lights[a].enabled)
		{
			lights[a].specify();
		}
	}
}

Light *LightManager::createLight(float pos[3], float red, float green, float blue)
{
	for (int a=0;a<MAX_LIGHTS;++a)
	{
		if (!lights[a].enabled)
		{
			lights[a].enable();
			lights[a].setPos(pos);
			lights[a].setColour(red,green,blue);

			return &lights[a];
		}
	}

	//there are no lights free, so steal one
	return &lights[random(MAX_LIGHTS)];
}


void LightManager::destroyLight(Light * lite)
{
	for (int a=0;a<MAX_LIGHTS;++a)
	{
		if (lights[a].enabled && lite==&lights[a])
		{
			lights[a].disable();

			break;
		}
	}
}
