/*
Mesh.h

Version 2.0g

(c)2001 Ben Woodhouse


Game version. 

*/


#ifndef MeshH
#define MeshH

#include <stdio.h>
//#include "stdafx.h"

#include <string>  
#ifndef BYTE
#define BYTE unsigned char
#endif
//#include "matrix.h"




#define B3DVER "2.0"




struct SimpleTri
{
	int ver[3];
};

struct CVertex
{
	float pos[3];
};

struct CTriangle
{
	int ver[3];
	float verNorm[3][3];
	float texCoord[3][2];
};


struct CSubMesh
{
    CSubMesh()
    {
        tri=NULL;
        numTris=0;
        texNum=-1;

    }
    ~CSubMesh()
    {
        if (tri!=NULL)
            delete [] tri;
    }
	CTriangle * tri;
	int numTris;
    int texNum; //refers to texture within B3D
};


class B3D;

class Mesh
{
	public:
		Mesh()
        {
            //	tex=NULL;
            drawb=true;
            numVers=0;
            ver=NULL;
            sub=NULL;
            numSubs=0;
            color[0]=1;
            color[1]=1;
            color[2]=1;
            sprintf(name,"Untitled");
				parentB3D=NULL;
        }
		~Mesh()
        {
            if (ver!=NULL)  delete [] ver;
            if (sub!=NULL)  delete [] sub;
        } 
        virtual bool writeToStream(FILE * str);
        virtual bool readFromStream(FILE * str);

		void setLowestColourComponent(float amt);

		//only specify altframever for animation frames
		virtual void draw(); 
		SimpleTri * getSimpleTris();
		int getNumTris();

		int getNumVers(){return numVers;}


		CVertex * ver;
		CSubMesh * sub;

	//	CTexture * tex;

		 bool drawb;

		//will not feature in game version, but will be stored
      char name[50];
		int numVers;
      int numSubs;
		B3D * parentB3D;

		float color[3];

		bool doubleSided;

};




#endif
