/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// Mouse.cpp: implementation of the Mouse class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Mouse.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Mouse::Mouse()
{
	posx=0;
	posy=0;
	lButtonClicked=false;
	rButtonClicked=false;
	lButtonDown=false;
	rButtonDown=false;
	lButtonReleased=false;
	rButtonReleased=false;
	mButtonDown=false;
	mButtonReleased=false;
	mButtonClicked=false;

	mouseWheelDir=0;
}

Mouse::~Mouse()
{

}

void Mouse::setCursorType(int cType)
{
	if (cursorType==MOUSE_WIN) ShowCursor(FALSE);
	else ShowCursor(TRUE);

	cursorType=cType;

}

void Mouse::showCursor()
{
	if (cursorType==MOUSE_WIN)	ShowCursor(TRUE);
	cursorVisible=true;
}

void Mouse::hideCursor()
{
	if (cursorType==MOUSE_WIN) ShowCursor(FALSE);
	cursorVisible=false;
}

void Mouse::update()
{
	lButtonClicked=false;
	rButtonClicked=false;

	lButtonReleased=false;
	rButtonReleased=false;

	mButtonReleased=false;
	mButtonClicked=false;

	mouseWheelDir=0;

	POINT point;

	GetCursorPos(&point);

	posx=point.x;
	posy=479.0-point.y;
}

bool Mouse::loadGLCursor(char * filename)
{
	glTex=loadNewTexture(filename,TF_N,TF_N,BMP);
	setCursorType(MOUSE_GL);

	return true;
}

void Mouse::display()
{
	if (cursorVisible)
	{
		glEnable(GL_BLEND);
		glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_COLOR);
		glTex->bind();
		glColor4f(1,1,1,1);

		screen.push2D();
		glBegin(GL_QUADS);
			glTexCoord2f(0,0);
			glVertex2i(posx-16,posy-16);

			glTexCoord2f(1,0);
			glVertex2i(posx+16,posy-16);

			glTexCoord2f(1,1);
			glVertex2i(posx+16,posy+16);

			glTexCoord2f(0,1);
			glVertex2i(posx-16,posy+16);
		glEnd();
		screen.pop2D();
		glDisable(GL_BLEND);
	}
	/*
	glCls();
	glPrintf("Pos = (%d, %d)\n",posx,posy);
	if (lButtonDown) glPrintf("LBUTTONDOWN\n");
	if (lButtonClicked) glPrintf("LBUTTONCLICKED\n");
	if (rButtonDown) glPrintf("RBUTTONDOWN\n");
	if (rButtonClicked) glPrintf("RBUTTONCLICKED\n");
	*/
}