// Mouse.h: interface for the Mouse class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MOUSE_H__45026241_8B3C_49B3_86A9_4CE477EC3FF8__INCLUDED_)
#define AFX_MOUSE_H__45026241_8B3C_49B3_86A9_4CE477EC3FF8__INCLUDED_

#define MOUSE_WIN 0 
#define MOUSE_GL 1

class Mouse  
{
public:
	Mouse();
	virtual ~Mouse();

	bool loadGLCursor(char * filename);
	void setCursorType(int cType);

	void hideCursor();
	void showCursor();
	int getX(){return posx;}
	int getY(){return posy;}
	bool getLButtonClicked(){return lButtonClicked;}
	bool getLButtonDown(){return lButtonDown;}
	bool getLButtonReleased(){return lButtonReleased;}

	bool getRButtonClicked(){return rButtonClicked;}
	bool getRButtonDown(){return rButtonDown;}
	bool getRButtonReleased(){return rButtonReleased;}

	bool getMButtonClicked(){return mButtonClicked;}
	bool getMButtonDown(){return mButtonDown;}
	bool getMButtonReleased(){return mButtonReleased;}
	
	int getMouseWheelDir(){return mouseWheelDir;}


	void setPos(int x,int y)
	{
		SetCursorPos(x,479-y);
		posx=x;
		posy=y;
	}

	//called from WinProc
	void setLButtonDown()
	{
		lButtonDown=true;
		lButtonClicked=true;
	}
	void setLButtonUp()
	{
		lButtonDown=false;
		lButtonReleased=true;
	}
	void setRButtonDown()
	{
		rButtonDown=true;
		rButtonClicked=true;
	}
	void setRButtonUp()
	{
		rButtonDown=false;
		rButtonReleased=true;
	}
	void setMButtonUp()
	{
		mButtonDown=false;
		mButtonReleased=true;
	}
	void setMButtonDown()
	{
		mButtonDown=true;
		mButtonClicked=true;
	}
	void setMouseWheel(int dir)
	{
		mouseWheelDir=dir;
	}
	void update(); //must be called after everything else in render loop
	void display();


private:
	int posx,posy;
	bool lButtonDown;
	bool lButtonClicked;
	bool lButtonReleased;
	bool rButtonDown;
	bool rButtonClicked;
	bool rButtonReleased;
	bool mButtonDown;
	bool mButtonClicked;
	bool mButtonReleased;

	int mouseWheelDir;
	int cursorType;
	bool cursorVisible;
	CTexture * glTex;
};

#endif // !defined(AFX_MOUSE_H__45026241_8B3C_49B3_86A9_4CE477EC3FF8__INCLUDED_)
