// NetPlayer.h: interface for the NetPlayer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NETPLAYER_H__07766427_7BD9_44CA_A8CC_28A394F86363__INCLUDED_)
#define AFX_NETPLAYER_H__07766427_7BD9_44CA_A8CC_28A394F86363__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "WDPlayer.h"

#define CMD_GAMESTATE 2

#define NETPLAYER_MAX_TARGETS 16;

struct SpellTarget
{
	SpellTarget()
	{

	}
	SpellTarget(const SpellTarget &src)
	{
		copyFrom(src);
	}
	const SpellTarget &operator=(const SpellTarget& src)
	{
		copyFrom(src);
		return *this;
	}
	void copyFrom(const SpellTarget& src)
	{
		memcpy((void *)this,&src,sizeof(SpellTarget));
	}
	float pos[3];
	int spellType;
};


struct CmdGameState
{
	CmdGameState()
	{
		type=CMD_GAMESTATE;
		id=0;
		time=0;
		yrot=0;
		for (int a=0;a<3;++a)
		{
			pos[a]=0;
			vel[a]=0;
			tPos[a]=0;
		}
		health=1;
		walk=false;
		drown=false;
		cast=false;
		died=false;
	}
	const CmdGameState & operator= (const CmdGameState &src)
	{
		copyFrom(src);
		return *this;
	}
	void copyFrom(const CmdGameState & src)
	{
		memcpy((void *)this,&src,sizeof(CmdGameState));
	}
	void resetFlags()
	{
		//walk=false;
		drown=false;
		cast=false;
		died=false;
	}
	int type;
	int id;
	unsigned time;

	//wizard
	float pos[3];
	float vel[3];
	float yrot;
	float health;



	//actions
	bool walk;
	bool drown; //if sinking in quicksand
	bool cast;
	bool died;
	SpellTarget spellTarget;
//	int spellSelect;
//	float spellTarget[3];

	//tornado
	float tPos[3];
};



class NetPlayer : public WDPlayer  
{
public:
	NetPlayer();
	virtual ~NetPlayer();
	int getType(){return PLAYER_NET;}
	void doStuff();
	void recvState(CmdGameState * state_in);
	void addTarget(SpellTarget &target);

protected:
	std::list<SpellTarget> spellTargets;
	CmdGameState state;
	bool justDied;
};

#endif // !defined(AFX_NETPLAYER_H__07766427_7BD9_44CA_A8CC_28A394F86363__INCLUDED_)
