// NetServer.cpp: implementation of the NetServer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#include "NetServer.h"
#include "GameNetwork.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

void NetServer::init(SOCKET * pClientSock)
{
	WSAPROTOCOL_INFO pinf[100];
	unsigned long psize=sizeof(pinf);
	char pm[1000]="";
//	char numStr[50];
	int numps;


	numps=WSAEnumProtocols (
		NULL,                   
		pinf,  
		&psize);

	

	/*font.setSize(15,15);
	
	glPrintf("%d protocols found\n",numps);
	char numStr[1024];

	for (int a=0;a<numps;++a)
	{
		sprintf(numStr,"%d : (a: %d  t: %d  p: %d)"
					,a,
					pinf[a].iAddressFamily,
					pinf[a].iSocketType, 
					pinf[a].iProtocol);
		glPrintf("%s",numStr);
		glPrintf("%s",pinf[a].szProtocol);

//		if (pinf[a].dwProviderFlags & PFL_MATCHES_PROTOCOL_ZERO)
//		{
//			strcat(pm," zero");
//		}
		glPrintf("%s","\n");
	}
//	messageBox("protocols:\n %s",pm);


*/

/*
	sock = socket (AF_INET,SOCK_STREAM,0); //  listening socket

	//setsockopt() - TCP_NODELAY
	char fal=1;
	setsockopt(sock,IPPROTO_TCP,TCP_NODELAY,&fal,1); 



	//messageBox("CNetwork Constructor");
	WSAAsyncSelect (sock, ghWnd, WM_NWSERVER, (FD_CONNECT | FD_READ | FD_WRITE | FD_ACCEPT));

	::client.sock = socket (AF_INET,SOCK_STREAM,0); // create socket

	setsockopt(::client.sock,IPPROTO_TCP,TCP_NODELAY,&fal,1);

	waitForClients();

	
	//the server's client sock
	if (WSAAsyncSelect (::client.sock, ghWnd, WM_NWCLIENT, 
		(FD_WRITE | FD_CONNECT | FD_READ | FD_CLOSE))==SOCKET_ERROR)
	{
		messageBox("Error creating server's client socket");
		translateError();
	}
	

//	connectSelf(pClientSock);
	::client.connect();
*/
	//accept the connection to myself
	startMulticastIP();
//	::client.startMulticastIP();


	
	networkp=this;
}

int NetServer::connectSelf(SOCKET * pClientSock)
{
	
	int rv;
	fd_set conn;
	sockaddr_in target;
//	int numConnections;

	timeval timeout;


	timeout.tv_sec=1; // Set the timeout to 0 for Non Blocking
	timeout.tv_usec=0;

	FD_ZERO(&conn); // Set the data in conn to nothing
	FD_SET(sock, &conn); // Tell it to get the data from the Listening Socket

	target.sin_family = AF_INET;           // address family Internet
	target.sin_port = htons (5001);        // set servers port number

	target.sin_addr.s_addr = inet_addr ("127.0.0.1");  // connect to self through loopback

	rv=::connect(::client.sock, (LPSOCKADDR)&target, sizeof(target));

	return rv;
/*
	
	int rv;
	sockaddr_in target;

	target.sin_family = AF_INET;           // address family Internet
	target.sin_port = htons (5001);        // set servers port number
	target.sin_addr.s_addr = inet_addr ("192.168.0.1");  // set servers IP

	rv=::connect(::client.sock, (LPSOCKADDR)&target, sizeof(target));
	glPrintf("connected to self");
	return rv;*/
}




NetServer::NetServer()
{
	open=true;
}

bool NetServer::waitForClients()
{
	//the server is the network object

	if (!bindSocket(5001))
	{
		messageBox("ERROR: Failed to bind socket");
		return false;

	}

	// WSAStartup () has been called
	// SOCKET s is valid
	// s has been bound to a port using sockaddr_in sock
	if (listen(sock,1)==SOCKET_ERROR)
	{ // error!  unable to listen
		messageBox("Error opening listening socket");
		Quit=1;
		WSACleanup ();
		return false;
	}
	return true;

	// listening

}


bool NetServer::bindSocket(u_short port)
{
	sockaddr_in addr; // the address structure for a TCP socket

	addr.sin_family = AF_INET;      // Address family Internet
	addr.sin_port = htons (port);   // Assign port 5001 to this socket
	addr.sin_addr.s_addr = htonl (INADDR_ANY);   // No destination
	if (bind(sock, (LPSOCKADDR)&addr, sizeof(addr)) == SOCKET_ERROR)
	{ // error
	  WSACleanup ();  // unload WinSock
	  return false;         // quit
	}

	return true;
}



bool NetServer::acceptConnection()
{
	// WSAStartup () has been called
	// SOCKET s is valid
	// s has been bound to a port using sockaddr_in sock
	// s is listening
	int addr_size;
	int numConnections=0;
//	fd_set conn;

	timeval timeout;


	timeout.tv_sec=0; // Set the timeout to 0 for Non Blocking
	timeout.tv_usec=0;

	glPrintf("Waiting for connections. Press escape to cancel",numConnections);

	/*
	//wait for a connection request
	while (numConnections==0)
	{

		FD_ZERO(&conn); // Set the data in conn to nothing
		FD_SET(sock, &conn); // Tell it to get the data from the Listening Socket

		numConnections = select(0, &conn, NULL, NULL, &timeout);
		if (numConnections==SOCKET_ERROR)
		{
			translateError();
			return false;
		}

		(void)DI_keysin();
		if (keyJustPressed(DIK_ESCAPE)) break; 
	}

	if (numConnections==0) return false;
*/
//	messageBox("connections %d",numConnections);
 
	//if we have a connection request, accept it
//	while (1)
//	{
		for (int a=0;a<NW_MAXCLIENTS;++a)
		{
			if (client[a].inuse==false)
			{
				addr_size=sizeof(client->sockaddr);

				client[a].sock =  // accept a connection
					accept (sock,(struct sockaddr *)&client[a].sockaddr,&addr_size);

				if (client[a].sock == INVALID_SOCKET)
				{ // error accepting connection
				//	translateError();
					//break;
					return false;
				}
				client[a].inuse=true;
				glPrintf("connection %d accepted",a);
				break;
			}

		}
//		(void)DI_keysin();
//		if (keyJustPressed(DIK_ESCAPE)) return false; 
//	}


	/*
	client[a] =  // accept a connection
		accept (sock,&client_sock[a],&addr_size);

	if (client[a] == INVALID_SOCKET)
	{ // error accepting connection
//		WSACleanup ();
		return false;
	}
	else
	{ 
		//client connected successfully
	}
	*/
	return true;

}

//handles messages for listen socket and client sockets
void NetServer::handleMsg(WPARAM wParam, LPARAM lParam)
{
	
	int a;
//	int r;
	bool debug=false;
	int playerNum;
//	char buf[300];
	int cmd;
	int er;
	cmd=0;
//	int len;
//	int chatTo;

	if (WSAGETSELECTERROR(lParam))
	{
		//messageBox("random error");
		//translateError(lParam);
		glPrintf("random error");
	}

	switch (WSAGETSELECTEVENT(lParam))
	{
		case FD_READ:
			readCommand(wParam);
//				
//			}

//			c.print();			
		break;
		
		case FD_CLOSE:
		break;

		case FD_WRITE:
		break;
	}
/*
		//listening socket only (hopefully)
		case FD_ACCEPT:*/
			/*
			// holds size of client struct
			int lenclient = sizeof(client[0].sockaddr);
			if (open)
			{
				// find a free client slot and connect it
				for (a=0;a<NW_MAXCLIENTS;++a)
				{
					if (client[a].inuse==false)
					{
						client[a].sock=
							accept(sock, (struct sockaddr *)&client[a].sockaddr, &lenclient);

						if (client[a].sock==SOCKET_ERROR)
						{
							translateError();
							return;
						}

						

						//send the player his ID
						cmd_setID(client[a].sock,a);

//						c.send(client[a].sock);

						//send all clients the new client's ID
						//send the client his ID
//						c.set(SETID,a+1,0,0,0);
//						c.send(client[a].sock);

						//send the client the server player
						c.set(CREATENEWPLAYER,0,mainGM.player[0].pos[0],
														mainGM.player[0].pos[1],
														mainGM.player[0].pos[2]);

//						mainGM.player[0].send(client[a].sock,true);

//						c.print();
//						c.send(client[a].sock);
						client[a].inuse=true;

						
						break;
					}
				}
			
				// check for an error
				//				if (!WSAGETSELECTERROR(lParam))

				glPrintf("Connection request received... accepted at slot %d\n",a);
			}
			else 
			{
				glPrintf("Connection request denied. Server is closed to new connections");
			}

		break;
	}
	if (er==SOCKET_ERROR)
	{
		glPrintf("error");
//		translateError();
	}

}

*/
}
void NetServer::startMulticastIP()
{
	ipBroadcastSock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);

/*	
	char hostAdd[20];
	getHostAddress(hostAdrs);
    u_long host_addr = inet_addr(hostAdd);   // local IP addr
    u_long net_mask = inet_addr("255.255.224.0");   // LAN netmask
    u_long net_addr = host_addr & net_mask;         // 172.16.64.0
    u_long dir_bcast_addr = net_addr | (~net_mask); // 172.16.95.255


	SOCKADDR_IN addrLocal;

	if(SOCKET_ERROR == bind(ipBroadcastSock, (LPSOCKADDR)&addrLocal, 
							sizeof(struct sockaddr)))
	{
		glPrintf("Problem\n");
	}
	glPrintf("Broadcast socket bound\n");

	nRet = setsockopt(hSock, SOL_SOCKET, SO_BROADCAST,
						(LPSTR)&bBroadcast, sizeof(BOOL));
*/
	SOCKADDR_IN addrLocal;

	addrLocal.sin_family = AF_INET;
	char addr[14];
	getHostAddress(addr);
	glPrintf("using local IP %s",addr);
	addrLocal.sin_addr.s_addr = INADDR_ANY;
	addrLocal.sin_port = htons(4567); 
	if(SOCKET_ERROR == bind(ipBroadcastSock, (LPSOCKADDR)&addrLocal, 
							sizeof(struct sockaddr)))
	{
		glPrintf("Problem\n");
	}
	glPrintf("Broadcast socket bound\n");

	mreq.imr_multiaddr.s_addr = inet_addr("234.5.6.7");
	mreq.imr_interface.s_addr = INADDR_ANY;
	int nRet = setsockopt(ipBroadcastSock, IPPROTO_IP, IP_ADD_MEMBERSHIP,
					  (char*)&mreq, sizeof(mreq));

	if (SOCKET_ERROR==nRet)
	{
		glPrintf("error with broadcast\n");
	}

	TTL=32; 
	setsockopt(ipBroadcastSock, IPPROTO_IP, IP_MULTICAST_TTL,
			   (char *)&TTL, sizeof(TTL));

	if (SOCKET_ERROR==(WSAAsyncSelect (ipBroadcastSock, ghWnd, WM_NWSERVERMULTICAST, 
		(FD_READ | FD_WRITE))))
	{
		glPrintf("error with WSAAsyncSelect");
	}
	else
	{
		glPrintf("WSAAsyncSelect OK");
	}

	addrDest.sin_family = AF_INET;
	addrDest.sin_addr.s_addr = inet_addr("234.5.6.7");
	addrDest.sin_port = htons(4567);

	char szHi[128]="blah";

	int er;
	if (SOCKET_ERROR==(er=sendto(ipBroadcastSock,szHi,5,0,(struct sockaddr*)&addrDest,
			sizeof(addrDest))))
	{
		glPrintf("send error:\n");
		translateError(er);
	}
	else
	{
		glPrintf("send successful");
	}
	font.setSize(20,20);
//	sendMulticastIP();
/*	
	if (SOCKET_ERROR==(er=sendto(ipBroadcastSock,szHi,5,0,(struct sockaddr*)&addrDest,
			sizeof(addrDest))))
	{
		glPrintf("send error:\n");
		translateError(er);
	}
*/
	//
	/*
struct in_addr {
        union {
                struct { u_char s_b1,s_b2,s_b3,s_b4; } S_un_b;
                struct { u_short s_w1,s_w2; } S_un_w;
                u_long S_addr;
        } S_un;*/
/* 	glPrintf("address is : %d %d %d %d\n",ipAddress.sin_addr.S_un.S_un_b.s_b1,
										ipAddress.sin_addr.S_un.S_un_b.s_b2,
										ipAddress.sin_addr.S_un.S_un_b.s_b3,
										ipAddress.sin_addr.S_un.S_un_b.s_b4);*/
	/*
	char ip[256];
	getHostAddress(ipOut);
	ipAddress.sin_addr=inet_addr(ip);


	getHostAddress(ip);
	*/
	
	/*
 	glPrintf("address is : %d %d %d %d\n",ipAddress.sin_addr.S_un.S_un_b.s_b1,
										ipAddress.sin_addr.S_un.S_un_b.s_b2,
										ipAddress.sin_addr.S_un.S_un_b.s_b3,
										ipAddress.sin_addr.S_un.S_un_b.s_b4);


*/
}


void NetServer::sendMulticastIP()
{
	/*
	setsockopt(ipBroadcastSock, IPPROTO_IP, IP_ADD_MEMBERSHIP,
					  (char*)&mreq, sizeof(mreq));

	
	setsockopt(ipBroadcastSock, IPPROTO_IP, IP_MULTICAST_TTL,
			   (char *)&TTL, sizeof(TTL));
	glPrintf("trying to send");
	char szHi[128]="blah";
	szHi[0]=random(32+32);
	int er;
	addrDest.sin_family = AF_INET;
	addrDest.sin_addr.s_addr = inet_addr("234.5.6.7");
	addrDest.sin_port = htons(4567);
	*/
	char szHi[128]="blah";
	szHi[0]=random(32+32);
	int er;
	if (SOCKET_ERROR==(er=sendto(ipBroadcastSock,szHi,5,0,(struct sockaddr*)&addrDest,
			sizeof(addrDest))))
	{
		glPrintf("send error:\n");
		translateError(er);
	}
	else glPrintf("must have worked\n");
}


void NetServer::endMulticastIP()
{
	ip_mreq mreq;
	mreq.imr_multiaddr.s_addr = inet_addr("234.5.6.7");
	mreq.imr_interface.s_addr = INADDR_ANY;
	setsockopt(ipBroadcastSock, IPPROTO_IP, IP_DROP_MEMBERSHIP,
					  (char*)&mreq, sizeof(mreq));

	closesocket(ipBroadcastSock);
}

void NetServer::handleMulticastMsg(WPARAM wParam,LPARAM lParam)
{
	glPrintf("server multicast msg\n");
}

/*
	//s = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);

ipBroadcastSock;
SOCKADDR_IN addrLocal;
// We want to use the Internet address family
addrLocal.sin_family = AF_INET;
// Use any local address
addrLocal.sin_addr.s_addr = INADDR_ANY;
// Use arbitrary port - but the same as on other clients/servers
addrLocal.sin_port = htons(uiPort); 
// Bind socket to our address
if(SOCKET_ERROR == bind(hUDPSocket, (LPSOCKADDR)&addrLocal, 
                        sizeof(struct sockaddr)))
  {cout << "Euston, we have a problem";}
// Ready to switch to multicasting mode
*/
