/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// OptionsMenu.cpp: implementation of the OptionsMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "OptionsMenu.h"
#include "Dauntless.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

OptionsMenu optionsMenu;

OptionsMenu::OptionsMenu()
{
	setTitle("Options");
	addItem("Sound`",MENU_SLIDER,&om_soundVol); 
	addItem("Music`",MENU_SLIDER,&om_musicVol);//music.getVolume()*6.0); 

	addItem("",MENU_DIVIDER); 
	addItem("Bright`",MENU_SLIDER,&om_brightness,3);//music.getVolume()*6.0); 
	addItem("",MENU_DIVIDER); 
	addItem("Invert mouse X",MENU_SWITCH,&om_mouseInvertx,0,"   no","   yes");
	addItem("Invert mouse Y",MENU_SWITCH,&om_mouseInverty,0,"   no","   yes");
	/*
	addItem(	"Single Player ",MENU_THING,&mm_singlePlayer); 
	addItem(	"Multiplayer   ",MENU_THING,&mm_multiplayer);

	addItem("Options           ",MENU_THING);
	//addItem("",MENU_DIVIDER); 
	addItem("Intro/Credits        ",MENU_THING);
	addItem("",MENU_DIVIDER); 
	addItem("QUIT",MENU_THING,&mm_quitPressed);
	*/
}

OptionsMenu::~OptionsMenu()
{

}

void OptionsMenu::postInit()
{
//	messageBox("%f",music.getVolume());
	item_p[0]->setValue(15*(sound_getVolume()-0.6));
	item_p[1]->setValue(6*music.getVolume());
}


void om_soundVol(int level)
{
	Sound sound;
	sound_setVolume(0.6+(float)level/15.0);
	mainGM.sounds[7]->getDuplicate(&sound);
	sound.play();
}

void om_musicVol(int level)
{
	music.setVolume((float)level/6.0);
}

void om_brightness(int level)
{
	
	screen.setBrightness((level-3.0)/6.0);
}

void om_mouseInvertx(int val)
{
	mainGM.setInvertMousex(val);
}

void om_mouseInverty(int val)
{
	mainGM.setInvertMousey(val);
}
