// Particle1.h: interface for the CParticle class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PARTICLE1_H__BB0FA02A_0F58_406F_A903_4ABEFEAC6C13__INCLUDED_)
#define AFX_PARTICLE1_H__BB0FA02A_0F58_406F_A903_4ABEFEAC6C13__INCLUDED_

#define PBLEND_LIGHT 0
#define PBLEND_DARK 1

#include <math.h>
struct Particle;

struct ParticleType
{
	virtual void generate(Particle * part){}
};


struct Particle
{
	Particle();
	Particle(const Particle & src);	
	Particle(	float posx, 
				float posy,
				float posz);

	~Particle();
	const Particle& operator=(const Particle& src);
	void copyFrom(const Particle &src);
	float getDistFromCam(const float camPos[3], const float camVect[3])
	{
		//return (float)fabs(camPos[0]-pos[0])+fabs(camPos[1]-pos[1])+fabs(camPos[2]-pos[2])-radius;
		return	(pos[0]-camPos[0])*camVect[0] + 
				(pos[1]-camPos[1])*camVect[1] + 
				(pos[2]-camPos[2])*camVect[2]-radius;
	}

	void draw();
	void move(float deltaT);

	bool gravity;
	bool drawb;
	bool doubleDraw;
	bool accelerateB;
	float vel[3]; 
	float acc[3];
	float pos[3];
	float life;
	float initLife;
	float decay;
	float mass;
	
	bool rotate;
	float rotateAngle;
	float rotateRadius;
	float rotateRadiusGrow;
	float rotateCenter[2];
	float rotateSpeed;

	float friction; 
	float radius;
	float grow;

	float colour[4];
	float distFromCam;
	int blendMode;
};

#endif // !defined(AFX_PARTICLE1_H__BB0FA02A_0F58_406F_A903_4ABEFEAC6C13__INCLUDED_)
