// ParticleExplosion.h: interface for the ParticleExplosion class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PARTICLEEXPLOSION_H__78B715D7_DF53_45E4_B46C_119A9AB92F79__INCLUDED_)
#define AFX_PARTICLEEXPLOSION_H__78B715D7_DF53_45E4_B46C_119A9AB92F79__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ParticleSystem.h"
#include "land.h"
#include "LightManager.h"

class ParticleExplosion : public ParticleSystem  
{
public:
	ParticleExplosion(	float x, 
						float y, 
						float z, 
						float psize,
						float eforce, 
						int numParts,
						CLand * land);
	ParticleExplosion(	float x, 
						float y, 
						float z, 
						float psize,
						float eforce, 
						int numParts,
						CLand * land,
						float colour[4],
						bool dark);
	~ParticleExplosion();

	void postMove();
	void preDraw();
	void start();

protected:
	CLand * landscape;
	float origin[3];
	Light * light;
	bool dark;
};

#endif // !defined(AFX_PARTICLEEXPLOSION_H__78B715D7_DF53_45E4_B46C_119A9AB92F79__INCLUDED_)
