// ParticleFire.h: interface for the ParticleFire class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PARTICLEFIRE_H__3E97EB09_183E_4D31_9EDE_22CC8DD9B65D__INCLUDED_)
#define AFX_PARTICLEFIRE_H__3E97EB09_183E_4D31_9EDE_22CC8DD9B65D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ParticleSystem.h"

class ParticleFire : public ParticleSystem  
{
public:
	ParticleFire(float x,float y,float z,float partsPerSec,bool rising);
	virtual ~ParticleFire();

	void postMove(); 
	void preDraw();
	void stop();
	bool isDead();
	void setPos(float pos_in[3]){pos[0]=pos_in[0];pos[1]=pos_in[1];pos[2]=pos_in[2];}
	float * getPos(){return pos;}
	void setExtinguishTime(double time);
	void setAcceleration(float acc){this->acc=acc;};


protected:
	float acc;
	float partsPerSec;
	float pos[3];
	float oldPos[3];
	bool active;
	float timeOffset;
	bool rising;

	float extinguishTimer;
	bool selfExtinguish;
};

#endif // !defined(AFX_PARTICLEFIRE_H__3E97EB09_183E_4D31_9EDE_22CC8DD9B65D__INCLUDED_)
