// ParticleManager.h: interface for the ParticleManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PARTICLEMANAGER_H__DD7AF99A_8C2E_4206_9894_94EBFD57C352__INCLUDED_)
#define AFX_PARTICLEMANAGER_H__DD7AF99A_8C2E_4206_9894_94EBFD57C352__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define MAX_PARTICLES 2048
#define MAX_PARTSYSTEMS 256

#include "ParticleSystem.h"

class ParticleManager  
{
public:
	ParticleManager();
	virtual ~ParticleManager();

	void reset();

	void setStandardTex(CTexture * standardTex){this->standardTex=standardTex;}

	void move();
	void draw(float camPos[3],float camNorm[3]);
	void sortParticles(float camPos[3], float camNorm[3]); //puts the order into partOrder


	void registerSystem(ParticleSystem * sys);
	CTexture * getStandardTex(){return standardTex;}
	Particle * createParticle();
	void destroyParticle(Particle * part);


	ParticleSystem * getSystem(int i){return particleSystems[i];}
	int particleCount;

protected:

	float partDist[MAX_PARTICLES];
	int partOrder[MAX_PARTICLES];
	Particle * particlep[MAX_PARTICLES];
	int lastBlendMode;

	int numParticles;
	//std::vector<ParticleSystem *> particleSystems;
	ParticleSystem * particleSystems [MAX_PARTSYSTEMS];
	
	int numSystems;

//	Particle particles[MAX_PARTICLES];

	CTexture * standardTex;

	RadixSort * radixSort;
};

extern ParticleManager gParticles;

#endif // !defined(AFX_PARTICLEMANAGER_H__DD7AF99A_8C2E_4206_9894_94EBFD57C352__INCLUDED_)
