/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// ParticleRain.cpp: implementation of the ParticleRain class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ParticleRain.h"
#include "ParticleManager.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ParticleRain::ParticleRain(float partsPerSec)
{
	allocate(2*partsPerSec+2);
	this->partsPerSec=partsPerSec;
	timeOffset=0;
	active=true;
	gParticles.registerSystem(this);


}

ParticleRain::~ParticleRain()
{
}

void ParticleRain::postMove()
{

	if (active)
	{
		Particle part;
		timeOffset=((double)speedmod/100.0)+timeOffset;
		int launchCount=timeOffset*partsPerSec;

		double launchInterval=1.0/partsPerSec;
		double currentTime=0;
		for (int a=0;a<launchCount;++a)
		{
			makeParticle(part);
			createParticle(part,currentTime);
			//part.radius*=0.7;
			//part.pos[1]+=part.radius*0.5;
			//createParticle(part,currentTime);


			//part.radius-=0.
			currentTime+=launchInterval;
		}
		timeOffset-=currentTime;

	}

	//kill parts below ground
	int numParts=numParticles;
	for (int a=0;a<numParts;++a)
	{
		if (particles[a].pos[1]<20) 
		{
			destroyParticle(a);
			--numParts;
		}
	}

//		glCls();
//		glPrintf("launchCount %d",0);
} 

void ParticleRain::makeParticle(Particle & part)
{
	part.gravity=false;
	//part.vel[0]=-0.1+random(10)*0.02; part.vel[1]=0.3-random(10)*0.002; part.vel[2]=-0.1+random(10)*0.02;
	part.vel[0]=0; part.vel[1]=0; part.vel[2]=0;
	part.acc[0]=0; part.acc[1]=-0.022; part.acc[2]=0;
	part.accelerateB=true;
	part.initLife=1;
	part.decay=0;
	part.friction=0;
	part.radius=0.7;
	part.grow=0;
	part.colour[0]=0.3; part.colour[1]=0.3; part.colour[2]=1;
	part.colour[3]=0.6;
	part.blendMode=PBLEND_DARK;
	//part.acc[1]=0.025/radius;

	part.pos[0]=random(400)-200;
	part.pos[1]=300.0;
	part.pos[2]=random(400)-200;
}


void ParticleRain::preDraw()
{
	
}

void ParticleRain::stop()
{
	active=false;
}

bool ParticleRain::isDead()
{
	if (!active && numParticles==0)
	{
		return true;
	}
	return false;
}
