/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// ParticleSystem.cpp: implementation of the CParticleSystem class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ParticleSystem.h"
#include "ParticleManager.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ParticleSystem::ParticleSystem()
{
	maxParticles=0;
	numParticles=0;
	exist=true;
	particles=NULL;
}

ParticleSystem::~ParticleSystem()
{
	gParticles.particleCount-=numParticles;
	if (particles!=NULL) 
	{
//		glPrintf("[%d] particles deleted\n",maxParticles);
		delete [] particles;
	}
}
/*
ParticleSystem::ParticleSystem(const ParticleSystem & src)
{
	copyFrom(src);
}*/
/*
ParticleSystem::setTex(CTexture * tex)
{
	this->tex=tex;
}*/

/*
const ParticleSystem& ParticleSystem::operator=(const ParticleSystem& src)
{
	copyFrom(src);
	return *this;
}
*/
/*
void ParticleSystem::copyFrom(const ParticleSystem &src)
{
	//particles.clear();
	numParticles=0;
	this->tex=src.tex;

	for (
	//PartIt it;

	//particles.assign(src.particles.begin(),src.particles.end());

}
*/

void ParticleSystem::move()
{
	//PartIt it;

//	for (it=particles.begin();it!=particles.end();++it)
	int numParts=numParticles;

	for (int a=0;a<numParts;++a)
	{
		particles[a].move(speedmod);
	}
	postMove();
}


void ParticleSystem::draw()
{

	preDraw();

	tex->bind();
//	glPrintf("%d particles to draw\n",particles.size());

//	for (it=particles.begin();it!=particles.end();++it)
	int numParts=numParticles;
	for (int a=0;a<numParts;++a)
	{
		particles[a].draw();
	}
}


int ParticleSystem::cullDeadParticles()
{
/*
	for (it=particles.begin();it!=particles.end();++it)
	{
		if (it->life<=0)
		{
			it=particles.erase(it);
		}
	}
	*/
	int numParts=numParticles;
	for (int a=0;a<numParts;++a)
	{
		if (particles[a].life<=0) 
		{
			destroyParticle(a);
			--numParts;
		}

	}
	return numParticles;
}


void ParticleSystem::createParticle(	Particle & part,
											float launchTime)
{
	//Particle p(ty,x,y,z); 
	/*
	if (launchTime>0)
	{
		part.move(launchTime);
	}*/

	if (numParticles<maxParticles)
	{
		particles[numParticles].copyFrom(part);
		++numParticles;
		++gParticles.particleCount;
	}
	//particles.push_back(part);

	//return particles.back();
}

/*
Particle * ParticleSystem::createParticle(ParticleType &ty,
									float x, 
									float y, 
									float z, 
									float launchTime)
{
	Particle p(ty,x,y,z); 
	if (launchTime>0)
	{
		p.move(launchTime*100);
	}
	particles.push_back(p);

	return &particles.back();
}*/

void ParticleSystem::destroyParticle(int index)
{
	//swap the last particle into the first particle's position in the array
	//--numParticles;
	
	if (index!=(numParticles-1))
	{
		particles[index].copyFrom(particles[numParticles-1]);
	}
//	particles.pop_back();
	--numParticles;
	--gParticles.particleCount;
}


bool ParticleSystem::isDead()
{
	if (numParticles==0) return true;
	return false;
}

void ParticleSystem::allocate(int maxParticles_in)
{
	maxParticles=maxParticles_in;
	
	particles=new Particle[maxParticles_in];
	//glPrintf("[%d][%d] particles created\n",maxParticles, maxParticles_in);

}

