/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// ParticleTornado.cpp: implementation of the ParticleTornado class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ParticleTornado.h"
#include "ParticleManager.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ParticleTornado::ParticleTornado(float x,float y,float z,float partsPerSec)
{
	allocate(partsPerSec*4+2);
	
	colour[0]=0.8; colour[1]=0.8; colour[2]=0.8; colour[3]=0.8;
	pos[0]=x;
	pos[1]=y;
	pos[2]=z;
	active=true;
	timeOffset=0;
	this->partsPerSec=partsPerSec;
	gParticles.registerSystem((ParticleSystem *)this);
	startAngle=0;
	
//	delete * this
}

ParticleTornado::~ParticleTornado()
{


}

void ParticleTornado::postMove()
{
	
	if (active)
	{
		Particle part;

		double smSec=speedmod/100.0;
		timeOffset=smSec+timeOffset;
		double launchInterval=1.0/partsPerSec;
		int launchCount=timeOffset/launchInterval;

		if (launchInterval<0.001) return;

		double currentTime=0;
		//Particle * p;
		for (int a=0;a<launchCount;++a)
		{
			makeParticle(part);
			part.pos[0]=oldPos[0]+(pos[0]-oldPos[0])*(currentTime/timeOffset);
			part.pos[1]=oldPos[1]+(pos[1]-oldPos[1])*(currentTime/timeOffset);
			part.pos[2]=oldPos[2]+(pos[2]-oldPos[2])*(currentTime/timeOffset);
		
			part.move((timeOffset-currentTime)*100.0);
			createParticle(part,0);
			
			currentTime+=launchInterval;
		}
		timeOffset-=currentTime;
		startAngle+=speedmod*3;

		oldPos[0]=pos[0];
		oldPos[1]=pos[1];
		oldPos[2]=pos[2];

	}
	

}

void ParticleTornado::makeParticle(Particle &part)
{
	part.gravity=false;
	part.vel[0]=-0.1+random(10)*0.02; part.vel[1]=0.24-random(10)*0.002; part.vel[2]=-0.1+random(10)*0.02;
	part.acc[0]=0; part.acc[1]=0; part.acc[2]=0;
	part.accelerateB=false;
	part.initLife=1;
	part.decay=0.005;
	part.friction=0;
	part.radius=2+random(5)*0.6;
	//part.radius=random(5)*0.5;
	part.grow=0.05;
//	part.colour[0]=0.8; part.colour[1]=0.8; part.colour[2]=0.8;
//	part.colour[3]=0.7;
	for (int a=0;a<4;++a)
	{
		part.colour[a]=colour[a];
	}
	part.blendMode=PBLEND_DARK;
	//part.acc[1]=0.025/radius;
	part.rotate=true;
	//part.rotateRadiusGrow=0.03+random(10)*0.002;
	part.rotateRadiusGrow=0.05;
	part.rotateAngle=startAngle;
	part.rotateCenter[0]=pos[0];
	part.rotateCenter[1]=pos[2];
	part.rotateSpeed=20;
	part.pos[0]=pos[0];
	part.pos[1]=pos[1];
	part.pos[2]=pos[2];
}

void ParticleTornado::preDraw()
{
}

void ParticleTornado::stop()
{
	active=false;
}

bool ParticleTornado::isDead()
{
	if (!active && numParticles==0)
	{
		return true;
	}
	return false;
}
