/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
#include "particleTypes.h"
#include "particle1.h"
#include "stdafx.h"

void PT_Smoke::generate(Particle * part)
{
	static float blah=0;

	part->gravity=false;
	part->vel[0]=0; part->vel[1]=0; part->vel[2]=0;
	part->acc[0]=0; part->acc[1]=0.1; part->acc[2]=0;
	part->accelerateB=true;
	part->initLife=1;
	part->decay=0.005;
	part->friction=0;
	part->radius=0.5+random(10)*0.1;
	part->grow=0.1;
	part->colour[0]=1; part->colour[1]=1; part->colour[2]=1;
	part->colour[3]=0.7;
	part->blendMode=PBLEND_DARK;
	part->acc[1]=0.025/radius;
	part->rotate=true;
	part->rotateRadiusGrow=0.05;
	part->rotateAngle=blah;
	blah+=speedmod*3;
	part->rotateCenter[0]=part->pos[0];
	part->rotateCenter[1]=part->pos[2];
	part->radius=2;
}

void PT_Fire::generate(Particle * part)
{
	part->gravity=false;
	
	part->vel[0]=random(10)*0.002-0.001; 
	part->vel[1]=0; 
	part->vel[2]=random(10)*0.002-0.001;

	part->acc[0]=0; part->acc[2]=0;
	part->accelerateB=true;
	part->initLife=1;
	part->life=1;
	part->decay=0.04;

	//part->decay=0.006;
	part->friction=0;
	part->radius=0.62+random(4)*0.2;
	//part->radius=1+random(4)*0.3;
	part->acc[1]=0.05/radius;

	part->doubleDraw=false;
	part->grow=0;
	part->colour[0]=1; part->colour[1]=0.5; part->colour[2]=0.1; part->colour[3]=1;
	part->blendMode=PBLEND_LIGHT;
	//part->colour[0]=0.1; part->colour[1]=0.1; part->colour[2]=0.5;
}


void PT_Sparks::generate(Particle * part)
{
	float flyAngle[3];
//	float flyLength;

	if (hemisphere)
	{
		flyAngle[0]=(float)-(random(90));
	}
	else
	{
		flyAngle[0]=(float)random(180)-90;
	}
	part->radius=1+random(10)*0.1;

	flyAngle[1]=(float)random(360);
	flyAngle[2]=0;

	part->mass=part->radius*part->radius;
	//anglesToCoord(flyAngle,eforce*0.2,part->acc);
	//anglesToCoord(flyAngle,eforce*0.4,part->acc);
	//part->acc[1]*=3.5;
	part->vel[0]=0; part->vel[1]=0; part->vel[2]=0; 
	anglesToCoord(flyAngle,eforce*0.4,part->vel);
	//part->acc[0]=0; part->acc[1]=0; part->acc[2]=0;

	part->acc[0]=part->vel[0]*0.08;
	part->acc[1]=part->vel[1]*0.08;
	part->acc[2]=part->vel[2]*0.08;
	part->vel[1]*=4;
	//part->acc[1]-=0.01;
	//part->acc[0]=0; part->acc[1]=0; part->acc[2]=0;


	part->gravity=true;
		
	part->accelerateB=true;
	part->initLife=1;
//	part->decay=0.0008+0.01/part->radius;
	part->decay=0.006+0.004/part->radius;
	part->friction=1.0-(part->radius)*0.03;
	//part->friction=0.01;
	//part->friction=0.00001;
	//if (part->friction<0.6) part->friction=0.6;
	//if (part->friction>0.95) part->friction=0.95;

	part->grow=0;

	part->colour[0]=1; 
	part->colour[1]=0.4;//-part->mass*0.01; 
	part->colour[2]=0.1;
	part->colour[3]=1;

	part->blendMode=PBLEND_LIGHT;

}


void PT_Static::generate(Particle * part)
{
	part->gravity=false;
	part->vel[0]=0; part->vel[1]=0; part->vel[2]=0;
	part->acc[0]=0; part->acc[1]=0; part->acc[2]=0;
	part->accelerateB=false;
	part->initLife=1;
	part->decay=0;
	part->friction=0;
	part->radius=1;
	part->grow=0;
	part->colour[0]=1; part->colour[1]=0.5; part->colour[2]=0.1;
	part->colour[3]=1;
	part->blendMode=PBLEND_LIGHT;

}



