/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// QuicksandSpell.cpp: implementation of the QuicksandSpell class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "QuicksandSpell.h"
#include "dauntless.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

QuicksandSpell::QuicksandSpell(float target[3], Wizard * caster, Wizard * enemy)
{
//	baseTexBackupImage.allocate(32,32,3);
	timer=0;
	pos[0]=target[0];
	pos[1]=target[1];
	pos[2]=target[2];

	wizards[0]=caster;
	wizards[1]=enemy;

	if (mainGM.getLand()->checkQuicksandPos(pos[0],pos[1],pos[2]))
	{
		mainGM.AIMessage(AIS_QUICKSAND,pos);
	}
	else
	{
		exist=false;
	}

	wizSinking[0]=false;
	wizSinking[1]=false;
	for (int a=0;a<2;++a)
	{
		mainGM.sounds[6]->getDuplicate(&sinkSound[a]);
	}
	float col[4]={0.6,0.6,0.2,0.5};
	ParticleExplosion * explosion=new ParticleExplosion(target[0],target[1],target[2],5,0.4,250,mainGM.getLand(),col,true);
	sinkSound[1].play();
}

void QuicksandSpell::doStuff()
{
	timer+=speedmod;
	int quicksandNo=0;
	if (timer<99)
	{
		quicksandNo=9-timer/10; //fade in
	}

	else if (timer>1900)
	{
		quicksandNo=(timer-1900)/10; //fade out
	}
	alphaID=mainGM.getLand()->drawQuicksand(pos[0],pos[1],pos[2],quicksandNo);
	if (alphaID!=-1)
	{
		mainGM.AIMessage(AIS_QUICKSAND,pos);
	}

	sinkWizards();
	if (timer>2000) exist=false;


}

QuicksandSpell::~QuicksandSpell()
{
	for (int a=0;a<2;++a)
	{
		sinkSound[a].stop();
	}
}

void QuicksandSpell::draw()
{
}


void QuicksandSpell::sinkWizards()
{
	float vect[3];
	float len;

	
	for (int a=0;a<2;++a)
	{
		vect[0]=wizards[a]->phys->pos[0]-pos[0];
		vect[1]=wizards[a]->getFeetY()-pos[1];
		vect[2]=wizards[a]->phys->pos[2]-pos[2];
		len=sqrt(vect[0]*vect[0]+vect[2]*vect[2]); //2d distance

		if (len<20) //sink the wizard
		{
			if (!wizSinking[a]) 
			{
				sinkSound[a].playRepeat();
				wizSinking[a]=true;
			}
			wizards[a]->sink(0.0027*speedmod);
		}
		else
		{
			if (wizSinking[a]==true)
			{
				sinkSound[a].stop();
			}
			wizSinking[a]=false;
		}
	}
}
