// Sea.h: interface for the CSea class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SEA_H__1FEB76F0_2373_4DEC_9B9C_894DC93ABB35__INCLUDED_)
#define AFX_SEA_H__1FEB76F0_2373_4DEC_9B9C_894DC93ABB35__INCLUDED_

#include "heightMap.h"
#include "skybox.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSea : public CHeightmap  
{
public:
	CSea(int res);
	virtual ~CSea();

	void draw();
	void doStuff(ViewFrustum &frustum);

	void doFrustumCull(ViewFrustum &frustum);
	void recalculateNormals();
	void animate();
	void setDepth(float depth_in);

//	void setDepthMap(BYTE ** landPoints, float landScale);
	void loadDepthMap(char * fileName);
	void loadSyncMap(char * fileName);
	void loadAlphaMap(char * fileName);
	void setDesiredDepth(float depth_in);
	void setWindFactor(float amt);
	void updateColSpheres();
	void setSky(CSkybox * sky){this->sky=sky;}
	void drawHeightmap();
	void setupVisSpheres();
	void clearScanLines();
	inline void normTableLookup(float a, float b, float c, float * normOut);



private:
	int bigSphereSquares;
	int lilSphereSquares;
	float desiredDepth;
	float depth;
	float timeTaken;
	float distanceToGo;
	float depthMap[82][82];
	float syncMap[82][82];
	float waveBeat;
	float windFactor;
	int scanLines[9][2];
	CSkybox * sky;
	BoundingSphere visSphere[3][3];
};

#endif // !defined(AFX_SEA_H__1FEB76F0_2373_4DEC_9B9C_894DC93ABB35__INCLUDED_)
