/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// SkyBox.cpp: implementation of the CSkyBox class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SkyBox.h"
 
CSkybox sky;
float CSkybox::cubeSize=NEARCLIP*2;


CSkybox::CSkybox()
{
	enabled=true;
}

CSkybox::~CSkybox()
{

}

void CSkybox::loadTextures(const char * fn)
{
	int a;
	int star;

	char newfn[512];

	if (extensions.exists("GL_EXT_texture_cube_map") && extensions.exists("GL_NV_texgen_reflection"))
	{
		cubemap=loadNewCubemap(fn,TF_L,TF_L);
		if (!cubemap->isEnabled())
			messageBox("error loading skybox");

		useCubemap=true;
	}
	
	else
	{
		strcpy(newfn,fn);

		//find which character is the *
		for (a=0;newfn[a]!=NULL;++a)
		{
			if (newfn[a]=='*') 
			{
				star=a;
				break;
			}
		}
		if (newfn[a]==NULL) 
		{
			messageBox("Skybox load error");
			return;
		}

		for (a=0;a<6;++a)
		{
			
			//tex[a]=starttex+a;
			newfn[star]=48+a;
			tex[a]=loadNewTexture(newfn,TF_L,TF_L);
			tex[a]->setParams(GL_CLAMP,GL_CLAMP,-1,-1,GL_DECAL);
		}
		useCubemap=false;
	}
}

void CSkybox::draw()
{

	float skyoff=0.005;
	//skybox shape (F = front, B = back)
	// #
	//#F#B
	// #
	glDisable(GL_LIGHTING);

 	glDisable(GL_DEPTH_TEST);
	glCullFace(GL_FRONT);


	glPushMatrix();
//		glRotatef(-currentVP->rot[0],1.0f,0.0f,0.0f);
		//glRotatef(-currentVP->rot[1],0.0f,1.0f,0.0f);
	/*gluLookAt(
					0,      
					0,           
					0,
					-currentVP->axis[2][0],   
					-currentVP->axis[2][1],   
					-currentVP->axis[2][2],   
					currentVP->axis[1][0],       
					currentVP->axis[1][1],       
					currentVP->axis[1][2]        
					);*/

		
		glLoadIdentity();
		//glLoadMatrixf(currentVP->getRotateMat());
		currentVP->rotateByRotMat();
		int a;

		float rot[6][4]={
						{90,0,1,0},
						{-90,0,1,0},
						{-90,1,0,0},
						{90,1,0,0},
						{0,0,1,0},
						{180,0,1,0}};
		
		if (useCubemap)
		{
			//setTextureLevel(GL_TEXTURE_CUBE_MAP_EXT);
			cubemap->bind();
	
			glBegin(GL_QUADS);
				//front
				cubeVertex(-1,-1,1);
				cubeVertex(1,-1,1);
				cubeVertex(1,1,1);
				cubeVertex(-1,1,1);
				
				//back
				cubeVertex(-1,1,-1);
				cubeVertex(1,1,-1);
				cubeVertex(1,-1,-1);
				cubeVertex(-1,-1,-1);

				//top
				cubeVertex(-1,1,-1);
				cubeVertex(-1,1,1);
				cubeVertex(1,1,1);
				cubeVertex(1,1,-1);

				//bottom
				cubeVertex(1,-1,-1);
				cubeVertex(1,-1,1);
				cubeVertex(-1,-1,1);
				cubeVertex(-1,-1,-1);

				//right
				cubeVertex(1,1,-1);
				cubeVertex(1,1,1);
				cubeVertex(1,-1,1);
				cubeVertex(1,-1,-1);

				//left
				cubeVertex(-1,-1,-1);
				cubeVertex(-1,-1,1);
				cubeVertex(-1,1,1);
				cubeVertex(-1,1,-1);

			glEnd();

//			setTextureLevel(GL_TEXTURE_2D);
			
			//glDisable(GL_TEXTURE_CUBE_MAP_EXT);
			//glEnable(GL_TEXTURE_2D);

			//cubemap->disable();
		}
		else
		{

			for (a=0;a<6;++a)
			{
				glPushMatrix();
					
					glRotatef(rot[a][0],rot[a][1],rot[a][2],rot[a][3]);
					glTranslatef(0,0,-cubeSize);

					tex[a]->bind();
					//glBindTexture(GL_TEXTURE_2D,texNum[tex[a]]);
					glBegin(GL_QUADS);

						glTexCoord2f(0,0);
						glVertex2i(cubeSize,-cubeSize);

						glTexCoord2f(1,0);
						glVertex2i(-cubeSize,-cubeSize);

						glTexCoord2f(1,1);
						glVertex2i(-cubeSize,cubeSize);

						glTexCoord2f(0,1);
						glVertex2i(cubeSize,cubeSize);  

					glEnd();
				glPopMatrix();
			}
		}


		setTextureLevel(GL_TEXTURE_2D);
						
	glPopMatrix();

	glCullFace(GL_BACK);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
}

void CSkybox::cubeVertex(float x, float y, float z)
{
	glTexCoord3f(-x,-y,-z);
	glVertex3f(cubeSize*x,cubeSize*y,cubeSize*z);

}


//*******************************
//END OF CLASS
//*******************************
