// SkyBox.h: interface for the CSkyBox class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(SKYBOX_H)
#define SKYBOX_H

class CSkybox
{
	public:
		//the filename of the textures with a '*' in place of the number
		CSkybox();
		~CSkybox();
		void loadTextures(const char * fn);
		void draw();

		bool isEnabled(){return enabled;}
		void enable(){enabled=true;}
		void disable(){enabled=false;}
		void cubeVertex(float x, float y, float z);
		CTexture * getCubemap(){return cubemap;}


		static float cubeSize;
		bool useCubemap;

	private:
		CTexture * tex[6];
		CTexture * cubemap;
		bool enabled;


};

extern CSkybox sky;

#endif 
