/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// SpellManager.cpp: implementation of the SpellManager class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SpellManager.h"
#include "TornadoSpell.h"
#include "FireballSpell.h"
#include "QuicksandSpell.h"
#include "FloodSpell.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


SpellManager::SpellManager()
{
	numSpells=0;
}

SpellManager::~SpellManager()
{
	clearSpells();
}

void SpellManager::reset()
{
	clearSpells();
}

void SpellManager::clearSpells()
{
	/*
	std::list<Spell *>::iterator it;
	Spell * spell;

	int count=0;
	it=spells.begin();
	while (it!=spells.end())
	{
		spell=*it;
	
		delete spell;
		++it;
		//it=spells.erase(it);
	}

	spells.clear();
	*/
	for (int a=0;a<numSpells;++a)
	{
		delete spells[a];
	}
	numSpells=0;
}


void SpellManager::registerSpell(Spell * spell)
{
	//spells.push_back(spell);
	if (numSpells<MAX_SPELLS)
	{
		spells[numSpells]=spell;
		++numSpells;
	}
	else
	{
		delete spell;
	}
	//glPrintf("numSpells %d",numSpells);
}


void SpellManager::doSpells()
{
	//std::list<Spell *>::iterator it;
//	Spell * spell;

	int count=0;
	/*
	it=spells.begin();
	while (it!=spells.end())
	{
		spell=*it;
		spell->doStuff();
		it++;
	}*/
	for (int a=0;a<numSpells;++a)
	{
		spells[a]->doStuff();
	}

	//clear dead spells
	/*
	it=spells.begin();
	while (it!=spells.end())
	{
		spell=*it;
		if (!spell->doesExist())
		{
			//delete spell;
			//spell->deleteSelf();
			//ell=NULL;
			it=spells.erase(it);
		}
		else
		{
			it++;
		}
	}*/
	for (a=0;a<numSpells;++a)
	{
		if (!spells[a]->doesExist())
		{
			delete spells[a];
			--numSpells;
			if (a!=numSpells)
			{
				//swap for endmost spell
				spells[a]=spells[numSpells];
			}
		}
	}
}


void SpellManager::drawSpells()
{
	/*
	std::list<Spell *>::iterator it;
	Spell * spell;

	int count=0;
	it=spells.begin();
	while (it!=spells.end())
	{
		spell=*it;
		spell->draw();

		++it;
	}*/
	for (int a=0;a<numSpells;++a)
	{
		spells[a]->draw();		
	}
}
