/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// Tune.cpp: implementation of the Tune class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Tune.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////





//TUNE
Tune::Tune()
{
	pSegment=NULL;
}

Tune::~Tune()
{
}

bool Tune::load(const char * fn)
{
	pSegment=music.loadNewMusic(fn);
	if (pSegment==NULL) return false;

	pSegment->SetRepeats(DMUS_SEG_REPEAT_INFINITE);

	return true;
}

bool Tune::play()
{

	if (pSegment!=NULL)
	{
		music.getPerformance()->PlaySegmentEx(
												pSegment,  
												NULL,    //song
												NULL,    // transitions. 
												DMUS_SEGF_SECONDARY,     // Flags.
												0,     // Start time; 0 is immediate.
												NULL,    // Pointer that receives segment state.
												NULL,    // Object to stop.
												NULL   // Audiopath, if not default.
											  );  
		pSegment->SetRepeats(DMUS_SEG_REPEAT_INFINITE);

	}
	return true;
}

bool Tune::stop()
{
	music.getPerformance()->StopEx(pSegment, 0,0);  
	return true;
}
