/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// UserPlayer.cpp: implementation of the UserPlayer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "UserPlayer.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

UserPlayer::UserPlayer()
{
	time=0;
//	wizAlive=true;
}

UserPlayer::~UserPlayer()
{

}

void UserPlayer::doStuff()
{
	input();
}

void UserPlayer::getCamToWizNorm(float camNorm[3])
{
	float camPos[3];
	screen.defaultVP.getCameraPos(camPos);
	for (int a=0;a<3;++a)
	{
		camNorm[a]=wiz->phys->pos[a]-camPos[a];
	}
	float l=lengthOf(camNorm);

	if (l>0.01) 
	{
		for (a=0;a<3;++a)
		{
			camNorm[a]/=l;
		}
	}

}
void UserPlayer::input()
{
	bool walk=false;
	float walkAngles[3];
	float walkAngle;
	float walkNorm[3]={0,0,0};
	float camNorm[3];
//	float camPos[3];

	//get the normal from the camera to the wizard
	getCamToWizNorm(camNorm);

	if (mouse.getLButtonClicked())
	{
		double sx,sy,sz;

		//draw a sphere around the enemy to make him easier to hit
		glPushMatrix();
			glTranslatef(	wiz->getEnemy()->phys->pos[0],
							wiz->getEnemy()->phys->pos[1],
							wiz->getEnemy()->phys->pos[2]);
			drawSphere(5,5,5);
		glPopMatrix();

		currentVP->setViewMatrix();
		currentVP->unproject(mouse.getX(),mouse.getY(),&sx,&sy,&sz);

		float target[3];
		target[0]=sx;
		target[1]=sy;
		target[2]=sz;
		if (wiz->castSpell(target,false)) //don't force success
		{
			//inform multiplayer state			
//			glPrintf("spell cast on this machine");

			state.cast=true;
			state.spellTarget.spellType=wiz->getCurrentSpell();
			vectorEquals(state.spellTarget.pos,target);
		}
	}

	if (keyJustPressed(DIK_NUMPAD0))
	{
		int spell=wiz->getCurrentSpell()+1;
		if (spell>3) spell=0;
		wiz->setCurrentSpell(spell);
	}
	if (keyJustPressed(DIK_NUMPAD1))
	{
		int spell=wiz->getCurrentSpell()-1;
		if (spell<0) spell=3;
		wiz->setCurrentSpell(spell);
	}
	if (mouse.getMButtonClicked())
	{
		int spell=wiz->getCurrentSpell()-1;
		if (spell<0) spell=3;
		wiz->setCurrentSpell(spell);
	}
	if (keyDown(DIK_UP))
	{
		walk=true;
		walkNorm[2]+=1;
	}

	if (keyDown(DIK_DOWN))
	{
		walk=true;
		walkNorm[2]-=1;
	}

	if (keyDown(DIK_RIGHT))
	{
		walk=true;
		walkNorm[0]-=1;
	}

	if (keyDown(DIK_LEFT))
	{
		walk=true;
		walkNorm[0]+=1;
	}

	float len=lengthOf(walkNorm);

	if (len>0.01)
	{
		coordsToAngles(walkNorm,&len,walkAngles);

		walkAngle=(180-screen.defaultVP.rot[1])+walkAngles[1];

		
		fixAngle(&walkAngle);
		wiz->turn(walkAngle);
		wiz->walk();
		
		state.walk=true;
		
		//wiz->walk(walkAngle);
	}
	else
	{

//		if (keyJustReleased(DIK_UP) || keyJustReleased(DIK_RIGHT) || keyJustReleased(DIK_LEFT) || keyJustReleased(DIK_DOWN))
//		{
			wiz->stop();
			
//		}
		state.walk=false;
	}




	screen.defaultVP.pos[0]=wiz->phys->pos[0];
	screen.defaultVP.pos[1]=wiz->phys->pos[1]+10; 
	screen.defaultVP.pos[2]=wiz->phys->pos[2];
}



void UserPlayer::sendState()
{
	

	if (client.isConnected())
	{
		state.health=wiz->getHealth();
		//if (wiz->justDied) state.died=true;
		state.died=!wiz->alive;
		state.drown=wiz->drown;


		float * rpos=wiz->phys->pos;//wiz->phys->getRealPos();
		for (int a=0;a<3;++a)
		{
			state.pos[a]=rpos[a];
			state.vel[a]=wiz->phys->vel[a];
		}

		state.time=time;
		state.yrot=wiz->desiredRot;

		++time;
		client.sendGameState(&state);
	}

	state.resetFlags();
}
