/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// VertexArray.cpp: implementation of the VertexArray class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VertexArray.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


VertexArray::VertexArray(int numVers_in, bool texCoords, bool normals, bool colours)
{
	numVers=numVers_in;

	texCoord=NULL;
	normal=NULL;
	colour=NULL;
	pos=NULL;
	if (texCoords) texCoord=new float[numVers*2];
	if (normals) normal=new float[numVers*3];
	if (colours) colour=new float[numVers*4];
	pos=new float[numVers*3];
	multiTexture=false;
}

VertexArray::~VertexArray()
{
	disable();
	if (numVers>0)
	{
		if (texCoord!=NULL) delete [] texCoord;
		if (normal!=NULL) delete [] normal;
		if (colour!=NULL) delete [] colour;
		if (pos!=NULL) delete [] pos;
	}
}


void VertexArray::enable()
{
	glVertexPointer(3, GL_FLOAT, 0, pos);
	glEnableClientState(GL_VERTEX_ARRAY);          

	if (texCoord!=NULL) 
	{
		if (multiTexture)
		{
			glClientActiveTextureARB(GL_TEXTURE1_ARB);
			glTexCoordPointer(2, GL_FLOAT, 0, texCoord);
			glEnableClientState(GL_TEXTURE_COORD_ARRAY);          

			glClientActiveTextureARB(GL_TEXTURE0_ARB);
			glTexCoordPointer(2, GL_FLOAT, 0, texCoord);
			glEnableClientState(GL_TEXTURE_COORD_ARRAY);  
		} 


		else
		{
			glTexCoordPointer(2, GL_FLOAT, 0, texCoord);
			glEnableClientState(GL_TEXTURE_COORD_ARRAY);          
		}



	}
	if (normal!=NULL) 
	{
		glNormalPointer(GL_FLOAT, 0, normal); 
		glEnableClientState(GL_NORMAL_ARRAY);          
	}
	if (colour!=NULL)
	{
		glColorPointer(4,GL_FLOAT, 0, colour); 
		glEnableClientState(GL_COLOR_ARRAY);          
	}
	
}


void VertexArray::disable()
{
	glDisableClientState(GL_VERTEX_ARRAY);          
	if (texCoord!=NULL) 
	{
		if (multiTexture)
		{
			glClientActiveTextureARB(GL_TEXTURE1_ARB);
			glDisableClientState(GL_TEXTURE_COORD_ARRAY);          

			glClientActiveTextureARB(GL_TEXTURE0_ARB);
			glDisableClientState(GL_TEXTURE_COORD_ARRAY);          
		}
		else
		{
			glDisableClientState(GL_TEXTURE_COORD_ARRAY);          

		}
	}
	if (normal!=NULL) 
	{
		glDisableClientState(GL_NORMAL_ARRAY);          
	}
	if (colour!=NULL)
	{
		glDisableClientState(GL_COLOR_ARRAY);          
	}
}
