// VertexArray.h: interface for the VertexArray class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VERTEXARRAY_H__5ABEEDC2_69F6_4231_83EB_4693BDCE9D9D__INCLUDED_)
#define AFX_VERTEXARRAY_H__5ABEEDC2_69F6_4231_83EB_4693BDCE9D9D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


struct VertexArray
{
	VertexArray(int numVers_in, bool texCoords, bool normals, bool colours);
	~VertexArray();

	void enable();
	void disable();

	float * texCoord;
	float * normal;
	float * colour;
	float * pos;
	int numVers;
	bool multiTexture;
};



struct VertexIndices
{

	VertexIndices()
	{
		numIndices=0;
		indices=NULL;
	}   
	~VertexIndices()
	{
		if (numIndices>0)
		{
			delete [] indices;
		}
	}
	void allocate(int numIndices_in)
	{
		numIndices=numIndices_in;
		indices=new unsigned int[numIndices];
	}

	unsigned int * indices;
	int numIndices;
};


#endif // !defined(AFX_VERTEXARRAY_H__5ABEEDC2_69F6_4231_83EB_4693BDCE9D9D__INCLUDED_)
