/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
// ViewFrustum.cpp: implementation of the ViewFrustum class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ViewFrustum.h"
#include "matrix.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ViewFrustum::ViewFrustum()
{
}

ViewFrustum::~ViewFrustum()
{
}

void ViewFrustum::extract()
{
	TMatrix4 projection;
	TMatrix4 modelview;
	TMatrix4 clip;
	float mul;

	glGetFloatv(GL_PROJECTION_MATRIX, projection);
	glGetFloatv(GL_MODELVIEW_MATRIX, modelview);

	multMatrixTo(projection,modelview,clip);

	//right plane
	frustum[0][0]=clip[3]-clip[0];
	frustum[0][1]=clip[7]-clip[4];
	frustum[0][2]=clip[11]-clip[8];
	frustum[0][3]=clip[15]-clip[12];

	//normalise
	mul=1.0/sqrt(frustum[0][0]*frustum[0][0]+
				 frustum[0][1]*frustum[0][1]+
				 frustum[0][2]*frustum[0][2]);
	frustum[0][0]*=mul;
	frustum[0][1]*=mul;
	frustum[0][2]*=mul;
	frustum[0][3]*=mul;

	//left plane
	frustum[1][0]=clip[3]+clip[0];
	frustum[1][1]=clip[7]+clip[4];
	frustum[1][2]=clip[11]+clip[8];
	frustum[1][3]=clip[15]+clip[12];

	mul=1.0/sqrt(	frustum[1][0]*frustum[1][0]+
					frustum[1][1]*frustum[1][1]+
					frustum[1][2]*frustum[1][2]);
	frustum[1][0]*=mul;
	frustum[1][1]*=mul;
	frustum[1][2]*=mul;
	frustum[1][3]*=mul;

	//bottom
	frustum[2][0]=clip[3]+clip[1];
	frustum[2][1]=clip[7]+clip[5];
	frustum[2][2]=clip[11]+clip[9];
	frustum[2][3]=clip[15]+clip[13];

	mul=1.0/sqrt(	frustum[2][0]*frustum[2][0]+
					frustum[2][1]*frustum[2][1]+
					frustum[2][2]*frustum[2][2]);
	frustum[2][0]*=mul;
	frustum[2][1]*=mul;
	frustum[2][2]*=mul;
	frustum[2][3]*=mul;

	//top
	frustum[3][0] = clip[3]-clip[1];
	frustum[3][1] = clip[7]-clip[5];
	frustum[3][2] = clip[11]-clip[9];
	frustum[3][3] = clip[15]-clip[13];

	mul=1.0/sqrt(frustum[3][0] * frustum[3][0] + frustum[3][1] * frustum[3][1] + frustum[3][2] * frustum[3][2]);
	frustum[3][0]*=mul;
	frustum[3][1]*=mul;
	frustum[3][2]*=mul;
	frustum[3][3]*=mul;

	//far
	frustum[4][0]=clip[3]-clip[2];
	frustum[4][1]=clip[7]-clip[6];
	frustum[4][2]=clip[11]-clip[10];
	frustum[4][3]=clip[15]-clip[14];

	mul=1.0/sqrt(	frustum[4][0]*frustum[4][0]+
					frustum[4][1]*frustum[4][1]+
					frustum[4][2]*frustum[4][2]);
	frustum[4][0]*=mul;
	frustum[4][1]*=mul;
	frustum[4][2]*=mul;
	frustum[4][3]*=mul;

	//near
	frustum[5][0]=clip[3]+clip[2];
	frustum[5][1]=clip[7]+clip[6];
	frustum[5][2]=clip[11]+clip[10];
	frustum[5][3]=clip[15]+clip[14];

	mul=1.0/sqrt(	frustum[5][0]*frustum[5][0]+
					frustum[5][1]*frustum[5][1]+
					frustum[5][2]*frustum[5][2]);
	frustum[5][0]*=mul;
	frustum[5][1]*=mul;
	frustum[5][2]*=mul;
	frustum[5][3]*=mul;


}
