/*
Camera.h

Version 1.0

(c)2001 Ben Woodhouse
*/

#include "matrix.h"
#include "miscutils.h"

#ifndef camera_h
#define camera_h

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class Viewport
{
public:
	Viewport();
	virtual void setViewMatrix(){}
	void unproject(int x,int y, 
						double * outx, double * outy, double * outz);
	virtual void getCameraPos(float * posOut){}
	virtual void rotateByRotMat(){messageBox("This should not be called");}
	virtual void rotateByInvRotMat(){messageBox("invRotmat doesn't exist");}
	virtual void getCameraNorm(float * normOut){}

	double viewangle;
	double nearclip;
	double farclip;
	double aspect;


	TMatrix4 modelView;
};


class ThreeDegreesCamera : public CThreeDegrees , public Viewport
{
public:
	ThreeDegreesCamera(); 
	void rotateByRotMat();

	void setViewMatrix();
	void getCameraPos(float * posOut);
	void rotateByInvRotMat();
};


class OrbitalCamera : public Viewport
{
public:
	OrbitalCamera();
	void setViewMatrix();
	void fixAngles();
	void getCameraPos(float * posOut);

	void rotateByRotMat();
	void rotateByInvRotMat();
	void getCameraNorm(float * normOut);

	float radius;
	float rot[3];
	float pos[3];
};


class fpsCamera
{

};

#endif