/*
DirectInput.cpp 
Version 1.31

(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 

*/
#include "stdafx.h"
//#include "directinput.h"

//GLOBALS
BYTE character=0;

LPDIRECTINPUT8 DI=NULL;
LPDIRECTINPUTDEVICE8 keyboardI=NULL; 
LPDIRECTINPUTDEVICE8 keyboardB=NULL; 
LPDIRECTINPUTDEVICE8 mouseI=NULL;  
BYTE kbbufOLD[256]={0};
BYTE kbbuf[256]={0};
HRESULT ghr=0; //global hresult
BOOL DirectInputb=FALSE; //becomes TRUE after DI is initialized
HWND DI_hWnd;

//FIXME: space causes crash
extern char DIKtoASCII[256]={
				0,27, 49, 50, 51, 52, 53, 54, 55, 56, 57, 48, 45, 61, 0, //backspace
				0, 113, 119, 101, 114, 116, 121, 117, 105, 111, 112,		//p
				91, 93, 0, 0, 97, 115, 100, 102, 103, 104, 106, 107, 108, //l
				59, 39, 96, 0, 92, 122, 120, 99, 118, 98, 110, 109, 44, 46, //.
				47, 0, 42, 0, 32, 0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0, 45,  //num pad -
				0,0,0, 43, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0, //DIK_UNLABELED
				0,0,0, 47, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
				
extern char DIKtoASCII_shift[256]={
				0,27, 33, 34, 35, 36, 37, 94, 38, 42, 40, 41, 95, 43, 0,
				0, 81, 87, 69, 82, 84, 89, 85, 73, 79, 80, 
				123, 125, 0,0, 65, 83, 68, 70, 71, 72 , 74, 75, 76,
				58 ,34 ,124 ,0, 124, 90, 88, 67, 86, 66, 78, 77, 60, 62, 
				63, 0, 42, 0, 32, 0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0, 45,
				0,0,0, 43, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,
				0,0,0, 47, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};  


//FUNCTIONS 

bool keyDown(BYTE key)
{
	if (KEYDOWN(kbbuf, key)) return true;
	return false;
}

bool keyJustPressed(BYTE key)
{
	if (KEYDOWN(kbbuf, key) && !KEYDOWN(kbbufOLD,key)) return true;
	return false;
}

bool keyJustReleased(BYTE key)
{
	if (!KEYDOWN(kbbuf, key) && KEYDOWN(kbbufOLD,key)) return true;
	return false;
}


//interprets hresult codes and displays the result through glprintf
void bitch(HRESULT hr)
{
	glPrintf("DIINPUT ERROR: ");
	switch(hr)
	{
		case DIERR_NOTFOUND:
			glPrintf("DIERR_NOTFOUND or DIERR_OBJECTNOTFOUND\n");
		break;

		case DI_NOTATTACHED:
			glPrintf("DI_NOTATTACHED, DI_PROPNOEFFECT\n");
			glPrintf("or DI_BUFFEROVERFLOW or DI_NOEFFECT\n");
		break;

		
		case DIERR_READONLY:
			glPrintf("DIERR_READONLY, DIERR_OTHERAPPHASPRIO\n");
			glPrintf("or DIERR_HANDLEEXISTS\n");
		break;

		case DI_DOWNLOADSKIPPED:
			glPrintf("DI_DOWNLOADSKIPPED\n");
		break;

		case DI_EFFECTRESTARTED:
			glPrintf("DI_EFFECTRESTARTED\n");
		break;

		case DI_OK:
			glPrintf("DI_OK, \n");
		break;

		case DI_POLLEDDEVICE:
			glPrintf("DI_POLLEDDEVICE \n");
		break;

		case DI_TRUNCATED:
			glPrintf("DI_TRUNCATED\n");
		break;

		case DI_TRUNCATEDANDRESTARTED:
			glPrintf("DI_TRUNCATEDANDRESTARTED\n");
		break;

		case DIERR_ACQUIRED:
			glPrintf("DIERR_ACQUIRED\n");
		break;

		case DIERR_ALREADYINITIALIZED:
			glPrintf("DIERR_ALREADYINITIALIZED\n");
		break;

		case DIERR_BADDRIVERVER:
			glPrintf("DIERR_BADDRIVERVER\n");
		break;

		case DIERR_BETADIRECTINPUTVERSION:
			glPrintf("DIERR_BETADIRECTINPUTVERSION\n");
		break;

		case DIERR_DEVICEFULL:
			glPrintf("DIERR_DEVICEFULL\n");
		break;

		case DIERR_DEVICENOTREG:
			glPrintf("DIERR_DEVICENOTREG\n");
		break;

		case DIERR_EFFECTPLAYING:
			glPrintf("DIERR_EFFECTPLAYING\n");
		break;

		case DIERR_HASEFFECTS:
			glPrintf("DIERR_HASEFFECTS\n");
		break;

		case DIERR_GENERIC:
			glPrintf("DIERR_GENERIC\n");
		break;

		case DIERR_INCOMPLETEEFFECT:
			glPrintf("DIERR_INCOMPLETEEFFECT\n");
		break;

		case DIERR_INPUTLOST:
			glPrintf("DIERR_INPUTLOST\n");
		break;

		case DIERR_INVALIDPARAM:
			glPrintf("DIERR_INVALIDPARAM \n");
		break;

		case DIERR_MOREDATA:
			glPrintf("DIERR_MOREDATA\n");
		break;

		case DIERR_NOAGGREGATION:
			glPrintf("DIERR_NOAGGREGATION \n");
		break;

		case DIERR_NOINTERFACE:
			glPrintf("DIERR_NOINTERFACE\n");
		break;

		case DIERR_NOTACQUIRED:
			glPrintf("DIERR_NOTACQUIRED\n");
		break;

		case DIERR_NOTBUFFERED:
			glPrintf("DIERR_NOTBUFFERED\n");
		break;

		case DIERR_NOTDOWNLOADED:
			glPrintf("DIERR_NOTDOWNLOADED\n");
		break;

		case DIERR_NOTEXCLUSIVEACQUIRED:
			glPrintf("DIERR_NOTEXCLUSIVEACQUIRED\n");
		break;

		case DIERR_NOTINITIALIZED:
			glPrintf("DIERR_NOTINITIALIZED\n");
		break;

		case DIERR_OLDDIRECTINPUTVERSION:
			glPrintf("DIERR_OLDDIRECTINPUTVERSION\n");
		break;

		case DIERR_OUTOFMEMORY:
			glPrintf("DIERR_OUTOFMEMORY\n");
		break;

		case E_PENDING:
			glPrintf("E_PENDING\n");
		break;

		default:
			glPrintf("HR (%d) not found!\n",hr);
	}
}



HRESULT DI_keysin(void)
{ 
    HRESULT  hr; 
	int a;
	BOOL shiftDown;


	hr = DIERR_INPUTLOST;
	
    while (hr==DIERR_INPUTLOST) 
    {
		
		for (a=0;a<256;++a)
		{ 
			kbbufOLD[a]=kbbuf[a];
		}
        hr = keyboardI->GetDeviceState( sizeof(kbbuf), &kbbuf );
	    if ( hr == DIERR_INPUTLOST || hr== DIERR_NOTACQUIRED)
        { 
            hr = keyboardI->Acquire();
            if ( FAILED(hr) )    
			{
				//glPrintf("Error point 1\n"); 
				//bitch(hr);
                return hr;
			}
        }
    }

    if ( FAILED(hr) ) 
	{
		//glPrintf("Error point 2\n");
		//bitch(hr);
        return hr;									 
	}

	//determine if shift is down
	if (KEYDOWN(kbbuf, DIK_LSHIFT) || KEYDOWN(kbbuf, DIK_RSHIFT)) shiftDown=TRUE;
	else shiftDown=FALSE;
	//find which keys have been pressed since last cycle
	//by comparing last cycles keypresses with this
	for (a=0;a<256;++a)
	{
		if (KEYDOWN(kbbuf, a) && !KEYDOWN(kbbufOLD, a)) 
		{
			//key (a) pressed since last cycle
			if (shiftDown)
			{
				if (DIKtoASCII_shift[a]!=0) character=DIKtoASCII_shift[a];
			}
			else 
			{
				if (DIKtoASCII[a]!=0) character=DIKtoASCII[a];
			}
			
			//FIXME: lack of key repeat causing problems with ground move

		}
	}
 

        // Turn left. 
	return S_OK;
} 



HRESULT DID_init(int dev)
{
	DIPROPDWORD  dipdw; 
	HRESULT hr;
	switch(dev)
	{

		case KEYBOARD_I:
			hr=DI->CreateDevice(GUID_SysKeyboard, &keyboardI, NULL);
			if (!FAILED(hr))
			{
				hr=keyboardI->SetDataFormat(&c_dfDIKeyboard);
				if (!FAILED(hr))
				{
					hr=keyboardI->SetCooperativeLevel(DI_hWnd, 
											DISCL_NONEXCLUSIVE | DISCL_FOREGROUND);
					if (!FAILED(hr))
					{			
						hr=keyboardI->Acquire();
					}
				}
			}
		break; 
	

		case KEYBOARD_B:
			hr=DI->CreateDevice(GUID_SysKeyboard, &keyboardB, NULL);
//			glPrintf("CreateDevice : ");
			//bitch(hr);
			if (!FAILED(hr))
			{
				hr=keyboardB->SetDataFormat(&c_dfDIKeyboard);
				//glPrintf("SetDataFormat : ");
				//bitch(hr);
				if (!FAILED(hr))
				{
					hr=keyboardB->SetCooperativeLevel(DI_hWnd, 
													DISCL_NONEXCLUSIVE | DISCL_FOREGROUND);
					//glPrintf("SetCooperativeLevel : ");
					//bitch(hr);

					//set the buffer size. DirectX is like pulling out toenails...

					dipdw.diph.dwSize = sizeof(DIPROPDWORD); 
					dipdw.diph.dwHeaderSize = sizeof(DIPROPHEADER); 
					dipdw.diph.dwObj = 0; 
					dipdw.diph.dwHow = DIPH_DEVICE; 
					dipdw.dwData = BUFFER_SIZE;
					if (!FAILED(hr))
					{
						hr = keyboardB->SetProperty(DIPROP_BUFFERSIZE, &dipdw.diph); 
//						glPrintf("SetProperty : ");
						//bitch(hr);

						if (!FAILED(hr))
						{

							hr=keyboardB->Acquire();
//							glPrintf("Acquire : ");
							//bitch(hr);
						}
					}
				}
			}
		break;

		case MOUSE_I:
			hr=DI->CreateDevice(GUID_SysMouse, &mouseI,NULL);
			if (!FAILED(hr))
			{
				hr=mouseI->SetDataFormat(&c_dfDIMouse);
				if (!FAILED(hr))
				{
					hr=mouseI->SetCooperativeLevel(DI_hWnd, 
								DISCL_NONEXCLUSIVE | DISCL_FOREGROUND);
					if (!FAILED(hr))
					{
						hr=mouseI->Acquire();  
					}
				}
			}
		break;

	}
	return hr;

}

void DID_term(int dev)
{
	switch(dev)
	{
		case ALL:
			if (keyboardI) 
			{ 
				 keyboardI->Unacquire(); 
				 keyboardI->Release();
				 keyboardI=NULL; 
			} 
			if (keyboardB)
			{
				 keyboardB->Unacquire(); 
				 keyboardB->Release();
				 keyboardB=NULL; 
			}
			if (mouseI)
			{
				mouseI->Unacquire();
				mouseI->Release();
				mouseI=NULL;
			}
		break;

		case KEYBOARD_I:
			if (keyboardI) 
			{ 
				 keyboardI->Unacquire(); 
				 keyboardI->Release();
				 keyboardI=NULL; 
			} 
		break;

		case KEYBOARD_B:
			if (keyboardB)
			{
				 keyboardB->Unacquire(); 
				 keyboardB->Release();
				 keyboardB=NULL; 
			}
		break;

		case MOUSE_I:
			if (mouseI)
			{
				mouseI->Unacquire();
				mouseI->Release();
				mouseI=NULL;
			}
		break;


	}

}

void DI_term(void)
{ 
    if (DI) 
    {
		DID_term(ALL);

        DI->Release();
        DI=NULL; 
    } 
} 




BOOL DI_init(HWND lhWnd)
{
	HRESULT hr;
	HINSTANCE hInstL;
	
	DI_hWnd=lhWnd;
	DirectInputb=TRUE;

	hInstL=(HINSTANCE)GetWindowLong(DI_hWnd, GWL_HINSTANCE);
	//get directinput interface pointer 

	hr=DirectInput8Create(	hInstL,
							DIRECTINPUT_VERSION,
							IID_IDirectInput8A, 
							(void **) & DI,
							NULL
						);


	ZeroMemory(&kbbuf,256);
	
	if (hr!=DI_OK) 
	{
		//bitch(hr);  
		return FALSE;
	}
//	glPrintf("DI setup successful\n");
	return TRUE; 
}
