/*
glText.cpp

(c)2000 Ben Woodhouse

Text and static input handling for Mirage 3D engine

Version 4.03


*/
#include "stdafx.h"
#include <string>

//#include "gltext.h"

//globals
Font fontStack[8];
Font font;
BOOL blankscreen=FALSE;
char GLTEXT[10000]={0};
int numchars;


void initText()
{
	_chdir("textures");
	
//	textTex=loadNewTexture("text.bmp",TF_LML,TF_LML,BMP,LOADTEX_ALPHAMAP); 
	//textTex=loadNewTexture("text\\impactVerdana.bmp",TF_LML,TF_LML,RAW,LOADTEX_ALPHAMAP); 


	//font.setTexP(textTex);
	font.load("text\\impactVerdana16.bmp","text\\impactVerdana16.dat");
	font.setAlternate(true);
	_chdir("..");
//	textTex=loadNewTexture("sand.raw",TF_LML,TF_LML,256);

}

/*
void copyFont(Font &source,Font &dest)
{
	dest.height
	dest->sizeX=source->sizeX;
	dest->sizeY=source->sizeY;
	dest->spaceX=source->spaceX;
	dest->spaceY=source->spaceY;
	dest->tex=source->tex;
	dest->colour[0]=source->colour[0];
	dest->colour[1]=source->colour[1];
	dest->colour[2]=source->colour[2];
}

void pushFont()
{
	//put current font on the stack


	int a;
	//shift stack down
	for (a=7;a>=1;--a)
	{
		copyFont(&fontStack[a-1],&fontStack[a]);
	}

	//copy current font to top of stack
	copyFont(&font,&fontStack[0]);

}   

void popFont() 
{
	int a;
	copyFont(&fontStack[0],&font);

	//shift stack up
	for (a=0;a<7;++a)
	{
		copyFont(&fontStack[a+1],&fontStack[a]);
	}

}
*/
void pushText()
{
	screen.push2D();
	glPushAttrib(GL_ENABLE_BIT);  
		glEnable(GL_BLEND);
		//glPushAttrib(GL_DEPTH_BUFFER_BIT);
    		glDepthFunc(GL_ALWAYS);
//			glDepthMask(GL_TRUE);
			glDisable(GL_LIGHTING);
	//		glDepthRange(0,0.01);



//		glBlendFunc(GL_SRC_COLOR, GL_DST_COLOR);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

		glPushMatrix();
			glLoadIdentity();
			
			//glBindTexture (GL_TEXTURE_2D,texNum[0]);
			font.tex->bind();
			glColor4f(1,1,1,1);

			glBegin(GL_QUADS);

}

void popText()
{
			glEnd();
			screen.pop2D();
//			glPopAttrib();
	glDepthFunc(GL_LEQUAL);
		glPopMatrix();
//		glDepthRange(0.5,1);
	glPopAttrib();
}



void outText(int x, int y,const char * format, ...) //outputs text at a specific location onscreen
{
	int a;
	int cx=0;
	int cy=0;

	char text[1000];

	glPushAttrib(GL_TEXTURE_BIT);
	va_list args;

	va_start(args,format);
	vsprintf(text, format, args);
	va_end(args);
	 
//	glColor4f(1,0,1,1);

	font.tex->bind();

	//glBindTexture(GL_TEXTURE_2D,texNum[font.texNum]);
	pushText();
	glColor4f(font.colour[0],font.colour[1],font.colour[2],1);
	for (a=0;text[a]!=NULL;++a)
	{
		if (text[a]==10) //if carrage return
		{
			cy-=font.sizeY;
			cx=0;
		}
		else
		{
			
			cx+=displayChar(	x+cx,
								y+cy,
								text[a],
								font.sizeX, 
								font.sizeY,
								&font);
							
		}
	}
	popText();
	glPopAttrib();
			  
}

char glGetch(void)
{
	int rv;
	char bob[2];

	rv=glInput(bob,-1);

	if (rv>0) return bob[0];

	//return 0 on enter or -1 on escape
	return rv;
}

char scanToAscii(DWORD scan) 
{
	HKL layout;
	UCHAR state[256];
	UINT vk;
	USHORT result[2];
	int chars;				  

	layout=GetKeyboardLayout(0);
	GetKeyboardState(state);
	vk=MapVirtualKeyEx(scan,1,layout);
	chars=ToAsciiEx(vk,scan,state,result,1,layout);
	if (chars<0) return 0;
	if (chars>1) return 0;
	return (char)result[0];
}

//returns number of chars written, or -1 on failure
int glInput(char * string,int inchars)
{
	DIDEVICEOBJECTDATA didod[BUFFER_SIZE];
	DWORD inOut,out;
	HRESULT hr=DIERR_INPUTLOST;
	DWORD keydownlog[BUFFER_SIZE]; //stores keys pressed down
	UINT keysdown=0; //keys pressed
	UINT vchars=0; //valid chars

	BOOL left=FALSE;
	BOOL right=FALSE;
	BOOL up=FALSE;
	BOOL down=FALSE;
	BOOL enter=FALSE;
	BOOL escape=FALSE;
	BOOL lshift=FALSE;
	BOOL rshift=FALSE;

	BOOL display=TRUE;
	UINT chars;
 
	//hr=keyboard->Unacquire();
	//hr=DIERR_INPUTLOST;

	//make sure the timer is stopped
	//TRANSFER:
	speedmod=0;


	if (inchars==-1) 
	{
		display=FALSE;
		chars=1;
	}
	else
	{
		chars=inchars;
	}


	UINT a; 
	char tempchar;

 

	//initialize the buffer
	DID_term(KEYBOARD_I);
	ghr=DID_init(KEYBOARD_B); 


	//flush the buffer
	while (hr==DIERR_INPUTLOST || hr==DIERR_NOTACQUIRED)
	{
		inOut=BUFFER_SIZE;
		/*
 		hr = keyboardB->GetDeviceData( sizeof(DIDEVICEOBJECTDATA),
									didod, 
									&inOut, 
									0 );
									*/
		inOut=INFINITE;
		hr = keyboardB->GetDeviceData( sizeof(DIDEVICEOBJECTDATA),
									NULL, 
									&inOut, 
									0 );
		
		
		if (hr==DIERR_INPUTLOST || hr==DIERR_NOTACQUIRED) 
		{
			ghr=keyboardB->Acquire();
			if (FAILED(ghr)) goto glInputError;								 
		}
	}

    if (FAILED(hr)) goto glInputError;
	while (vchars<chars && !enter && !escape)
	{
		hr=DIERR_INPUTLOST;
		while (hr==DIERR_INPUTLOST || hr==DIERR_NOTACQUIRED)
		{
			inOut=BUFFER_SIZE;
			hr = keyboardB->GetDeviceData( sizeof(DIDEVICEOBJECTDATA),
										didod, 
										&inOut, 
										0 );
			//hr = keyboardB->Unacquire();
			if (hr==DIERR_INPUTLOST || hr==DIERR_NOTACQUIRED) 
			{
				ghr=keyboardB->Acquire();					 
			    if (FAILED(ghr)) goto glInputError;								 
			}
		}
		out=inOut;

		//find how many keys have actually been pressed
		keysdown=0; 
		//keysdown records how many keys have been pressed since
		//the previous GetDeviceData call.

		for (a=0;a<out;++a)
		{
			if (didod[a].dwData & 0x80) //if key is pressed, not released
			{
				keydownlog[keysdown]=didod[a].dwOfs;
				++keysdown;
			}
			/*FIXME:SHIFT DOESN'T WORK
			else
			{			 //check for release of shift
				if (didod[a].dwOfs==DIK_LSHIFT) lshift=FALSE;
				else if (didod[a].dwOfs==DIK_RSHIFT) rshift=FALSE;
			}
			*/
		}

		//next, process keydownlog to get some more useful data
		for (a=0;a<keysdown;++a)
		{
			//convert the data to an ascii format
			tempchar=scanToAscii(keydownlog[a]);

			if (tempchar>31 && tempchar<127) 
			{								 //key is a valid char
				string[vchars]=tempchar;
				
				if (display)
				{
					glPrintf("%c",string[vchars]);
					screen.update();
				} 
				++vchars;

			}
			
			else
			{								//key is not a valid char
				switch(keydownlog[a])
				{
					case DIK_ESCAPE:
						escape=TRUE;
					break;

					case DIK_BACK:
						if (vchars>0)
						{
							--vchars;
							if (display)
							{
								--numchars;
								screen.update();
							}
						}
					break;
						
					case DIK_RETURN:
						enter=TRUE;
					break;

					case DIK_RIGHT:
						right=TRUE;
					break;

					case DIK_LEFT:
						left=TRUE;
					break;

					case DIK_UP:
						up=TRUE;
					break;

					case DIK_DOWN:
						down=TRUE;
					break;

		
					
				/*	case DIK_LSHIFT:
						lshift=TRUE;
					break;

					case DIK_RSHIFT:
						rshift=TRUE;
					break;*/
				}

			}
			


		}
	

	}
	//glPrintf("got to here2\n");
	//goto glInputError;

	string[vchars]=NULL; //terminate the string

		//flush the buffer
	hr=DIERR_INPUTLOST;
	while (hr==DIERR_INPUTLOST || hr==DIERR_NOTACQUIRED)
	{
		inOut=INFINITE;
 		hr = keyboardB->GetDeviceData( sizeof(DIDEVICEOBJECTDATA),
									NULL, 
									&inOut, 
									0 );
		if (hr==DIERR_INPUTLOST || hr==DIERR_NOTACQUIRED) 
		{
			ghr=keyboardB->Acquire();
		    if (FAILED(ghr)) goto glInputError;								 
		}
	}
    if (FAILED(hr)) goto glInputError;
	//terminate the buffer
	DID_term(KEYBOARD_B);
	ghr=DID_init(KEYBOARD_I);  

	if (escape) return -1;

	return (int)vchars;

glInputError:
	DID_term(KEYBOARD_B);
	ghr=DID_init(KEYBOARD_I);  
	return -2;
}





 

void glPrintSymbol(char symbol)
{
	GLTEXT[numchars]=symbol-128;
	++numchars;
}

void glPrintf(const std::string & s)
{
	if (numchars<9500)
		numchars+=sprintf(GLTEXT+numchars,s.c_str());
}

void glPrintf( const char *format, ...)		//used like printf to display text
{	
	va_list args;

	//textDisplayList=0; //causes text display list to be updated

	va_start(args,format);

	if (numchars<9500)
		numchars+=vsprintf(GLTEXT+numchars, format, args);

	va_end( args );
}



void glCls(void)
{
	numchars=0;
}

void dirList(char filetype[])
{
	HANDLE dir;
	WIN32_FIND_DATA dirEntry[128];
	BOOL finished=FALSE;
	int a;
	float testfloat=1.999;

	dir=FindFirstFile(filetype,&dirEntry[0]);
	
	if (dir!=INVALID_HANDLE_VALUE)
	{
		glPrintf("%s\n",dirEntry[0].cFileName);
		a=1;
		while(!finished)				
		{
			if (!FindNextFile(dir,&dirEntry[a]) || a==128)
			{
				finished=TRUE;
			}
			else
			{
				glPrintf("%s\n",dirEntry[a].cFileName);

			}
			++a;
		}

	}
	else
	{
		glPrintf("ERROR: Invalid search handle\n");
	}

	
	FindClose(dir); 


}


void glText(void)
{
	int umx=0,umy=0,a;
	int numLines;
	float charSizeX, charSizeY;
	float aspect=0.6;
	float screenx,screeny;


	
	blankscreen=FALSE;

	//use a display list
	if (numchars>0)
	{
		charSizeY=16;
		charSizeX=16*aspect;
		glColor4f(1,1,1,1);

//	glDisable(GL_TEXTURE_2D);
		pushText();
			
		for (a=0;a<numchars;++a)
		{
			if (umx>(screen.sizex/charSizeX)-2) 
			{
				umx=0;
				++umy;
			}

			if (GLTEXT[a]==10) //if carriage return
			{
				umx=-1;		   
				++umy;	  
			} 				
			++umx;
		}
		umx=0;
		numLines=umy;
		umy=0;

		screenx=0;
		screeny=448;
//		glCls();
//		glPrintf("font size: %f %f",font.sizeX,font.sizeY);

		for (a=0;a<numchars;++a)
		{
			if (screenx>screen.sizex) 
			{
				umx=0;
				screenx=0;
				screeny-=32;
				++umy;
			}

			if (GLTEXT[a]==10) //if carriage return
			{
				umx=-1;		   
				screenx=0;
				screeny-=font.sizeY;
				++umy;	  
			} 				

	//							else displaychar(umx,umy,GLTEXT[a],charSizeX, charSizeY);
			else 
			{
				if (GLTEXT[a]=='`') //small tab
				{
					screenx=(roundup((screenx/10.0)))*10;
				}
				else if (GLTEXT[a]=='~') //tab
				{
					screenx=((int)(screenx/32.0))*32+32;
					//screenx+=32;
				}
				else
				{	//display the character
					screenx+=displayChar(screenx,screeny,GLTEXT[a],font.sizeX,font.sizeY,&font);
				}
			}
			++umx;
			
		}
		popText();
	}

}


float displayChar(float screenX, float screenY,
				  unsigned char c, float sizeX, float sizeY, Font * pFont)
{
	c=c-32+pFont->charOffset;
	Letter * letter=&pFont->letter[c];
	float * texcx=letter->texCoordx;
	float * texcy=letter->texCoordy;

	
	
	//float startX=
	float actWidth=letter->texCoordWidth*sizeX*16.0;
	//actWidth=32;
	
	//then display the character
	glTexCoord2f(texcx[0],texcy[0]);
	glVertex2f(screenX, screenY);

	glTexCoord2f(texcx[0],texcy[1]);
	glVertex2f(screenX,screenY+sizeY);

	glTexCoord2f(texcx[1],texcy[1]);
	glVertex2f(screenX+actWidth, screenY+sizeY);

	glTexCoord2f(texcx[1],texcy[0]);
	glVertex2f(screenX+actWidth,screenY);

	return actWidth;
}
