/*
glText.h

(c)2000 Ben Woodhouse

Text and static input handling for Mirage 3D engine

Version 4.03
*/



#ifndef _INC_GLTEXT
#define _INC_GLTEXT

#if     _MSC_VER > 1000
#pragma once
#endif

#include "Font.h"

#define PIXELS true
#define CHARACTERS false
//globals
extern BOOL blankscreen;
extern char GLTEXT[10000];
extern int numchars;

#define SYMBOL_BIGSPACE 128



extern Font font;
extern Font fontStack[8];

void initText();
/*
void copyFont(Font &source,Font &dest);
void pushFont();
void popFont();*/
void pushText();
void popText();
void outText(int x, int y,const char * text, ...); //outputs text at a specific location onscreen
char glGetch(void);			//calls glInput(1)
char scanToAscii(DWORD);  //used by glInput
int glInput(char * ,int);	//used to get a text string
void glText(void);			//displays all text on the screen
//void displaychar(int,int,char,float sizeX, float sizeY,bool coordType=CHARACTERS);	//displays a character (only works between GLBEGIN and GLEND)
void glCls(void);							//clears the text buffer
void glPrintSymbol(char symbol); //prints an extended character
void glPrintf( const char *, ...);			//used like printf to display text
void glPrintf(const std::string & s);
void dirList(char *);			//lists all files of type specified

//returns width of displayed character
float displayChar(float screenX, float screenY,
				  unsigned char c, float sizeX, float sizeY, Font * pFont);


#endif



