#if !defined(HEIGHTMAP_H)
#define HEIGHTMAP_H

#include "VertexArray.h"

struct HMYOutParamStruct
{
	int cornerPos[4][2];
	float cornerHeight[4];
	float pos[2];
};

class CHeightmap  
{
public:
	CHeightmap();
	~CHeightmap(); 

	bool loadFromImage(CImage & image);
	void drawHM(); 
	void loadTexImage(CImage & image);
	void genArrays(bool texCoords, bool normals, bool colours);
	void set(int dx, int dy, BYTE heightVal);
	void preDraw(){}
	void generateNormTable();
	void setScale(float scalexz, float scaley);
	void setTex(CTexture * tex);
	float getYAt(float x, float z);
	
	float getYAt_simple(float x_in, float z_in, HMYOutParamStruct &out);
	float getYAt_2ndPart(HMYOutParamStruct &in);
	
	float getScale(){return scalexz;}
	BYTE ** getPoints(){return points;}

protected:
	BYTE ** points;
	int width;
	int height;
	float scalexz;
	float scaley;
	float oneOverScaley;
	CTexture * tex;

	VertexIndices * indexStrip;
	VertexArray * array;

	float tableUnit;
	float * normTable;


	//sea
	float seaVal;
};


#endif