/*
Matrix.h
Quaternion and matrix operations
Version 1.0

(c)2001 Ben Woodhouse

The matrices used are compatible with openGL matrices and therefore are turned on their sides
*/

#ifndef _INC_MATRIX
#define _INC_MATRIX


typedef float TQuaternion[4];
typedef float TMatrix4[16];
typedef float TMatrix3[9];

extern TMatrix4 Identity4;
extern TMatrix3 Identity3;

//extern TQuaternion quat;

class CQuaternion
{
};

class CVector
{
};

class CMatrix
{
	public:
		friend CMatrix operator+ (CMatrix m1, CMatrix m2);
		float v[16];

};


void copyMatrix(TMatrix4 src, TMatrix4 dst);
void transposeMatrix(TMatrix4 m);
void loadIdentity(TMatrix4 m);
void translateMatrix(TMatrix4 m,float trans[3]);
void displayMatrix4(TMatrix4 m);
void multMatrixBy(float *matrixa, float matrixb[16]);
void multMatrixTo(TMatrix4 matrixa, TMatrix4 matrixb, TMatrix4 matrixDest);

void quat_multiplyBy(TQuaternion quata, TQuaternion quatb); //multiplies a by b and stores result in a
void quat_normalize(TQuaternion quat);
float quat_getLength(TQuaternion quat);
void quat_convertToRotMatrix(TQuaternion quat, TMatrix4 rotMat);
void quat_rotateByRotMatrix(float vector[3],TMatrix4 rotMat);
void quat_convertFromAxisAngle(float angle, float axis[3], TQuaternion quat);

void axisAngleToRotMatrix(float angle, float axis[3], TMatrix4 rotMat);
void rotateByRotMatrix(float point[3],TMatrix4 rotMat);

#endif

