/*
menu.cpp

Mirage Menus


Version 1.11

(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 

*/
#include "stdafx.h"  

miMenu_c * currentMenu=NULL;

/* 
#include "menu.h"
#include "mirage.h"
#include "gltext.h"      
#include "breakout.h"     
printf 
*/
//**********************************************************************************
// ITEM
//**********************************************************************************

/*
miMenu_c::item_c::item_c(char * name_in)
{
	sprintf(name,"%s",name_in);
}
*/
/*
miMenu_c::item_c::item_c(void)
{
	name[0]=NULL;
}
*/
void miMenu_c::item_c::setFunc(changeFunc_t onUpdate_inn)
{
	//changeFunc_t hi;
	//onChange=onUpdate_inn;
	hi=onUpdate_inn;
}



//**********************************************************************************
// END OF ITEM
//**********************************************************************************




//**********************************************************************************
// MENU CLASS
//**********************************************************************************
void miMenu_c::escapeFunc()
{
	glCls();
	currentMenu=parent;

	if (currentMenu==NULL)
	{
		font.setAlternate(false);
		font.setSize(20,20);
	}
}


void miMenu_c::exitMenus()
{
	glCls();
	currentMenu=NULL;

	font.setAlternate(false);
	font.setSize(20,20);
}


void miMenu_c::KeysIn()
{
	if (keyJustPressed(DIK_ESCAPE))
	{
//		if (escFunc!=NULL)
//			(*escFunc)();
		escapeFunc();
	}
	if (keyJustPressed(DIK_UP))
	{
		--selector;
		if (selector<0) selector=numItems-1;
		while(item_p[selector]->getType()==MENU_DIVIDER)
		{
			--selector;
			if (selector<0) selector=numItems-1;
		}
	}

	if (keyJustPressed(DIK_DOWN))
	{
		++selector;
		if (selector>=numItems) selector=0;
		while(item_p[selector]->getType()==MENU_DIVIDER)
		{
			++selector;
			if (selector>=numItems) selector=0;
		}
	}
	
	if (keyJustPressed(DIK_RIGHT) || keyJustPressed(DIK_RETURN))
	{
		item_p[selector]->slide(true);
	}
	if (keyJustPressed(DIK_LEFT))
	{
		item_p[selector]->slide(false);
	}  
	init();
	
	
}




void miMenu_c::addItem(	char * name_in, 
						int type_in, 
						changeFunc_t onUpdate_in,
						int initValue,
						char * text0, 
						char * text1, 
						char * text2,
						char * text3)					
{

	itemSwitch_c * current;

	//allocate memory for item
	switch(type_in)
	{
		case MENU_SWITCH:
			//create the item
			if (initValue==NULL) initValue=0;
			item_p[numItems]=new itemSwitch_c(name_in,initValue);

			current=(itemSwitch_c*)item_p[numItems];

			if (text0 != NULL) current->setOptionText(text0);
			if (text1 != NULL) current->setOptionText(text1);
			if (text2 != NULL) current->setOptionText(text2);
			if (text3 != NULL) current->setOptionText(text3);
		break;

		case MENU_THING:
			//create the item 
			item_p[numItems]=new itemThing_c(name_in);
		break;

		case MENU_SLIDER:  
			//create the item
			item_p[numItems]=new itemSlider_c(name_in,initValue);
		break;

		case MENU_DIVIDER:
  			item_p[numItems]=new itemDivider_c(name_in);
		break;

		default:
			glPrintf("\nERROR: INVALID MENU OPTION\n");
			--numItems;
	} 

	item_p[numItems]->setFunc(onUpdate_in);
	++numItems;
	
}

miMenu_c::miMenu_c(char * namein)
{
//	numItemsAdded=0;
	numItems=0;
	setTitle(namein);
	escFunc=NULL;
	parent=NULL;
	//TEMP
	//genItems(2);
}

miMenu_c::miMenu_c()
{
	numItems=0;
	//escFunc=NULL;
	parent=NULL;
}

miMenu_c::~miMenu_c(void)
{
	int a;

	for (a=0;a<numItems;++a)
	{
		delete [] item_p[a];
	}
}


void miMenu_c::setTitle(char * nameIn)
{
		sprintf(title,"%.50s",nameIn);
}

void miMenu_c::display(void)      
{
	int a;

	//drawGrayRect(-0.5,18,298,292,462);
	drawGrayRect(-0.3,20,100,320,460);

	glCls();

	glPrintSymbol(0);
	glPrintSymbol(0);
	glPrintSymbol(0);
	glPrintf("\n         %s\n\n",title);
	for (a=0;a<numItems;++a)
	{
		glPrintSymbol(0);
		glPrintSymbol(0);
		glPrintSymbol(0);
		if (selector==a) glPrintf(">");
		else glPrintSymbol(0);
		glPrintSymbol(0);
		item_p[a]->display();
	}

	//brightness=-0.3;//+gamebrightness;

	//keysin();




	//call parent menu if there is one
//	if (parent!=NULL) parent->execute(NULL);

	//blank parent menu to avoid confusion later if menu is called as a root menu
//	parent=NULL;
	//glCls();
}

void miMenu_c::execute()
{
	font.setAlternate(false);
	font.setSize(32,32);
	init();
	postInit();
	parent=currentMenu;
	currentMenu=this;

}

void miMenu_c::init()
{
	int a;

	for (a=0;a<numItems;++a)
	{
		item_p[a]->reset();
	}

}

//**********************************************************************************
// END OF MENU CLASS
//**********************************************************************************
