/*

___________________________________________________________________

				Mirage 3D engine
				"mirage.cpp"
				(c) copyright 2002 Ben Woodhouse
___________________________________________________________________ 

 
link to: opengl32.lib glu32.lib ijl.lib
		(optimize for speed)

  Version 2.3

(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 

	   

 */




//************************************* **************

#include "stdafx.h"

#include <winuser.h> 
#ifndef WM_MOUSEWHEEL
#define WM_MOUSEWHEEL 0x020A
#endif



//GLOBALS

Mouse mouse;

Viewport * currentVP;

float col_white[3]={1,1,1};
float col_grey[3]={0.5,0.5,0.5};
float col_orange[3]={1,0.5,0};
float col_green[3]={0,1,0};
float col_blue[3]={0,0,1};

//for ID textures
int IDstartCol; //increases every time an ID texture is created to keep ID textures unique;
				//must be reset after ID textures are no longer needed

//testcube stuff
int numTilesDrawn=0;

float cube_ver[8][3]=	
				{
					0,0,0,
					1,0,0,
					1,0,1,
					0,0,1,

					0,1,0,
					1,1,0,
					1,1,1,
					0,1,1					
				};

//anticlockwise cube tri defs
int cube_tri[12][3] = 
					{
						0,2,1,
						0,3,2,

						0,7,3,
						0,4,7,

						3,7,6,
						3,6,2,

						1,2,6,
						6,5,1,

						0,1,5,
						5,4,0,

						5,6,7,
						7,4,5

						
					};




//LIGHTS
light_t light;

//TEMP
int myfire;


float lightc[4]={1.0, 1, 1, 1.0};  //light colour

//display lists
GLuint obListNames;



ground_t ground;

//gl info 

gl_info_t gl_info;

//particle arrays
int mypart;
//int lightPart[8];
int lightPart;

//*********




//*********
//SETUP
//*********

//*********



//*********
//ENGINE
//*********

//*********





//*********
//TEXTURES
//*********

//*********




//*********
//OBJECTS
//*********

//*********




//*********
//GLTEXT
//*********

	





//*********
//SHADOWS
//*********

//*********




//*********
//TESTQUAD
//*********

//*********




//*********
//SELECTTRI
//*********

//*********




//*********
//USERINPUT
//*********


//*********




//*********
//PARTICLES
//*********

//*********


//texture array
//GLuint texNum[MAX_TEXTURES];
//GLsizei numTextures=0;

//CAMERA STUFF
float movex=0, movey=0;

//radius (radius move is blah)
float radius=4;


//REQUIRED BY WINDOWS

//*******************************************************
LRESULT CALLBACK AppWndProc(HWND hWndL,UINT msg,WPARAM wParam,LPARAM lParam);

//LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

char lpszAppName[] = "My Game";

HWND ghWnd;
HGLRC hRC;	 //openGL rendering context
HDC hDC;	 //window device context


//*******************************************************


//*********  necessary for shadows and lighting *************

GLfloat shadowMat[4][4];

GLfloat lightpos[4]={0.6727, 0.3648, 0.6437, 0};

//***********************************************************

		 	 
//performance counter variables
double fpsgone;

__int64 timestart,timeend,fpstimestart,fpstimeend;
__int64 perfreq;  


//lighting	  
GLfloat	ambientProperties[] = {0.5, 0.5, 0.5, 0.5}; 
GLfloat	diffuseProperties[] = {1.0, 1,1, 1}; 
GLfloat	specularProperties[] = {specular, specular, specular, 0};

GLfloat	fireamb[] = {0.5, 0.3, 0, 1};
GLfloat	firedif[] = {0.5, 0.3, 0, 1};
GLfloat	firespec[] = {1, 0.9, 0, 1};


//FPS timer variables
int frames=0;
DWORD timea,timeb,speedstart,speeddif;


//*************** camera stuff ***********************

	//viewpoint position and angles
//	viewport_t * vp[2];

	//speed at which pos moves
	float blah=0.00;		  

	//speed modifier for game
	float gameSpeed=1;

	//frame rate related speed modifier
	double speedmod=1;		

//cursor stuff
int	oldcursx,oldcursy;
int mousex,mousey;	
long cx,cy;

	  
//temporary showing off stuff
float fallVel=0;
int fireFall;
BOOL fall=FALSE;
int groundtexture=1;					   

GLUquadricObj *sphereOb;


//********
//Switches
//*******
//program quit switch
BOOL sw_gameMove=FALSE;
BOOL Quit=FALSE;

BOOL SW_vertexArrays=TRUE;

BOOL SW_test=FALSE;
BOOL SW_wideLens=FALSE;
BOOL SW_displayList=FALSE; //use display lists ON/OFF

BOOL fullscreen=TRUE;
BOOL programActive=TRUE;

BOOL shadows=FALSE;

BOOL firstrun=1;
BOOL mouselook=0;

BOOL bench=0;

BOOL sw_sky=initsky;
BOOL mipmap=TRUE;
BOOL SW_COMPLEX=TRUE;

BOOL SW_FOG=FALSE;
BOOL sw_drawWithoutGL=FALSE;
BOOL sw_zoom=FALSE;
BOOL movecursor=FALSE;



display_c display;

ViewFrustum viewFrustum;

void drawGrayRect(float bright,float left,float bottom,float right,float top)
{
	screen.push2D();
		glPushAttrib(GL_ENABLE_BIT);
			glEnable(GL_BLEND);
			glDisable(GL_TEXTURE_2D);
			setTextureLevel(0);


			if (bright<0)
			{
				glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
				glColor4f(0,0,0,-bright*1.5); 
			}
			else
			{
				glBlendFunc(GL_ONE,GL_ONE);
				glColor4f(bright/2,bright/2,bright/2,bright/2);
			}

			glBegin(GL_QUADS);
				glVertex2i(left,bottom);
				glVertex2i(right,bottom);
				glVertex2i(right,top);
				glVertex2i(left,top);

			glEnd();
			
		glPopAttrib();
	screen.pop2D();
}

void display_c::clear()
{
		if (UO.stencil) 
			glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);

		else
			glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);


}









void pause(void)
{
	screen.update();
	glGetch();
}

void displayTitle(CTexture * tex,BOOL fullscreen)
{
	//glBindTexture(GL_TEXTURE_2D,texNum[tex]); 
	tex->bind();
	screen.push2D();
				
		glBegin(GL_QUADS);
			glTexCoord2f(0,0);
			glVertex2f(0,0);

			glTexCoord2f(1,0);
			glVertex2f(screen.sizex,0);

			glTexCoord2f(1,1);
			glVertex2f(screen.sizex,screen.sizey);

			glTexCoord2f(0,1);
			glVertex2f(0,screen.sizey);
		glEnd();
	screen.pop2D();
}


//TRANSFER
void colorDepthUpdate(BOOL tf)
{
	glColorMask(tf,tf,tf,tf);
	glDepthMask(tf);
}


//TRANSFER

void setStencil(int value)
{
	//call to enable drawing to cause a stencil (value) to be set
	glStencilOp(GL_KEEP, GL_REPLACE, GL_REPLACE);
	glStencilFunc(GL_ALWAYS, value, 0xffffffff);
}
//TRANSFER

void drawOnStencil_once(int value)
{
	//call to enable drawing on a specific stencil
	glStencilOp(GL_KEEP, GL_ZERO, GL_ZERO);
	glStencilFunc(GL_EQUAL, value, 0xffffffff);
}

//TRANSFER

void drawOnStencil(int value)
{
	//call to enable drawing on a specific stencil
	glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);
	glStencilFunc(GL_EQUAL, value, 0xffffffff);
}





//TRANSFER:
BOOL stencilDetect(void)
{
	int bits;
	glGetIntegerv(GL_STENCIL_BITS,&bits);
	if (bits>7) return TRUE;
	else return FALSE;

}





//get frustum data from viewport data
void getFrustum (float *left, float *right, float *bottom, float *top)
{
	float vay,vax;

	vay=currentVP->viewangle/rade;
	vax=vay*currentVP->aspect;
	
	*top=tan((vay/2.0))*currentVP->nearclip;
	*bottom=-*top;

	*right=*top*currentVP->aspect;
	*left=-*right;
}

//a useful lil function for toggling bools
void toggle(BOOL * sw)
{
	*sw=1-*sw;
} 



void createLight(void)  //FIXME: expand this later to take light_t * etc
{
//	int a;

	light.pos[0]=16;
	light.pos[1]=24;
	light.pos[2]=16;

	light.color[0]=0;
	light.color[1]=1;
	light.color[2]=0;

	light.size=2;
	/*
	light.particle=createParticle(	PART_STATIC,light.pos[0],light.pos[1],
									light.pos[2],light.size,0,col_white);*/
/*
	for (a=0;a<3;++a)
	{
		particle[light.particle].color[a]=light.color[a];
	}*/
}

void setFog(void)
{

	GLfloat fogColor[4]={0.2 ,0.2 ,1};

	//FOG is shite
	glEnable(GL_FOG);
	glFogi(GL_FOG_START,45);
	glFogi(GL_FOG_END,50);
	glFogi(GL_FOG_MODE,GL_LINEAR);

	//glFogfv(GL_FOG_COLOR,fogColor);
}







void fullScreenToggle(void)
{
	//FD specific
	if (fullscreen)
	{
		resetScreenSize();
		glCls();
		glPrintf("Fullscreen: OFF\n");
	}
	else
	{
		glCls();
		setScreenSize(640,480);
		glPrintf("Fullscreen: ON\n");
	}
}



//for initializing minitextures
BOOL resetScreenSize(void)
{
	LONG res;

	res=ChangeDisplaySettings(NULL, CDS_FULLSCREEN);
	if (res==DISP_CHANGE_SUCCESSFUL) 
	{
		fullscreen=FALSE;
		return TRUE;
	}
	else return FALSE;
}



BOOL setScreenSize(int x,int y)
{
	LONG res;

	DEVMODE dm;
	memset(&dm, 0, sizeof(DEVMODE));
	dm.dmSize = sizeof(DEVMODE);
	dm.dmPelsWidth = x; 
	dm.dmPelsHeight = y;
	dm.dmFields = DM_PELSWIDTH | DM_PELSHEIGHT;

	res=ChangeDisplaySettings(&dm, CDS_FULLSCREEN);
	if (res==DISP_CHANGE_SUCCESSFUL) 
	{
		fullscreen=TRUE;
		return TRUE;
	}
	else return FALSE;
}








void drawBox(float bottom,float left, float top, float right)
{

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
		glLoadIdentity();
		glOrtho (0.0, screen.sizex, 0.0, screen.sizey, 0.0, 1.0);

		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
			glLoadIdentity();
			glPushAttrib(GL_ENABLE_BIT);  
				glEnable(GL_BLEND);
    			glDisable(GL_DEPTH_TEST);
				glDisable(GL_LIGHTING);
				glDisable(GL_CULL_FACE);
				//glDisable(GL_TEXTURE_2D);
				setTextureLevel(0);
				glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
			
				
				glBegin(GL_LINE_LOOP);
					glVertex2f(left,bottom);
					glVertex2f(left,top);
					glVertex2f(right,top);
					glVertex2f(right,bottom);
				glEnd();
				
			glPopAttrib();
		glPopMatrix();
		glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
}

//redraws the display for the minitexture choose routine

				











void drawQuad(BOOL texture,float size) 
{
	float half=size/2;

	if (texture)
	{
		glBegin(GL_QUADS);
		
			glNormal3f(0,0,-1);
			glTexCoord2f(-half/2,-half/2);
			glVertex2f(-half,-half);

			glNormal3f(0,0,-1);
			glTexCoord2f(-half/2,half/2);
			glVertex2f(-half,half);

			glNormal3f(0,0,-1);
			glTexCoord2f(half/2,half/2);
			glVertex2f(half,half);

			glNormal3f(0,0,-1);
			glTexCoord2f(half/2,-half/2);
			glVertex2f(half,-half);

		glEnd();
	}
	else
	{
		glBegin(GL_QUADS);
		
			glVertex2f(-half,-half);

			glVertex2f(-half,half);

			glVertex2f(half,half);

			glVertex2f(half,-half);

		glEnd();
	}
}






void addText(char * addThis, char * text)
{
	int a=0,b=0;

	//find the end
	while (text[a]!=NULL) ++a;
	
	//add the text
	while (addThis[b]!=NULL)
	{
		text[a]=addThis[b];
		++a;
		++b;
	}
	text[a]=NULL;
	
}



BOOL findDot(char * text)
{
	BOOL rv=FALSE;
	int a=0;

	while (text[a]!=NULL)
	{
		if (text[a]=='.') rv=TRUE;
		++a;
	}
	return rv;
}


















void userInput(void)
{
	/*if (inputcount==0) 
	{
		DI_keysin();
		inputcount=5;
	} */
	DI_keysin();
}













						





//******************GRAPHICS SETUP ROUTINES********************	


HGLRC setupGL(HWND hWnd)
{
	PIXELFORMATDESCRIPTOR pfd = { 
		sizeof(PIXELFORMATDESCRIPTOR),   // size of this pfd 
		1,                     // version number 
		PFD_DRAW_TO_WINDOW |   // support window 
		PFD_SUPPORT_OPENGL | // support OpenGL 
		PFD_DOUBLEBUFFER,      // double buffered 
		PFD_TYPE_RGBA,         // RGBA type  
		32,                    // -bit color depth 
		0, 0, 0, 0, 0, 0,      // color bits ignored 
		0,                     // alpha buffer 
		0,                     // shift bit ignored 
		0,                     // accumulation buffer 
		0, 0, 0, 0,            // accum bits ignored 
		32,                    // -bit z-buffer  
		0,                     // stencil buffer 
		0,                     // auxiliary buffer 
		PFD_MAIN_PLANE,        // main layer 
		0,                     // reserved 
		0, 0, 0                // layer masks ignored 
	}; 

	int  iPixelFormat; 
    HGLRC rv = 0;

	hDC = GetDC(hWnd);
	if (hDC)
	{
   		iPixelFormat = ChoosePixelFormat(hDC, &pfd);
		if ( iPixelFormat )
		 {
			if ( SetPixelFormat(hDC, iPixelFormat, &pfd) )
			  {
				rv = wglCreateContext( hDC );
				if ( rv )
					{
					if ( !wglMakeCurrent( hDC, rv ) )
						 {
						wglDeleteContext( rv );
						rv = 0;
					}
				}
			}
		}
	}
    return rv;
}



//the shutting down function
void uninitialize()
{
	game_shutdown();
	if (UO.sound) sound_uninitialize();
	DI_term();						//kill direct input
	uninitTextures();
//	glDeleteTextures(MAX_TEXTURES,texNum);	//delete textures
	killGL(ghWnd);					//release RC and DC
	
	resetScreenSize();				//reset the screen size

	music.uninit();
//	MessageBox(ghWnd,"Everything is shut down.","OK",MB_OK);
	//DestroyWindow(ghWnd);			//destroy the window explicitly
}









			

void info_display(void)
{	
	int partz=0;

//	brightness-=0.3;
//	glCls();
//	glPrintf("%d of %d particles used\n",partz,MAX_PARTICLES);

	glPrintf("INFO DISPLAY\n\n");
	glPrintf("Color Bits: %d\n",gl_info.colorBits);
	glPrintf("stencil: %d\n",UO.stencil);
	glPrintf("speedmod: %f\n",speedmod);
/*	glPrintf("vp.pos[0]: %f\n",vp.pos[0]);
	glPrintf("vp.pos[1]: %f\n",vp.pos[1]);
	glPrintf("vp.pos[2]: %f\n",vp.pos[2]);

	glPrintf("vp.rot[0]: %f\n",vp.rot[0]);
	glPrintf("vp.rot[1]: %f\n",vp.rot[1]);
	glPrintf("vp.rot[2]: %f\n",vp.rot[2]);*/

	glPrintf("GL_INFO: \n VENDOR:%s\nRENDERER:%s\nVERSION:%s\nEXTENSIONS:%s\n"
		,gl_info.vendor,gl_info.renderer,gl_info.version,gl_info.extensions);

	pause();
//	glCls();
//	brightness+=0.3;


/*	
	glPrintf("vp.pos[0]:%f\n",vp.pos[0]);
	glPrintf("vp.pos[1]: %f\n",vp.pos[1]);
	glPrintf("vp.pos[2]: %f\n",vp.pos[2]);
	glPrintf("\nvp.rot[1]: %f\n",vp.rot[1]);
	glPrintf("vp.rot[0]: %f\n",vp.rot[0]);
	glPrintf("radius: %f\n",radius);
	glPrintf("\nnumobjects: %d\n",numobjects);
	glPrintf("\n\nspeedmod: %lf\n",speedmod);
*/

}
									   



LRESULT CALLBACK AppWndProc(HWND hWndL,UINT msg,WPARAM wParam,LPARAM lParam)
{ 
	short wheelDir;

	switch(msg)
	{			
		case WM_MOUSEWHEEL:
			wheelDir = HIWORD(wParam);    // wheel rotation

			if (wheelDir>0)
			{
				mouse.setMouseWheel(1);
			}
			else
			{
				mouse.setMouseWheel(-1);
			}
		break;
		case WM_LBUTTONDOWN:
			mouse.setLButtonDown();
		break;
		case WM_LBUTTONUP:
			mouse.setLButtonUp();
		break;

		case WM_RBUTTONDOWN:
			mouse.setRButtonDown();
		break;
		case WM_RBUTTONUP:
			mouse.setRButtonUp();
		break;

		case WM_MBUTTONDOWN:
			mouse.setMButtonDown();
		break;
		case WM_MBUTTONUP:
			mouse.setMButtonUp();
		break;




		case WM_CREATE:
		return 0;
   
		case WM_SIZE:
		screen.resize(LOWORD(lParam),HIWORD(lParam));
		break; 
		
		case WM_ACTIVATE:
			//FD specific for PSP and imagine compatibility
			if (wParam==WA_INACTIVE)
			{
				if (keyboardI) keyboardI->Unacquire();
	//			programActive=FALSE;
			}
			else
			{
				if (keyboardI) keyboardI->Acquire();
				programActive=TRUE;
			}
			return TRUE;
		break;


		case WM_NWCLIENTMULTICAST:
			//client.handleMulticastMsg(wParam,lParam);
			//glPrintf("msg");
			client.handleMsg(wParam,lParam);
		break;
/*
		case WM_NWSERVERMULTICAST:
//			server.handleMulticastMsg(wParam,lParam);
//			server.handleMsg(wParam,lParam);
		break;*/
/*
		case WM_NWCLIENT:

			//some network event has occurred
			client.handleMsg(wParam,lParam);
		break;



		case WM_NWSERVER:

			//message received from the server
			server.handleMsg(wParam,lParam);
		break;
*/

		case WM_CLOSE:
			PostQuitMessage(0);
		break;

													 	
		case WM_DESTROY:
		return 0L;  // Terminate Application

		default:
		return DefWindowProc(hWndL,msg,wParam,lParam);
	}
	return 0L; 

}


void pushshadow(float shade)
{
	glDepthMask(GL_FALSE);
	glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glDisable(GL_LIGHTING);  /* Force the 50% black. */
//	glDisable(GL_TEXTURE_2D);
	setTextureLevel(0);
	
 
    glColor4f(0.0, 0.0, 0.0, shade);
	glPushMatrix();			

    glMultMatrixf((GLfloat *) shadowMat);
}

void popshadow(void)
{
	glDepthMask(GL_TRUE);

    glPopMatrix();
    glEnable(GL_LIGHTING);  
//	glEnable(GL_TEXTURE_2D);
	setTextureLevel(GL_TEXTURE_2D);


//   	if (polyoffset) glPolygonOffset(0, 0);

	glDisable(GL_BLEND);
}




void shadowmatrix(GLfloat litepos[4],GLfloat plane[4])
{
  GLfloat dot;
									   
  // Find dot product between light position vector and ground plane normal. 
  dot = plane[0] * litepos[0] +
  plane[1] * litepos[1] +
  plane[2] * litepos[2] +
  plane[3] * litepos[3];

  //ax+by+cz+d=0

  shadowMat[0][0] = dot - litepos[0] * plane[0];
  shadowMat[1][0] = 0.f - litepos[0] * plane[1];
  shadowMat[2][0] = 0.f - litepos[0] * plane[2];
  shadowMat[3][0] = 0.f - litepos[0] * plane[3];

  shadowMat[0][1] = 0.f - litepos[1] * plane[0];
  shadowMat[1][1] = dot - litepos[1] * plane[1];
  shadowMat[2][1] = 0.f - litepos[1] * plane[2];
  shadowMat[3][1] = 0.f - litepos[1] * plane[3];

  shadowMat[0][2] = 0.f - litepos[2] * plane[0];
  shadowMat[1][2] = 0.f - litepos[2] * plane[1];
  shadowMat[2][2] = dot - litepos[2] * plane[2];
  shadowMat[3][2] = 0.f - litepos[2] * plane[3];

  shadowMat[0][3] = 0.f - litepos[3] * plane[0];
  shadowMat[1][3] = 0.f - litepos[3] * plane[1];
  shadowMat[2][3] = 0.f - litepos[3] * plane[2];
  shadowMat[3][3] = dot - litepos[3] * plane[3];

}









void resetlighting(void)
{
    glLightfv( GL_LIGHT0, GL_AMBIENT, ambientProperties);
    glLightfv( GL_LIGHT0, GL_DIFFUSE, lightc);
    glLightfv( GL_LIGHT0, GL_SPECULAR, specularProperties);


}



void drawSphere(float radius,int slices,int stacks)
{
	gluQuadricDrawStyle (sphereOb, GLU_FILL);
	gluQuadricNormals (sphereOb, GLU_SMOOTH);
	gluQuadricTexture (sphereOb, GL_TRUE);
	gluSphere (sphereOb, radius, slices, stacks);
}










int random(int limit)
{
	int out;
	double raw;

	raw=rand();
	out=(raw/32768.0)*limit;

	return out;
}





void texbox(float dx, float dy, float dz,float tsx, float tsy)
{
	float tx,ty;
	dx=dx/2.0;
	dy=dy/2.0;
	dz=dz/2.0;

	tx=(dx*2.0)/tsx;
	ty=(dz*2.0)/tsy;



	glBegin(GL_QUADS);

	//top
	glNormal3f(0,1,0);
	glTexCoord2f(tx,0); glVertex3f(-dx,dy,-dz);
	glTexCoord2f(tx,ty); glVertex3f(-dx,dy,dz);    
	glTexCoord2f(0,ty); glVertex3f(dx,dy,dz);	
	glTexCoord2f(0,0); glVertex3f(dx,dy,-dz);

	
	glNormal3f(0,-1,0);
	glTexCoord2f(0,0); glVertex3f(-dx,-dy,-dz);
	glTexCoord2f(tx,0); glVertex3f(dx,-dy,-dz);
	glTexCoord2f(tx,ty); glVertex3f(dx,-dy,dz);
	glTexCoord2f(0,ty); glVertex3f(-dx,-dy,dz);  

	//front
	tx=(dx*2.0)/tsx;
	ty=(dy*2.0)/tsy;
	glNormal3f(0,0,-1);
	glTexCoord2f(0,0); glVertex3f(-dx,dy,-dz);
	glTexCoord2f(tx,0); glVertex3f(dx,dy,-dz);
	glTexCoord2f(tx,ty); glVertex3f(dx,-dy,-dz);
	glTexCoord2f(0,ty); glVertex3f(-dx,-dy,-dz);

	glNormal3f(0,0,1);
	glTexCoord2f(tx,0); glVertex3f(-dx,dy,dz);
	glTexCoord2f(tx,ty); glVertex3f(-dx,-dy,dz);	
	glTexCoord2f(0,ty); glVertex3f(dx,-dy,dz);	
	glTexCoord2f(0,0); glVertex3f(dx,dy,dz);
 			
	//side
	tx=(dy*2.0)/tsx;
	ty=(dz*2.0)/tsy;
	glNormal3f(1,0,0);
	glTexCoord2f(0,0); glVertex3f(dx,dy,-dz);
	glTexCoord2f(tx,0); glVertex3f(dx,dy,dz);    
	glTexCoord2f(tx,ty); glVertex3f(dx,-dy,dz);  	
	glTexCoord2f(0,ty); glVertex3f(dx,-dy,-dz);


 	glNormal3f(-1,0,0);
	glTexCoord2f(tx,0); glVertex3f(-dx,dy,-dz);
	glTexCoord2f(tx,ty); glVertex3f(-dx,-dy,-dz);	
	glTexCoord2f(0,ty); glVertex3f(-dx,-dy,dz);	
	glTexCoord2f(0,0); glVertex3f(-dx,dy,dz);    
 				
	glEnd();

}





int getMouseX()
{									
    POINT Point;

	GetCursorPos(&Point);

	return Point.x;
}

int getMouseY()
{
    POINT Point;

	GetCursorPos(&Point);

	return Point.y;
}





void speedtest(void)
{
	if (bench==1) 
	{
		//printf("\nFPS test already started");
	}
	else
	{
		bench=1;  
		QueryPerformanceCounter((LARGE_INTEGER *) &fpstimestart);
		//printf("\nFPS test started");		//   QueryPerformanceCounter
		frames=0;
	}									   
}





//*******************************************






int WINAPI WinMain ( HINSTANCE hInst, 
                     HINSTANCE hPrevInstance, 
                     LPSTR lpCmdLine, 
                     int nCmdShow ) 
{ 
	MSG msg; // Windows message structure
	WNDCLASS wc; // Windows class structure
	HWND hWnd;


	//Memory leak detection
	#ifndef NDEBUG
	int flag = _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG);// Get current flag
	flag |= _CRTDBG_LEAK_CHECK_DF; // Turn on leak-checking
	bit_CrtSetDbgFlag(flag); // Set flag to the new value
	#endif    


	// Register Window style

	// winclass variables stolen from Dogfight
	// old window class variables

	wc.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wc.lpfnWndProc =  AppWndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInst;
	wc.hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON1));
	wc.hCursor = LoadCursor(hInst, MAKEINTRESOURCE(IDC_WIZDUELPOINTER));
	wc.hbrBackground = (HBRUSH)GetStockObject( BLACK_BRUSH ); 
	wc.lpszMenuName = NULL;
	wc.lpszClassName = lpszAppName;

	//register the class

	if(RegisterClass(&wc) == 0)
	{
		//or not as the case may be
		return FALSE;
	}
	SetCursor(wc.hCursor); 


 
	//SetSystemCursor(CopyCursor(),MAKEINTRESOURCE(OCR_NORMAL));
	
	// Create the main application window

	hWnd = CreateWindow(
		lpszAppName,
		lpszAppName,
		WS_POPUP | WS_CLIPCHILDREN | WS_CLIPSIBLINGS,
		0, 0,
		640, 480,  
		NULL,
		NULL,
		hInst,
		NULL);


	// If window was not created, quit

	if(hWnd == NULL) return FALSE;


	ghWnd=hWnd;

	// Display the window
	ShowWindow(hWnd,SW_SHOWDEFAULT);
	UpdateWindow(hWnd);
	SetFocus (hWnd);


	CoInitialize(NULL); //init COM

//____________________________________________________________________________
//
//
//   This should go in WM_CREATE, but it doesn't work there, so it won't
//
//____________________________________________________________________________

	hRC = setupGL(hWnd);
	if (!hRC)
	{
		MessageBox (0, "Failed to Create OpenGL Rendering Context.",
							"ERROR", MB_ICONERROR);
		DestroyWindow(hWnd);
	}
 
	if (!setScreenSize(640,480)) 
		Quit=TRUE;
	
//	exit(1);
	initialize();




//____________________________________________________________________________

	
//The Main Loop
/*	while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}*/
//    DWORD dwThreadId, dwThrdParam = 1; 
  //  HANDLE hThread; 

/*    hThread = CreateThread( 
        NULL,                        // no security attributes        
        0,                           // use default stack size        
        (LPTHREAD_START_ROUTINE) checkKey, // thread function        
        &dwThrdParam,                // argument to thread function   
        0,                           // use default creation flags    
        &dwThreadId);				//returns the thread identifier
*/
//	_beginthread((void (__cdecl*)(void *))checkKey,0,NULL);
//	_beginthread(checkKey,0,NULL);
	while (!Quit) 	
	{
		// check for messages
		if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) 
		{
			// handle or dispatch messages
			if (msg.message == WM_QUIT) 
			{
				Quit = TRUE;
			} 
			else 
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		} 
		else 
		{
			if (programActive)
			{
				userInput();
				theGame();
				screen.render();

				//renderAll();
				SwapBuffers(hDC); 

				mouse.update();
				//COMPAT
//				keys.character=0;
			}

		}
	}

	uninitialize();
	CoUninitialize(); //init COM

	return msg.wParam;
}



void killGL(HWND hWnd)
{
	wglMakeCurrent(NULL, NULL);
	wglDeleteContext(hRC);
	ReleaseDC(hWnd,hDC);
}






void initialize(void)
{
    GLdouble	near_plane, far_plane;

//	GLdouble equation[4]={0,0,0,10};

    GLsizei	width, height;		

	GLfloat	cutoff[] = {180.0};
	int rgbBits[3];

	ground.size=10;
	ground.height=-4;


	if (QueryPerformanceFrequency((LARGE_INTEGER *) &perfreq))
	{
		QueryPerformanceCounter((LARGE_INTEGER *) &timestart);
		//printf("\nPerformance counter enabled");
		//printf("\n%ld counts per second",perfreq);
		QueryPerformanceCounter((LARGE_INTEGER *) &timeend);
	//	printf("\nTime elapsed: %ld",timeend-timestart);
	}
	
	else
	{
	//	printf("\nPerformance counter not enabled");
		exit(14);
	}
	
	//glViewport(0, 0, 640, 480);
	//glPixelTransfer
	initTextures();
//	initParticles();

	//TRANSFER:
//    gl_info.stencil=stencilDetect();
	UO.stencil=0;
//	if (UO.stencil) glEnable(GL_STENCIL_TEST);



/*    lightPart=createParticle(PART_STATIC,
								lightpos[0], lightpos[1], lightpos[2],
								0.4,0,col_white);*/

//	createLight();




	//temporary
	//mypart=createParticle(0,0,0,0);


	srand( (unsigned)time( NULL ) ); 

	width = 640.0;
	height = 480.0;	
	screen.sizex=width;
	screen.sizey=height;

	glClearColor( 0.0, 0.0, 0.0, 1.0 );
	glClearDepth( 1.0 );
	glEnable(GL_DEPTH_TEST);
//	if (polyoffset) glEnable(GL_POLYGON_OFFSET_FILL);
	//glPolygonMode(GL_FRONT,GL_LINE);

	glEnable(GL_LIGHTING);
//	glDisable(GL_CULL_FACE);
	glEnable(GL_CULL_FACE);
	glDepthFunc(GL_LEQUAL);
	glFrontFace(GL_CCW);
	glCullFace(GL_BACK);
	 

//	glEnable(GL_TEXTURE_2D);
	setTextureLevel(GL_TEXTURE_2D);

	//glEnable(GL_BLEND);
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	
	if (smoothshade) glShadeModel(GL_SMOOTH);
	else glShadeModel(GL_FLAT);
    								
	resetlighting();
													 
	glLightModelf(GL_LIGHT_MODEL_TWO_SIDE, 0.0);
//	glLightModelf(GL_LIGHT_MODEL_TWO_SIDE, 1.0);

	glEnable( GL_PROJECTION );

	glEnable( GL_LIGHT0 );

	glMatrixMode( GL_PROJECTION );
	screen.vp[0]->aspect = (GLfloat) width / height;
	glLoadIdentity();
	gluPerspective( screen.vp[0]->viewangle, screen.vp[0]->aspect, 
						screen.vp[0]->nearclip, screen.vp[0]->farclip );
	glEnable(GL_LINE_SMOOTH);

	//HALF HEARTED ATTEMPT AT ANTIALIASING

	//glEnable(GL_POLYGON_SMOOTH);
	//glEnable(GL_BLEND); 
	//glHint(GL_POLYGON_SMOOTH_HINT,GL_NICEST);
	//glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);

	//create some display lists
	



	glMatrixMode( GL_MODELVIEW );

	near_plane = 1.0;
	far_plane = 15.0;
//	maxObjectSize = 3.0;



	//TRANSFER:
	glGetIntegerv(GL_RED_BITS,&rgbBits[0]);
	glGetIntegerv(GL_GREEN_BITS,&rgbBits[1]);
	glGetIntegerv(GL_BLUE_BITS,&rgbBits[2]);
	gl_info.colorBits=rgbBits[0]+rgbBits[1]+rgbBits[2];


	gl_info.vendor=glGetString(GL_VENDOR);
	gl_info.renderer=glGetString(GL_RENDERER);
	gl_info.version=glGetString(GL_VERSION);
	gl_info.extensions=glGetString(GL_EXTENSIONS);


	glHint(GL_POINT_SMOOTH_HINT,GL_NICEST);
	glPointSize(1);
	glEnable(GL_POINT_SMOOTH);

//	glEnable(GL_CLIP_PLANE0);
//	glLoadIdentity();
//	glClipPlane(GL_CLIP_PLANE0,equation);


	///++obCurList;
	//textDisplayList=obCurList+obListNames;
	sphereOb = gluNewQuadric ();
	
/*	glVertexPointer(3,GL_FLOAT,0,ob[0].array.vertex);
	glTexCoordPointer(2,GL_FLOAT,0,ob[0].array.texcoord);
	glNormalPointer(GL_FLOAT,0,ob[0].array.normal);
	*/

/*	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glEnableClientState(GL_NORMAL_ARRAY);*/

	//initialize directInput
	(void)DI_init(ghWnd);
	ghr=DID_init(KEYBOARD_I);

	//initialize directSound
	if (UO.sound) 
	{
		sound_initialize();
	}

	extensions.getNames();
	extensions.linkFunctions();

	//test for an extension
	
	if (extensions.exists("GL_ARB_multitexture"))
	{
//		messageBox("Extension exists");
	}
	else
		messageBox("No ARB_multitexture");
		
	initText(); 
	game_init();
}

					    

		



void theGame(void)  
{
	newMode_check();

	game_mainLoop();

	if (bench==1) 
	{

		if (frames==100)
		{
			QueryPerformanceCounter((LARGE_INTEGER *) &fpstimeend);
			fpsgone=(double) (fpstimeend-fpstimestart)/(double) perfreq;
			glPrintf("\n100 frames in %f seconds",fpsgone);
			
			glPrintf("\n%f fps",100.0/fpsgone);
	
			bench=0;
		}
		++frames;
	}

	QueryPerformanceCounter((LARGE_INTEGER *) &timeend);

	//TRANSFER:
	if (speedmod>0) speedmod=(double) ((timeend-timestart)/(double) perfreq)*100.0;
	else speedmod=0.001;

	//1 speedmod is 100th of a second

	//if a frame takes more than 1/20 of a second, slow down
//	if (speedmod>5)
//	{
//		glPrintf("maxing out");
//		speedmod=5;
//	}

	//TRANSFER:
	//stencilly testy thingy
	/*
	if (speedmod>6 && UO.stencil==TRUE) 
	{
		UO.stencilOffCount--;
	    if (UO.stencilOffCount==0)
		{
			glCls();
			glPrintf("Stencil disabled due to poor frame rate\n");
			if (gl_info.colorBits<17) glPrintf("HINT: Try changing desktop display depth to 32-bit\n");
			UO.stencil=FALSE;

		}
	}
	else UO.stencilOffCount=3;
*/
	QueryPerformanceCounter((LARGE_INTEGER *) &timestart);

	//particle explosion effect

//	doFires();
//	doParticles();
//	particles.move();
//	physics.mainloop();
}



void renderVP(Viewport * view)
{
	int a=0,b=0;

	GLfloat  lightdirection[] = {-45.0,-2.1,60.0}; 
    static GLfloat	angle = 0.0;

	float quadx[] = {0,1,1,0};
	float quady[] = {0,0,0,0};
	float quadz[] = {0,0,1,1};

	float temp[4]={2,2,3};


	currentVP=view;

	//resetlighting();

	glPushMatrix();
		glLoadIdentity();
		currentVP->setViewMatrix();

	//	glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
	
		//TRANSFER: this should be in gamemove
		glColor4f(1,1,1,1);

		game_graphics();
		//particles_render();
		screen.brightnessOverlay();

		glText();
		mouse.display();
	glPopMatrix();
	glFlush();
	glFinish();

	
			
	firstrun=0;
}

