
/*
______________________________

  mirage.h

  (c)2000 Ben Woodhouse

______________________________

  #defines, typedefs, globals and function definitions

  for mirage.cpp

  Version 2.21

*/

//user defined windows messages
#define WM_NWSERVER WM_USER+1
#define WM_NWCLIENT WM_USER+2
#define WM_NWCLIENTMULTICAST WM_USER+3
#define WM_NWSERVERMULTICAST WM_USER+4


//*******************************************
//defines
//*******************************************

/*
#define initRot0 0;
#define initRot1 5;
#define initRot2 3.0;

#define initPos0 0;
#define initPos1 -40;
#define initPos2 0;
*/

#define initRot0 -5;
#define initRot1 0;
#define initRot2 0;

#define initPos0 0;
#define initPos1 0.5;
#define initPos2 3.5;

#define cam_swing 2.4
#define TC_RANGE 200


//DISPLAY LISTS
#define MAX_OB_LISTS 100

//LOADING/SAVING
#define FD_OB_SIZE 76 

//*********
//GLTEXT
//*********
#define SIMPLE 1
#define COMPLEX 0

#define BUFFER_SIZE 100 //buffer size for DI

//viewpoint
#define initsky 1

//lighting
#define smoothshade 1 
#define diffuse 1
#define ambient 1 
#define specular 1.0 

//perspective 
#define VIEWANGLE 70
#define NEARCLIP 4 
#define FARCLIP 1300.0


//*******************************************  
	  

#define screenworld 0.0125		
#define rade 57.2957795	 
#define dera 0.0174532925

							//multiply by rade to convert rads to 
							//degrees, or divide to do convert degrees 
							//to rads
							
			  

//FILE *texin,*objin; 			  

//*******************************************
//				typedefs 
//*******************************************

//*********
//GLOBAL
//*********

//*********
//ENGINE
//*********

class displayList_c
{
	public:
		~displayList_c()
		{
			glDeleteLists(name,1);
		}

		void gen()
		{
			name=glGenLists(1);
		}
 
		void begin()
		{
			glNewList(name,GL_COMPILE);
		}
		void end()
		{
			glEndList();
		}
		void call()
		{
			glCallList(name);
		}
		unsigned int getName()
		{
			return name;			
		}

	protected:
		unsigned int name;
};

class display_c
{
	public:
//		display_c();

		//clears the display if clear flag is set. Otherwise, sets clear
		//flag to ensure display is set next time
		void clear();

};

extern display_c display;

extern Viewport * currentVP;




typedef struct
{
	float pos[3];
	float rot[3]; //possibly

	float color[3];
	float size;
	int particle;
} light_t;

typedef struct 
{
	int sx;
	int sy;

	int ex;
	int ey;
} hp_t; //contains hm pos bounds for a fan, tile, section or landscape







typedef struct
{
	float pos[3];
} obver_t;

typedef struct
{
	int ver[3];
	float norm[3];		//whole tri normal (for working out pNorm)
	float pNorm[3][3]; //point normals		(for drawing)

	float texCo[3][2];  //tex coord [point] [x/y]

	//fd specific
	float depth[3];

	int bb[4];		//bounding box: left, top, right, bottom
	int sx[3];		//tri point screen coords
	int sy[3];  
	BOOL partial; // is tri fully or partially onscreen? (for initclicktri)    
	BOOL select; //(for selection in texmode)
} obtri_t;

//FIXME: this should be malloced according to number of tris
typedef struct
{
	GLfloat vertex[500][3][3];
	GLfloat texcoord[500][3][2];
	GLfloat normal[500][3][3];
	
} vertexArray_t;

//*********



//*********
//GLTEXT
//*********



//*********
//USER INPUT
//*********
//*********





//*********
//PARTICLES
//*********

//*********



//*******************************************
//				Globals
//*******************************************
//int skyBoxTex[6]={};

extern Mouse mouse;

//SOME USEFUL COLOURS
extern float col_white[3];
extern float col_grey[3];
extern float col_orange[3];
extern float col_green[3];
extern float col_blue[3];
//END


//*********
//GLOBAL
//*********

//for ID textures
extern int IDstartCol; //increases every time an ID texture is created to keep ID textures unique;
				//must be reset after ID textures are no longer needed

//testcube stuff
extern int numTilesDrawn;

extern float cube_ver[8][3];

//anticlockwise cube tri defs
extern int cube_tri[12][3];

//LIGHTS
extern light_t light;

//TEMP
extern int myfire;


extern float lightc[4];  //light colour

//display lists
extern GLuint obListNames;




struct ground_t
{
	float height;
	float size;
};

extern ground_t ground;
//gl info 


struct gl_info_t
{
	const GLubyte *vendor;
	const GLubyte *renderer;
	const GLubyte *version;
	const GLubyte *extensions;
	int colorBits;

	BOOL stencil;
};

extern gl_info_t gl_info;

//particle arrays
extern int mypart;
//int lightPart[8];
extern int lightPart;

//*********




//*********
//SETUP
//*********

//*********



//*********
//ENGINE
//*********

//*********





//*********
//TEXTURES
//*********

//*********




//*********
//OBJECTS
//*********

//*********




//*********
//GLTEXT
//*********

	





//*********
//SHADOWS
//*********

//*********




//*********
//TESTQUAD
//*********

//*********




//*********
//SELECTTRI
//*********

//*********




//*********
//USERINPUT
//*********


//*********




//*********
//PARTICLES
//*********

//*********


//extern GLuint texNum[MAX_TEXTURES];
//extern GLsizei numTextures;

//CAMERA STUFF
extern float movex, movey;

//radius (radius move is blah)
extern float radius;


//REQUIRED BY WINDOWS

//*******************************************************
LRESULT CALLBACK AppWndProc(HWND hWndL,UINT msg,WPARAM wParam,LPARAM lParam);

//LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

extern char lpszAppName[];

extern HWND ghWnd;
extern HGLRC hRC;	 //openGL rendering context
extern HDC hDC;	 //window device context


//*******************************************************


//minimise glBindTexture calls by drawing all like textures together

//*********  necessary for shadows and lighting *************

extern GLfloat shadowMat[4][4];

extern GLfloat lightpos[4];

//***********************************************************

		 	 
//performance counter variables
extern double fpsgone;

extern __int64 timestart,timeend,fpstimestart,fpstimeend;
extern __int64 perfreq;  


//lighting	  
extern GLfloat	ambientProperties[];
extern GLfloat	diffuseProperties[];
extern GLfloat	specularProperties[];

extern GLfloat	fireamb[];
extern GLfloat	firedif[];
extern GLfloat	firespec[];


//FPS timer variables
extern int frames;
extern DWORD timea,timeb,speedstart,speeddif;


//*************** camera stuff ***********************

	//speed at which pos moves
	extern float blah;		  

	//speed modifier for game
	extern float gameSpeed;

	//frame rate related speed modifier
	extern double speedmod;		

//cursor stuff
extern int	oldcursx,oldcursy;
extern int mousex,mousey;	
extern long cx,cy;

	  
//temporary showing off stuff
extern float fallVel;
extern int fireFall;
extern BOOL fall;
extern int groundtexture;					   

extern GLUquadricObj *sphereOb;


//********
//Switches
//*******
//program quit switch
extern BOOL sw_gameMove;
extern BOOL Quit;

extern BOOL SW_vertexArrays;

extern BOOL SW_test;
extern BOOL SW_wideLens;
extern BOOL SW_displayList; //use display lists ON/OFF

extern BOOL fullscreen;
extern BOOL programActive;

extern BOOL shadows;

extern BOOL firstrun;
extern BOOL mouselook;

extern BOOL bench;

extern BOOL sw_sky;
extern BOOL mipmap;
extern BOOL SW_COMPLEX;

extern BOOL SW_FOG;
extern BOOL sw_drawWithoutGL;
extern BOOL sw_zoom;
extern BOOL movecursor;


//*******************************************
//function definitions
//*******************************************
void pause(void);
void displayTitle(CTexture * tex,BOOL fullscreen);
void colorDepthUpdate(BOOL tf);

BOOL stencilDetect(void);
void setStencil(int value);
void drawOnStencil(int value);
void drawOnStencil_once(int value);

void drawGrayRect(float bright,float left,float bottom,float right,float top);


//game to engine linking functions



//void game_graphicsExt(void);

//ID textures (for lightmap generation)



void drawSphere(float radius,int slices,int stacks);


//useful lil functions
void toggle(BOOL * sw);



//initialize the viewport positions, rotations and perspective



void createLight(void);





void theGame(void); //non rendering stuff


//drawing
void drawBox(float bottom,float left, float top, float right);

void drawQuad(BOOL,float);


//global


BOOL findDot(char *);
void addText(char *,char *);

void initialize(void);
void renderVP(Viewport * view);
void info_display(void);
void speedtest(void);
void orbitdemo(void);




//graphics setup
HGLRC setupGL(HWND);
void killGL(HWND);
void fullScreenToggle(void);
BOOL resetScreenSize(void);
BOOL setScreenSize(int x,int y);

//engine (seperate functions with multiple uses)
int random(int);

void resetlighting(void);
//void fixangles(void);
void texbox(float, float, float, float, float);

//textures

//shadows
void shadowmatrix(GLfloat[4],GLfloat[4]);
void pushshadow(float shade);
void popshadow(void);
void drawreflect(void);


//userinput
void userInput(void);
int getMouseX();
int getMouseY();


void getFrustum (float *left, float *right, float *bottom, float *top);

















