/*
MiscUtils.h
Version 1.12
(c)2001 Ben Woodhouse
*/

#ifndef MiscUtilsH
#define MiscUtilsH

#ifndef BYTE
#define BYTE unsigned char
#endif

#ifndef GLbyte
#define GLbyte signed char
#endif

int round(float val);
int roundup(float val);
int rounddown(float val);
bool strToWstr(const char * str, WCHAR * wstr); //assumes length of doesn't exceed 255
void changeFNFiletype(char * fn,const char * fileType);

void messageBox(const char *format, ...);
void debugPrint(const char *format, ...);


//BYTE functions 
void byteToFloat3(BYTE * bpos, float * fpos);
void getTriNormalB(float * norm,BYTE pointa[3],BYTE pointb[3],BYTE pointc[3]);

//same as above, but normal is in char form
void getTriNormalubB(GLbyte * norm,BYTE pointa[3],BYTE pointb[3],BYTE pointc[3]);

void glVertex3ubv(const BYTE *v);
void glTexCoord2ubv(const BYTE *c);

extern float color4f[4];

float * col3(float r, float g, float b);
float * col4(float r, float g, float b, float a);

//some definitions
//a chunk is what is contained in enclosing braces { }
//a subchunk is any chunk enclosed in a chunk

bool enterSubChunk(FILE * str,char * name);
bool enterChunk(FILE * str,char * name);
//finds and enters the next chunk or subchunk
bool enterNextChunk(FILE * str);

//exits the current chunk
bool exitChunk(FILE * str);

//finds text in the stream in the current chunk 
bool findInStreamChunk(FILE * str, char * text); 

bool findInStream (FILE * str, char * text);
void getStreamText(FILE * str, char * outStr, int maxChars, bool quots=false);
void getStreamLine(FILE * str, char * outStr, int maxChars); 
int getStreamInt(FILE * str);
float getStreamFloat(FILE * str);
void getFilenameFromPath(const char * path,char * filename);




extern float byteScale[3];

#endif