/*
MiscUtils.cpp
Version 1.12

(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/

#include "stdafx.h"


float byteScale[3]={0.0625,0.125,0.0625}; 

float color4f[4]={0,0,0,0};


bool strToWstr(const char * str, WCHAR * wstr)
{
	char c=1;
	int a=0;

	while (c!=NULL && a<255)
	{
		c=str[a];
		wstr[a]=(WCHAR)c;
		++a;
	}
	if (a==255) return false;
	return true;
}

void changeFNFiletype(char * fn,const char * fileType)
{
	//find the write pos
	for (int a=0;fn[a]!=NULL;++a)
	{
		if (fn[a]=='.')
			break;
	}
	
	fn[a]='.';
	++a;

	int ftp=0;

	//write the filetype
	for (int b=a;fn[b]!=NULL;++b)
	{
		fn[b]=fileType[ftp];
		++ftp;
	}
}

void getFilenameFromPath(const char * path,char * filename)
{
	int pos=0;
	for (int a=0;path[a]!=NULL;++a)
	{
		if (path[a]=='\\') pos=-1;
		else filename[pos]=path[a];
		++pos;
		
	}
	filename[pos]=NULL;
}
//COLOUR functions
float * col3(float r, float g, float b)
{
	color4f[0]=r;
	color4f[1]=g;
	color4f[2]=b;
	return color4f;
}

float * col4(float r, float g, float b, float a)
{
	color4f[0]=r;
	color4f[1]=g;
	color4f[2]=b;
	color4f[3]=a;
	return color4f;
}



//BYTE functions
void byteToFloat3(BYTE * bpos, float * flpos)
{
	flpos[0]=bpos[0]*byteScale[0];
	flpos[1]=bpos[1]*byteScale[1];
	flpos[2]=bpos[2]*byteScale[2];
}

void getTriNormalubB(GLbyte * norm,BYTE pointa[3],BYTE pointb[3],BYTE pointc[3])
{
	float pointaf[3],pointbf[3],pointcf[3];
	float normf[3];

	for (int a=0;a<3;++a)
	{
		pointaf[a]=(float)pointa[a]*byteScale[a];
		pointbf[a]=(float)pointb[a]*byteScale[a];
		pointcf[a]=(float)pointc[a]*byteScale[a];
	}

	getTriNormal(normf,pointaf,pointbf,pointcf);
	norm[0]=normf[0]*127;
	norm[1]=normf[1]*127;
	norm[2]=normf[2]*127;
}

void getTriNormalB(float * norm,BYTE pointa[3],BYTE pointb[3],BYTE pointc[3])
{
	float pointaf[3],pointbf[3],pointcf[3];

	for (int a=0;a<3;++a)
	{
		pointaf[a]=(float)pointa[a]*byteScale[a];
		pointbf[a]=(float)pointb[a]*byteScale[a];
		pointcf[a]=(float)pointc[a]*byteScale[a];
	}

	getTriNormal(norm,pointaf,pointbf,pointcf);
}

void glTexCoord2ubv(const BYTE *c)
{
	float cf[3]; 

	cf[0]=(float)c[0]/240; 
	cf[1]=(float)c[1]/240;

	glTexCoord2fv(cf);
}

void glVertex3ubv(const BYTE *v)
{
	float vf[3];

	vf[0]=(float)v[0]*byteScale[0]; 
	vf[1]=(float)v[1]*byteScale[1];
	vf[2]=(float)v[2]*byteScale[2]; 

	glVertex3fv(vf);
}

void debugPrint(const char *format, ...)
{
	char msg[1000];
	int len;
	va_list args;

	//textDisplayList=0; //causes text display list to be updated

	va_start(args,format);

	len=_vsnprintf( msg, 999, format, args);
	glPrintf( "%s",msg);

	va_end( args );

}

void messageBox(const char *format, ...)
{
	char msg[1000];
	int len;
	va_list args;

	//textDisplayList=0; //causes text display list to be updated

	va_start(args,format);
//	numchars+=vsprintf(msg, format, args);
	//len=vsprintf(NULL, format, args);
	len=_vsnprintf( msg, 999, format, args);

	va_end( args );

	MessageBox(ghWnd,msg,"",MB_OK);
}


//gets the next int from a text stream enclosed by special characters
int getStreamInt(FILE * str)
{
	char text[40];
	getStreamText(str,text,40);
	return atoi(text);
}

//gets the next float from a text stream enclosed by special characters
float getStreamFloat(FILE * str)
{
	char text[40];
	getStreamText(str,text,40);
	return (float)atof(text);
}

//gets the next string from a text stream enclosed by special characters
//or quotes
void getStreamText(FILE * str, char * outStr, int maxChars,bool quots)
{
	int charNo=0;
	char ch;

	//find the beginning
	while (!feof(str))
	{
		ch=fgetc(str);


		if (quots)
		{
			if (ch=='"') break;
		}

		else
		{
			if (ch>32) break;
		}
	}
	if (feof(str)) return;

	if (!quots)
	{
		//store the beginning character
		outStr[0]=ch;
		charNo=1;
	}

	//store characters until we find the end
	while (!feof(str) && charNo<(maxChars-1))
	{
		outStr[charNo]=fgetc(str);
		if (quots)
		{
			if (outStr[charNo]=='"') break;
		}
		else
		{
			if (outStr[charNo]<33) break;
		}
		++charNo;
	}
	outStr[charNo]=NULL;
}

//gets the remainder of a line from a stream
void getStreamLine(FILE * str, char * outStr, int maxChars)
{
	int charNo=0;

	while (!feof(str) && charNo<maxChars)
	{
		outStr[charNo]=fgetc(str);
		if (outStr[charNo]==13) break;
		++charNo;
	}
	outStr[charNo]=NULL;
}


bool exitChunk(FILE * str)
{
	long pos=ftell(str);
	int indentLevel=1;
	char inchar;

	while (!feof(str))
	{
		inchar=fgetc(str);
		if (inchar=='{') ++indentLevel;
		if (inchar=='}') --indentLevel;
		if (indentLevel==0) return true;
	}
	fseek(str,pos,SEEK_SET);
	return false;
}

bool enterSubChunk(FILE * str,char * name)
{
	char temp[256];

	sprintf(temp,"%s {",name);
	if (findInStreamChunk(str,temp))
		return true;

	return false;
}

bool enterChunk(FILE * str,char * name)
{
	char temp[256];

	sprintf(temp,"%s {",name);
	if (findInStream(str,temp))
		return true;

	return false;
}

bool enterNextChunk(FILE * str)
{
	long pos=ftell(str);
	while (!feof(str))
	{
		if (fgetc(str)=='{') return true;
	}
	fseek(str,pos,SEEK_SET);
	return false;
}

bool findInStreamChunk(FILE * str, char * text)
{
	//get the current pos
	long pos=ftell(str);
	int indentLevel=1;
	char inchar;

	int charNo=0;
	while (!feof(str) && indentLevel>0)
	{
		if (text [charNo]==NULL) 
			return true;

		inchar=fgetc(str);

		if (inchar=='{') ++indentLevel;
		if (inchar=='}') --indentLevel;

		if (text [charNo]==inchar) 
			++charNo;

		else 
			charNo=0;
	}

	//restore the old stream position
	fseek(str,pos,SEEK_SET);
	return false;
}

//finds a string in a stream. On failure, resets position to where it was
//previously
bool findInStream (FILE * str, char * text)
{
	//get the current pos
	long pos=ftell(str);

	int charNo=0;
	while (!feof(str))
	{
		if (text [charNo]==NULL) 
			return true;

		if (text [charNo]==fgetc(str)) 
			++charNo;

		else 
			charNo=0;
	}

	//restore the old stream position
	fseek(str,pos,SEEK_SET);
	return false;
}


int round(float val)
{
	int ival=(int)val;
	val=val-ival;
	if (val>0.5) ival++;
	return ival;
}

int roundup(float val)
{
	int ival=(int)val;
	val=val-ival;
	if (val>0) ival++;
	return ival;
}

int rounddown(float val)
{
	return (int)val;
}

