/*
Network.cpp

Version 1.0e
Winsock 2.2 Network-play capability

*/
/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/


#include "stdafx.h"
//#include "gameincludes.h"
 

#define INITGUID
DEFINE_GUID(progGUID, 
0x4c85a25, 0xf104, 0x11d5, 0xa0, 0x1e, 0x0, 0x80, 0xad, 0x8, 0x6c, 0xb5);

//use whichever is necessary
CNetwork * networkp=NULL;

CWinsockInit wsInit;

int getCmdType(SOCKET s)
{
	char b;
	int ercode=::recv(s,&b,1,MSG_PEEK);
	if (ercode!=SOCKET_ERROR)
		return b;
	return ercode;
}





/***************************************************************************
 *																									*
 *																									*
 *										CWinsockInit class									*
 *																									*
 *																									*
 *																									*
 ***************************************************************************/

CWinsockInit::CWinsockInit()
{
	// Must be done at the beginning of every WinSock program
	WSADATA w;    // used to store information about WinSock version
	int error = WSAStartup (0x0202, &w);   // Fill in w

	if (error)
	{ // there was an error
		return;
	}
	if (w.wVersion != 0x0202)
	{ // wrong WinSock version!
		WSACleanup (); // unload ws2_32.dll
		return;
	}
}

CWinsockInit::~CWinsockInit()
{
	client.shutdown();
	WSACleanup();
}






/****************************************************************************																			*
 *																			*
 *										Commands							*
 *																									*
 *																									*
 *																									*
 ***************************************************************************/
int cmd_chat(SOCKET s,BYTE player, BYTE toPlayers, char * str)
{
	int rv;

	char * cmd;
	int len=strlen(str);

	//limit the packet size to 255
	if (len>251) len=251;

	cmd=new char[len+5];
	cmd[0]=CMD_CHAT;
	cmd[1]=player;
	cmd[2]=toPlayers;

	cmd[3]=len;


	for (int a=0;a<len;++a)
	{
		cmd[a+4]=str[a];
	}
	rv=::send(s,cmd,len+4,0);


//	cmd[len+4]=NULL;
	
//	glPrintf("Chat '%s'",str);
	delete cmd;

	return rv;
}

int cmd_setID(SOCKET s,BYTE id)
{
	int rv;

	char cmd[2];
	cmd[0]=CMD_SETID;
	cmd[1]=id;
	
	rv=::send(s,cmd,2,0);

	return rv;
}

int cmd_keepAlive(SOCKET s)
{
	int rv;
	char cmd=CMD_KEEPALIVE;

	rv=::send(s,&cmd,1,0);
	return rv;
}







/***************************************************************************
 *																									*
 *																									*
 *										globals													*
 *																									*
 *																									*
 *																									*
 ***************************************************************************/



void getAddressByName(char * name, char * ipOut)
{
	PHOSTENT hostinfo;

	if((hostinfo = gethostbyname(name)) != NULL)
	{
			sprintf(ipOut,"%s", inet_ntoa (*(in_addr*)*hostinfo->h_addr_list) );
	}
}

void getHostAddress(char * ipOut)
{
	char name[255];
	
	if(gethostname(name, sizeof(name))==0)
	{
		getAddressByName(name,ipOut);
	}	
	else ipOut="Error";
}

//translates specified error (if there is one) or the last error
void translateError(int errorCode)
{

//return;//nasty hack
	if (errorCode==-1)
		errorCode=WSAGetLastError();

	switch(errorCode)
	{
		case WSAEWOULDBLOCK:
			messageBox("WSAEWOULDBLOCK");
		break;
		case WSAEINPROGRESS:
			messageBox("WSAEINPROGRESS");
		break;
		case WSAEALREADY:
			messageBox("WSAEALREADY");
		break;
		case WSAENOTSOCK:
			messageBox("WSAENOTSOCK");
		break;
		case WSAEDESTADDRREQ:
			messageBox("WSAEDESTADDRREQ");
		break;
		case WSAEMSGSIZE:
			messageBox("WSAEMSGSIZE");
		break;
		case WSAEPROTOTYPE:
			messageBox("WSAEPROTOTYPE");
		break;
		case WSAENOPROTOOPT:
			messageBox("WSAENOPROTOOPT");
		break;
		case WSAEPROTONOSUPPORT:
			messageBox("WSAEPROTONOSUPPORT");
		break;
		case WSAESOCKTNOSUPPORT:
			messageBox("WSAESOCKTNOSUPPORT");
		break;
		case WSAEOPNOTSUPP:
			messageBox("WSAEOPNOTSUPP");
		break;
		case WSAEPFNOSUPPORT:
			messageBox("WSAEPFNOSUPPORT");
		break;
		case WSAEAFNOSUPPORT:
			messageBox("WSAEAFNOSUPPORT");
		break;

		case WSAEADDRINUSE:
			messageBox("WSAEADDRINUSE");
		break;

		case WSAEADDRNOTAVAIL:
			messageBox("WSAEADDRNOTAVAIL");
		break;

		case WSAENETDOWN:
			messageBox("WSAENETDOWN");
		break;
		case WSAENETUNREACH:
			messageBox("WSAENETUNREACH");
		break;

		case WSAENETRESET:
			messageBox("WSAENETRESET");
		break;

		case WSAECONNABORTED:
			messageBox("WSAECONNABORTED");
		break;

		case WSAECONNRESET:
			messageBox("WSAECONNRESET");
		break;

		case WSAENOBUFS:
			messageBox("WSAENOBUFS");
		break;

		case WSAEISCONN:
			messageBox("WSAEISCONN");
		break;

		case WSAENOTCONN:
			messageBox("WSAENOTCONN");
		break;

		case WSAESHUTDOWN:
			messageBox("WSAESHUTDOWN");
		break;

		case WSAETOOMANYREFS:
			messageBox("WSAETOOMANYREFS");
		break;

		case WSAETIMEDOUT:
			messageBox("WSAETIMEDOUT");
		break;

		case WSAECONNREFUSED:
			messageBox("WSAECONNREFUSED");
		break;

		case WSAELOOP:
			messageBox("WSAELOOP");
		break;

		case WSAENAMETOOLONG:
			messageBox("WSAENAMETOOLONG");
		break;

		case WSAEHOSTDOWN:
			messageBox("WSAEHOSTDOWN");
		break;

		case WSAEHOSTUNREACH:
			messageBox("WSAENOTEMPTY");
		break;

		case WSAENOTEMPTY:
			messageBox("WSAENOTEMPTY");
		break;

		case WSAEPROCLIM:
			messageBox("WSAEPROCLIM");
		break;

		case WSAEUSERS:
			messageBox("WSAEUSERS");
		break;

		case WSAEDQUOT:
			messageBox("WSAEDQUOT");
		break;

		case WSAESTALE:
			messageBox("WSAESTALE");
		break;

		case WSAEREMOTE:
			messageBox("WSAEREMOTE");
		break;

		//regular c errors
		case WSAEINTR:
			messageBox("WSAEINTR");
		break;

		case WSAEBADF:
			messageBox("WSAEBADF");
		break;

		case WSAEACCES:
			messageBox("WSAEACCES");
		break;

		case WSAEFAULT:
			messageBox("WSAEFAULT");
		break;

		case WSAEINVAL:
			messageBox("WSAEINVAL");
		break;

		case WSAEMFILE:
			messageBox("WSAEMFILE");
		break;

		//extended
		case WSASYSNOTREADY:
			messageBox("WSASYSNOTREADY");
		break;

		case WSAVERNOTSUPPORTED:
			messageBox("WSAVERNOTSUPPORTED");
		break;

		case WSAEDISCON:
			messageBox("WSAEDISCON");
		break;

		/*
		case WSAENOMORE:
			messageBox("WSAENOMORE");
		break;

		case WSAECANCELLED:
			messageBox("WSAECANCELLED");
		break;

		case WSAEINVALIDPROCTABLE:
			messageBox("WSAEINVALIDPROCTABLE");
		break;

		case WSAEINVALIDPROVIDER:
			messageBox("WSAEINVALIDPROVIDER");
		break;

		case WSAEPROVIDERFAILEDINIT:
			messageBox("WSAEPROVIDERFAILEDINIT");
		break;

		case WSASYSCALLFAILURE:
			messageBox("WSASYSCALLFAILURE");
		break;

		case WSASERVICE_NOT_FOUND:
			messageBox("WSASERVICE_NOT_FOUND");
		break;

		case WSATYPE_NOT_FOUND:
			messageBox("WSATYPE_NOT_FOUND");
		break;

		case WSA_E_NO_MORE:
			messageBox("WSA_E_NO_MORE");
		break;

		case WSA_E_CANCELLED:
			messageBox("WSA_E_CANCELLED");
		break;

		case WSAEREFUSED:
			messageBox("WSAEREFUSED");
		break;
*/

		default :
			messageBox("Unknown error: %d",errorCode);



		
		
	}
}

int bytesToFloats(char * b, float * f, int numFloats)
{
	for (int a=0;a<numFloats;++a)
	{
		f[a]=bytesToFloat(&b[a*4]);
	}
	return numFloats*4;
}

int floatsToBytes(float * f,char * b, int numFloats)
{
	
	for (int a=0;a<numFloats;++a)
	{
		floatToBytes(f[a],&b[a*4]);		
	}
	return numFloats*4;

}

void floatToBytes(float f, char b[4])
{
	char * a=(char *)&f;

	b[0]=a[0];
	b[1]=a[1];
	b[2]=a[2];
	b[3]=a[3];

	//glPrintf("%d %d\n",i,iPlus1);

//	glPrintf("%f -> %d %d %d %d\n",f,b[0],b[1],b[2],b[3]);
}

float bytesToFloat(char b[4])
{
	float f;
	float * a=(float *)b;

	f=*a;

//	glPrintf("%d %d %d %d -> %f\n",b[0],b[1],b[2],b[3],f);
	return f;
}
