/*
sound.h

(c)copyright 2002 Ben Woodhouse

Version 1.6

Mirage sound engine code - 2 modes: high quality (ds3d) and low quality (ds)
updated for Direct sound 8, and cleaned up (slightly)
*/

#include "Tune.h"

#if     _MSC_VER > 1000
#pragma once
#endif

#ifndef _INC_SOUND
#define _INC_SOUND

#define LOW_QUALITY 0
#define HIGH_QUALITY 1
#define MAX_SOUNDS 32

//these globals really should be in a sound manager class

//globals
extern LPDIRECTSOUND lpDirectSound;	//holds global direct sound object
extern LPDIRECTSOUNDBUFFER primebuf;	//primary buffer
extern float masterVolume;

extern UINT numSounds;

class Sound
{
	friend Sound;
	public:
		Sound();
		BOOL load(const char * soundFN, int channels);			//was sound_loadstatic
		BOOL play(void);	
		BOOL playRepeat(void);
		BOOL stop(void);
		void setExists(){exist=TRUE;}
		BOOL exists(){return exist;}
		void setVolume(float amt);
		void updateVolume();

		void getDuplicate(Sound * soundOut);
		void release(){buf->Release();}
		//was sound_playstatic
 
	private:
		float volume;
		BOOL exist;
		bool playing;
		LPDIRECTSOUNDBUFFER buf;
		//IDirectMusicSegment8 * pSegment;
};


Sound * loadNewSound(const char * filename, int numChannels);
Sound * getNewSound();

extern Sound soundst[MAX_SOUNDS];

BOOL sound_initialize(void);
BOOL sound_uninitialize(void);
void sound_setVolume(float vol);
float sound_getVolume();



BOOL stream_search(FILE * stream,char * text); //should be somewhere else






#endif