/*
splitscreen.cpp

version 1.01
*/

/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/


#include "stdafx.h"

CScreen screen;



void CScreen::update()
{
	render();
	SwapBuffers(hDC);
}

CScreen::CScreen()
{
	brightness=0;
	numViewPorts=1;
	vp[0]=&defaultVP;
	vp[1]=&defaultVP;
	flasher=0;
}

void CScreen::splitScreen(BOOL ssb)
{
	if (ssb)
	{
		numViewPorts=2;
	}
	else numViewPorts=1;
}

void CScreen::render()
{
	int a;

	display.clear();

	doFlasher();

//	if (currentMenu!=NULL)
//		currentMenu->display();

/*
	if (UO.stencil) 
		glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);

	else
		glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
*/
	if (numViewPorts==1)
	{
		glViewport(0, 0, sizex, sizey);  

		renderVP(vp[0]);
	}

	else
	{
		for (a=0;a<2;++a)
		{


			glViewport(0, (sizey/2)*(a), sizex, sizey/2);  
			renderVP(vp[a]);
		
		}
	}

}
/*
void CScreen::setVP(int num, Viewport  * vp_in)
{
	vp[num]=vp_in;
}
*/
void CScreen::setVP3Deg(CThreeDegrees * threeDeg_src, ThreeDegreesCamera  * vp_dst)
{

	(void)memcpy( (float *)vp_dst->rot, (float *)threeDeg_src->rot, sizeof(float)*3);
	(void)memcpy( (float *)vp_dst->pos, (float *)threeDeg_src->pos, sizeof(float)*3);
	(void)memcpy( (float *)vp_dst->axis, (float *)threeDeg_src->axis, sizeof(float)*9);

	copyMatrix(threeDeg_src->rotateMat, vp_dst->rotateMat);
	copyMatrix(threeDeg_src->invRotateMat, vp_dst->invRotateMat);
//	copyMatrix(threeDeg_src->pointlessMat, vp_dst->pointlessMat);
}

void CScreen::resize(GLsizei width, GLsizei height)
{
		//	GLdouble aspect;

		if (height==0)                          
			height=1;

		glViewport(0, 0, width, height);  
		sizex=width;
		sizey=height;
		halfx=width/2;
		halfy=height/2;

		vp[0]->aspect=(GLdouble)width/(GLdouble)height;	
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		gluPerspective(vp[0]->viewangle, vp[0]->aspect, vp[0]->nearclip, vp[0]->farclip);
		glMatrixMode(GL_MODELVIEW);
}

void CScreen::brightnessOverlay()
{
	if (brightness!=0)
	{
		push2D();
			glPushAttrib(GL_ENABLE_BIT);
				glEnable(GL_BLEND);
				glDisable(GL_TEXTURE_2D);
				setTextureLevel(0);


				if (brightness<0)
				{
					//glPrintf("fdsfds %f",brightness);
					glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
					glColor4f(0,0,0,-brightness*1.5);
				}
				else
				{
					glBlendFunc(GL_ONE,GL_ONE);
					glColor4f(brightness/2,brightness/2,brightness/2,brightness/2);
				}

				glBegin(GL_QUADS);
					glVertex2i(0,0);
					glVertex2i(screen.sizex,0);
					glVertex2i(screen.sizex,screen.sizey);
					glVertex2i(0,screen.sizey);
				glEnd();
				
			glPopAttrib();
		pop2D();


	}
}

void CScreen::push2D()
{
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
		glLoadIdentity();
		glOrtho (0.0, sizex, 0.0, sizey, 0.0, 1.0);

		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
			glLoadIdentity();
			glPushAttrib(GL_ENABLE_BIT); 
				glDepthMask(GL_FALSE);
    			glDisable(GL_DEPTH_TEST);
				glDisable(GL_LIGHTING);
				glDisable(GL_CULL_FACE);
}
				

void CScreen::pop2D()
{
				glDepthMask(GL_TRUE);
				
			glPopAttrib();
		glPopMatrix();
		glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
}

void CScreen::doFlasher()
{
	static float flashVal=0;
	flashVal+=0.05*speedmod;
	while (flashVal>6.283185307) 
	{
		flashVal=-12.56637061;
	}
	flasher=(1.0+sin(flashVal))*0.5;
}

