/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/
/*
superSort.cpp
v2.3

*/
#include "stdafx.h"

int * BS_order=0;
int BS_ordercount=0;


void reorder(	float * value,
				int numvals,
				int * order)
{
	float * valuecopy=new float[numvals];
	int a;
	
	for (a=0;a<numvals;++a)
	{
		valuecopy[a]=value[a];
	}

	for (a=0;a<numvals;++a)
	{
		value[a]=valuecopy[order[a]];
	}

	delete [] valuecopy;
}







void bNode_c::bubbleSort()
{
	int a,b;

	floatIndex_t * score=new floatIndex_t[numvalues+1];

	for (a=0;a<numvalues;++a)
	{
		score[a].ID=0;
		score[a].val=2000000000000;
	}

	for (a=0;a<numvalues;++a)
	{
		for (b=numvalues-1;b>-1;--b)
		{
			if (value[a].val<score[b].val)
			{
				//shift old score down
				score[b+1].val=score[b].val;
				score[b+1].ID=score[b].ID;

				//put new score in its place
				score[b].val=value[a].val;
				score[b].ID=value[a].ID;
			}
		}
	}

	for (a=0;a<numvalues;++a)
	{
		BS_order[BS_ordercount]=score[a].ID;
		++BS_ordercount;
	} 
	delete [] score;
}


bNode_c::bNode_c(float maxval_in, float minval_in, floatIndex_t * valuep_in, int numvals)
{
	maxval=maxval_in;
	minval=minval_in;
	midval=((maxval-minval)*0.5)+minval;
	value=valuep_in;
	numvalues=numvals;
	sort();
}


void bNode_c::createChild(int id, float maxval_in, float minval_in, floatIndex_t * valuep_in, int numvals)
{
	child[id]=new bNode_c(maxval_in, minval_in,valuep_in, numvals);
}

void bNode_c::sort()
{
	floatIndex_t * lowvalue;		
	floatIndex_t * highvalue;		

	int a;
	int highcount=0;
	int lowcount=0; 

	float lowmax;

	float highmin;

	if (maxval>minval && numvalues>SUPERSORT_MAGICNUMBER)
	{
		lowvalue=new floatIndex_t[numvalues];		
		highvalue=new floatIndex_t[numvalues];		


		//highmax=maxval;
		highmin=2000000000000;

		lowmax=-2000000000000;
		//lowmin=minval;
			
		//split the values into 2 lists

		for (a=0;a<numvalues;++a)
		{
			if (value[a].val<midval)
			{
				lowvalue[lowcount].val=value[a].val;
				lowvalue[lowcount].ID=value[a].ID;
				
				if (lowvalue[lowcount].val>lowmax) lowmax=lowvalue[lowcount].val;

				++lowcount;
			}
			else
			{
				highvalue[highcount].val=value[a].val;
				highvalue[highcount].ID=value[a].ID;

				if (highvalue[highcount].val<highmin) highmin=highvalue[highcount].val;

				++highcount;
			}
		}
		//create 2 new nodes from the lists
		createChild(0,lowmax,minval,lowvalue,lowcount);
		createChild(1,maxval,highmin,highvalue,highcount);
		delete child[0];
		delete child[1];


		//deletes here
		delete [] lowvalue;
		delete [] highvalue;

	}
	else
	{
		//this is the end of the branch
		//there could be more than one value here (if they are identical) so set them all
		if (maxval==minval)
		{
			for (a=0;a<numvalues;++a)
			{

			//	glPrintf("store order[%d] %f\n",BS_ordercount,value[a].val);
				BS_order[BS_ordercount]=value[a].ID;
				++BS_ordercount;
			}
		}
		else
		{
			//bubble sort the remaining values in this node
			bubbleSort();
		}
	}

}


void superSort(float * valuep_in, 
				int numvals, 
				int * order_out)
{
	floatIndex_t * valuep=new floatIndex_t[numvals];
	int a;

	//find maxval and minval
	float maxval_in=-2000000000000;
	float minval_in=2000000000000;

	for (a=0;a<numvals;++a)
	{
		if (valuep_in[a]>maxval_in)
			maxval_in=valuep_in[a];

		if (valuep_in[a]<minval_in)
			minval_in=valuep_in[a];

	}

	for (a=0;a<numvals;++a)
	{
		valuep[a].ID=a; 
		valuep[a].val=valuep_in[a];
	}
	BS_ordercount=0;
	BS_order=new int[numvals];

	//creates the tree and sorts
	bNode_c btree(maxval_in,minval_in,valuep,numvals);
	//order_out=BS_order;
	for (a=0;a<numvals;++a)
	{
		order_out[a]=BS_order[a];
	}

	delete [] BS_order;


	delete [] valuep;
}


void bubbleSort(float * valuep_in, 
				int numvals, 
				int * order_out)
{
	int a,b;

	floatIndex_t * score=new floatIndex_t[numvals+1];

	for (a=0;a<numvals;++a)
	{
		score[a].ID=0;
		score[a].val=2000000000000;
	}

	for (a=0;a<numvals;++a)
	{
		for (b=numvals-1;b>-1;--b)
		{
			if (valuep_in[a]<score[b].val)
			{
				//shift old score down
				score[b+1].val=score[b].val;
				score[b+1].ID=score[b].ID;

				//put new score in its place
				score[b].val=valuep_in[a];
				score[b].ID=a;
			}
		}
	}

	for (a=0;a<numvals;++a)
	{
		order_out[a]=score[a].ID;
	}
	delete [] score;

}



void autoSort(	float * valuep_in,
				int numvals,
				int * order_out)
{
	if (numvals<AUTOSORT_SUPERSORT_MINVALS)
	{
		bubbleSort(valuep_in,numvals,order_out);
	}
	else
	{
		superSort(valuep_in,numvals,order_out);
	}
}

