/*
superSort.h
v2.3

(c)2001 Ben Woodhouse
*/
 
#define SUPERSORT_MAGICNUMBER 14
#define AUTOSORT_SUPERSORT_MINVALS 39

#include "RadixSort.h"

typedef struct
{
	float val;
	int ID;
} floatIndex_t;

class bNode_c
{
	public:
	bNode_c(float maxval_in, float minval_in, floatIndex_t * valuep_in, int numvals);

	protected:
	void createChild(int id, float maxval_in, float minval_in, floatIndex_t * valuep_in, int numvals);
	void bubbleSort();
	void sort();
	bNode_c * parent; 
	bNode_c * child[2]; //pointers to two child nodes;

	floatIndex_t * value;
	float maxval;
	float minval;
	float midval;

	int numvalues;
};

extern int * BS_order;
extern int BS_ordercount;

//these functions return an order array containing the order of each value

//blindingly fast sort for arrays>14
void superSort(float * valuep_in, 
				int numvals, 
				int * order_out);

//slow sort for arrays >14
void bubbleSort(float * valuep_in, 
				int numvals, 
				int * order_out);

//selects an appropriate sort type and then sorts
void autoSort(	float * valuep_in,
				int numvals,
				int * order_out); 

//reorders values accoring to order list
void reorder(	float * value,
				int numvals,
				int * order);


