/*`
Threedegrees.cpp
v1.0

  base class for objects rotatable through 3 degrees of freedom

(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/

#include "stdafx.h"




void CThreeDegrees::getFrom3ds(CThreeDegrees * t)
{
	for (int a=0;a<3;++a)
	{
		pos[a]=t->pos[a];
		rot[a]=t->rot[a];
		for (int b=0;b<3;++b)
		{
			axis[a][b]=t->axis[a][b];
		}

	}
	for (a=0;a<4;++a)
	{
		quat[a]=t->quat[a];
	}
	copyMatrix(t->rotateMat,rotateMat);
	copyMatrix(t->invRotateMat,invRotateMat);

//	copyMatrix(t->pointlessMat,pointlessMat);

}

void CThreeDegrees::move(int axisNo,float distance)
{
	float vect[3];

	for (int a=0;a<3;++a)
	{
		vect[a]=axis[axisNo][a]*distance;
		pos[a]+=vect[a];
	}

//	translateMatrix(modelView,vect);
}

void CThreeDegrees::rotate(int axisNo,float angle)
{
	angle/=rade;
	TMatrix4 m;
	TQuaternion rotquat;
 
//	axisAngleToRotMatrix(angle,axis[axisNo],m);

	quat_convertFromAxisAngle(angle,axis[axisNo],rotquat);
	quat_convertToRotMatrix(rotquat,m);	

	/*
	//rotate the other axii by m
	for (int a=0;a<3;++a)
	{
		if (a!=axisNo)
		{
			rotateByRotMatrix(axis[a],m);
			normalize(axis[a]);
		}
	}
*/


	//rotate the world the other way
//	multMatrixBy(testMat,m);
	
	//multiply the quaternion by the rotquat
	quat_multiplyBy(quat,rotquat);
	quat_convertToRotMatrix(quat,rotateMat);


	
	transposeMatrix(rotateMat);
	copyMatrix(rotateMat,invRotateMat);
	transposeMatrix(invRotateMat);

	//get the axiis
	for (int a=0;a<3;++a)
	{
		for (int b=0;b<3;++b)
		{
			axis[a][b]=rotateMat[b*4+a];
		}
	}

	

/*	transposeMatrix(m);
	multMatrixBy(rotateMat,m);
	copyMatrix(rotateMat,invRotateMat);
	transposeMatrix(invRotateMat);*/
	
}

void CThreeDegrees::setFromPosQuat(float pos_in[3],TQuaternion quat_in)
{
	for (int a=0;a<3;++a)
	{
		pos[a]=pos_in[a];
		quat[a]=quat_in[a];
	}
	quat[3]=quat_in[3];



	//fill in the axises and matrices
	rotate(0,0);	
//	rotate(0,1);	
}

CThreeDegrees::CThreeDegrees()
{
//	for (int a=0;a<2;++a)
//	{
		ZeroMemory(axis,9*sizeof(float));
		axis[AXIS_RIGHT][0]=1;
		axis[AXIS_UP][1]=1;
		axis[AXIS_FRONT][2]=1;

//		messageBox("invRotateMat initialized, (%d)",this);
		loadIdentity(invRotateMat);
		loadIdentity(rotateMat);
//		loadIdentity(pointlessMat);

		pos[0]=0;
		pos[1]=0;
		pos[2]=0;

		quat[0]=1;
		quat[1]=0;
		quat[2]=0;
		quat[3]=0; 
//	}
}	


void CThreeDegrees::resetRot()
{
//	rotateMat->loadIdentity()
}