/*
Threedegrees.h
v1.0
(c)2001 Ben Woodhouse

  base class for objects rotatable through 3 degrees of freedom
*/

#ifndef threeDegreesH
#define threeDegreesH

#include "matrix.h"

#define AXIS_RIGHT 0
#define AXIS_UP 1
#define AXIS_FRONT 2

class CThreeDegrees
{
public:

	CThreeDegrees();
	void rotate(int axisNo,float angle);
	void move(int axisNo,float distance);
	void getFrom3ds(CThreeDegrees * t);
	void setFromPosQuat(float pos_in[3],TQuaternion quat_in); //sets up all the data from just
																					//a pos and a quaternion
	//void setViewMatrix();
	
	void resetRot();

	float rot[3];
	float pos[3];
/*
	double viewangle;
	double nearclip;
	double farclip;
	double aspect;
*/

	float axis[3][3];
	TMatrix4 rotateMat;
	TMatrix4 invRotateMat;
// TMatrix4 pointlessMat;

	TQuaternion quat;

//	TMatrix4 modelView;
};

#endif
