//Vector.cpp

//Version 1.71

//useful vector functions

/*
(c)2002 Ben Woodhouse

ben@elf-stone.com
www.elf-stone.com

This code may not be used in a commercial product without my permission.
If you redistribute it, this message must remain intact. 
*/

/*
float getAngleDifference(float angle0,float angle1)
{
	float subresult;

	//the difference between 2 angles is always less than 180

	//make sure both angles are within the acceptable range
	fixAngle(&angle0);
	fixAngle(&angle1);
 
	//this is one answer, not necesserily the shortest
	subresult=fabs(angle0-angle1);
	if (subresult>180) subresult=360-subresult;

	return subresult;
}
*/
#include "stdafx.h"
#include "vector.h"

//#define rade 57.2957795130823208767981548141052	 

float getFixAngle(float angle)
{
	int eger;
	float ra;
	ra=angle;

	if (angle>180)
	{
		eger=((int)angle+180)/360;
		ra=angle-eger*360;			
	}
	else
	{
		if (angle<-180)
		{
			eger=((int)angle-180)/-360;
			ra=angle+eger*360;			
		}
	}
	return ra;
}

bool isPointOnLine(float point[3],float l0[3],float l1[3], float &distFromLine)
{
	double lv[3];
	double pv[3];
	double pvl,lvl;
	double dfl;

	
	int a;
	distFromLine=0;

	//get the line's vector
	//and the vector from the line's start to the point
	for (a=0;a<3;++a)
	{
		lv[a]=l1[a]-l0[a];
		pv[a]=point[a]-l0[a];
	}

	//get the lengths of the vectors
	pvl=lengthOf_d(pv);
	lvl=lengthOf_d(lv);
	
	if (pvl>lvl) return false;


	if (pvl<VSMALL || lvl<VSMALL) return false;

	//normalise the vectors
	for (a=0;a<3;++a)
	{
		pv[a]/=pvl;
		lv[a]/=lvl;
	}

	//get the distance from the line
	dfl=1-dotProduct_d(pv,lv);

	if (dfl>1) return false; //the point goes off the end of the line

	//dfl is now the distance of the point from the line
	dfl*=pvl;

	if (dfl>VSMALL) return false;

	float vf[3]={-65.5, 2.69,	36.68};

	if (getManhattanDist(vf,point)<0.1)
	{
		glPrintf("\nPointOnLine: %f %f %f\n",point[0],point[1],point[2]);
		glPrintf("             %f %f %f\n",l0[0],l0[1],l0[2]);
		glPrintf("             %f %f %f\n",l1[0],l1[1],l1[2]);
	}

	distFromLine=dfl;

	return true;
}

float getDist(const float a[3],const float b[3])
{
	float d[3];
	for (int c=0;c<3;++c)
	{
		d[c]=a[c]-b[c];
	}

	return lengthOf(d);
}

float getManhattanDist(const float a[3],const float b[3])
{
	float c;

	c=fabs(a[0]-b[0]);
	c+=fabs(a[1]-b[1]);
	c+=fabs(a[2]-b[2]);

	return c;
}

float sizeOfTri(float pointa[3],float pointb[3],float pointc[3])
{
	float point[3][3]; //point[tri][point]==verpos

	int a;
	for (a=0;a<3;++a)
	{
		point[0][a]=pointa[a];
		point[1][a]=pointb[a];
		point[2][a]=pointc[a];
	}


	//pick an axis that all points are not on
	int axis=4;
	for (a=0;a<3;++a)
	{
		if (!(point[0][a]==point[1][a] && point[0][a]==point[2][a])) 
		{
			axis=a;
			break;
		}
	}
	if (axis==4) return 0;


	//find mid point on axis
	int midpoint;

	float highest=-1000000000;
	int highpt;

	float lowest=1000000000;
	int lowpt;

	for (a=0;a<3;++a)
	{
		if (point[a][axis]>=highest)
		{
			highest=point[a][axis];
			highpt=a;
		}
		if (point[a][axis]<lowest)
		{
			lowest=point[a][axis];
			lowpt=a;
		}
	}

	for (a=0;a<3;++a)
	{
		if (a!=lowpt && a!=highpt)
		{
			midpoint=a;

			break;
		}
	}

	//find where point's plane intersects with its opposite line

	//get opposite line's vector
	float lvect[3];

	for (a=0;a<3;++a)
	{
		lvect[a]=point[highpt][a]-point[lowpt][a];
	}

	//get distance on axis from lowest point
	float axisdist=point[midpoint][axis]-point[lowpt][axis];

	//unnecessary error checking
	if (lvect[axis]==0) 
	{
	//	messageBox("Error: tri is crap");
		return 0;
	}
	//divide axisdist by lvect[axis] to get multiplier
	float mult=axisdist/lvect[axis];

	//multiply lvect by multiplier and add to its origin to find intersection point
	
	float Ipoint[3];
	for (a=0;a<3;++a)
	{
		Ipoint[a]=(lvect[a]*mult)+point[lowpt][a];
	}

	//armed with the intersection point, get distance from it to the midpoint to reveal the
	//triangle's waist measurement (more commonly known as width)

	float wvect[3];
	for (a=0;a<3;++a)
	{
		wvect[a]=fabs(Ipoint[a]-point[midpoint][a]);
	}
	float triWidth=lengthOf(wvect);

	//now, get the triangle's height measurement
	float triHeight=point[highpt][axis]-point[lowpt][axis];

	//finally, get the area and return it
	
	float area=triHeight*triWidth*0.5;

	return area;

	

}

float angleSubtract(float a, float b) //returns a-b
{
	float rv=a-b;
	rv=getFixAngle(rv);
	return rv;

}

void fixAngle(float * angle)
{
	int eger;

	if (*angle>180)
	{
		eger=(*angle+180)/360;
		*angle-=eger*360;			
	}
	else
	{
		if (*angle<-180)
		{
			eger=(*angle-180)/-360;
			*angle+=eger*360;			
		}
	}
}

void fixAngles(float * angles)
{
	int a;

	for (a=0;a<3;++a)
	{
		fixAngle(&angles[a]);
	}
}

//returns 0 on no action, -1 on low constraint and 1 on high constraint
int constrain(float * value,float low, float high)
{
	if (*value>high)
	{
		*value=high;
		return 1;
	}
	else
	{
		if (*value<low)
		{
			*value=low;
			return -1;
		}
	}
	return 0;
}

//FIXME: should take 3 angles
void coordsToAngles(float vcoord[3],float * vlength, float * vangle)
{
	double xandz;
	float length;

	length=lengthOf(vcoord);
	xandz=sqrt(pow(vcoord[0],2)+pow(vcoord[2],2));

	if (length>0)
	{
		vangle[0] = -asin(vcoord[1] / length)*rade;
	}
	else vangle[0]=0;

	if (xandz>0)
	{
		vangle[1] =  asin(vcoord[0] / xandz )*rade;
	}
	else vangle[1]=0;

	if (vcoord[2]<0) vangle[1]=180-vangle[1];
	vangle[2]=0;

	*vlength=length;
}

//FIXME: should take 3 angles
void anglesToCoord(float vangle[3],float vlength,float * vcoord)
{
	double xandz;

	xandz=cos(vangle[0]*dera)*vlength;
	vcoord[1]=-sin(vangle[0]*dera)*vlength;
	
	vcoord[0]=sin(vangle[1]*dera)*xandz;
	vcoord[2]=cos(vangle[1]*dera)*xandz;

}


double lengthOf_d(double axis[3])
{
	double length;

	length=sqrt(pow(axis[0],2)+pow(axis[1],2)+pow(axis[2],2));

	return length;
}


float lengthOf(float axis[3])
{
	float length;

	length=sqrt(pow(axis[0],2)+pow(axis[1],2)+pow(axis[2],2));

	return length;
}


void getTriPlane(float plane[4], float pointa[3], float pointb[3], float pointc[3])
{
/*
normal = (p1-p2) x (p3-p2)
k = normal * p1
  */
    //get the normal
//	float norm[3];

    getTriNormal(plane,pointa,pointb,pointc);
    //with normal 0,1,0, plane eq is
    //0x+1y+0z=D


    //so plug in a point on the plane (say 1,1,1) to get D
    //D = 0*2 + 1*2 + 3*0

    //scratch that.
    //with normal 0,1,0, plane eq is
    //0x+1y+0z=-D


    //so plug in a point on the plane (say 1,1,1) to get D
    //-D = 0*2 + 1*2 + 3*0
    plane[3]=-dotProduct(plane,pointa);
}


bool sameSideOfLine(float p1[3], float p2[3], float linea[3], float lineb[3])
{
	float res1[3];
	float res2[3];

	float linev[3];
	float v1[3];	
	float v2[3];

	//calculate the vectors from linea to the end of the line
	//and from linea to each of the two points
	for (int a=0;a<3;++a)
	{
		linev[a]=lineb[a]-linea[a];
		v1[a]=p1[a]-linea[a];
		v2[a]=p2[a]-linea[a];
	}

	//get the cross products of v1 and the line
	crossProduct(res1,linev,v1);
	crossProduct(res2,linev,v2);

	//if the two resultant vectors point the same way then they're on the same side of the line

	//get the dot products the two
	if (dotProduct(res1,res2)>=0) return true;

	return false;
}


void getTriNormal(float *norm,float pointa[3],float pointb[3],float pointc[3])
{
	float vect[2][3];
	int a;
//	float tri[3][3];


	for (a=0;a<3;++a)
	{
		vect[0][a]=pointb[a]-pointa[a];
		vect[1][a]=pointc[a]-pointa[a];
	}
/*
	for (a=0;a<3;++a)
	{
		tri[0][a]=pointa[a];
		tri[1][a]=pointb[a];
		tri[2][a]=pointc[a];
	}
	for (b=0;b<2;++b)
	{
		for (a=0;a<3;++a)
		{
			vect[b][a]=tri[b+1][a]-tri[0][a];
		}
	}
*/
	crossProduct(norm,vect[0],vect[1]);
	normalize(norm);
}

void normalize(float *vect)
{
	float length;

	length=sqrt(
				pow(vect[0],2)+
				pow(vect[1],2)+
				pow(vect[2],2)
				);

	if (length!=0)
	{
		float oneOverLength=1.0/length;
		vect[0]*=oneOverLength;
		vect[1]*=oneOverLength;
		vect[2]*=oneOverLength;
	}
}

void crossProduct(float *c,float a[3], float b[3])
{
	c[0]=a[1]*b[2] - b[1]*a[2];
	c[1]=a[2]*b[0] - b[2]*a[0];
	c[2]=a[0]*b[1] - b[0]*a[1];
}

float dotProduct(float a[3], float b[3])
{
	float c;

	c = (a[0]*b[0] + a[1]*b[1] + a[2]*b[2]);
	return c;
}

double dotProduct_d(double a[3], double b[3])
{
	double c;

	c = (a[0]*b[0] + a[1]*b[1] + a[2]*b[2]);
	return c;
}











