//Vector.h

//Version 1.71

//special version which only works in character editor (or whatever it's called)

//all of these functions may not be tested

//float getAngleDifference(float angle0,float angle1);

//returns 0 on no action, -1 on low constraint and 1 on high constraint 

//void displayVector(float vect[3]);

#ifndef VECTOR_H
#define VECTOR_H

#define VSMALL 0.001

float sizeOfTri(float pointa[3],float pointb[3],float pointc[3]);
float angleSubtract(float a, float b); //returns a-b

float getFixAngle(float angle);
void fixAngle(float * angle);
void fixAngles(float * angles);

int constrain(float * value,float low, float high);
void coordsToAngles(float vcoord[3],float * vlength, float * vangle);
void anglesToCoord(float vangle[3],float vlength,float * vcoord);

double lengthOf_d(double axis[3]);
float lengthOf(float axis[3]);

bool isPointOnLine(float point[3],float l0[3],float l1[3], float &distFromLine);

/*
Vector.h
*/

//tells if 2 points are the same side of a line 
//(less than 90 degrees apart, treating the line as an axis)
bool sameSideOfLine(float p1[3], float p2[3], float linea[3], float lineb[3]);


void getTriNormal(float *norm,float pointa[3],float pointb[3],float pointc[3]);

void normalize(float *vect);

//the cross product of 2 vectors is always purpendicular to the two of them
void crossProduct(float *c,float a[3], float b[3]);

void getTriPlane(float plane[4], float pointa[3], float pointb[3], float pointc[3]);
float getManhattanDist(const float a[3],const float b[3]);
float getDist(const float a[3],const float b[3]);


//finds the cosine of the angle between 2 unit-length vectors
//OR
//a dot b = |a|*|b|*cos(angle)
//|a| meaning length of a
float dotProduct(float a[3], float b[3]);
double dotProduct_d(double a[3], double b[3]);

inline void vectorAdd(const float a[3], const float b[3], float * out) //c=a+b
{
	out[0]=a[0]+b[0];
	out[1]=a[1]+b[1];
	out[2]=a[2]+b[2];
}
inline void vectorSubtract(const float a[3], const float b[3], float * out) //c=a-b
{
	out[0]=a[0]-b[0];
	out[1]=a[1]-b[1];
	out[2]=a[2]-b[2];
}

inline void vectorEquals(float * out, const float b[3])
{
	out[0]=b[0];
	out[1]=b[1];
	out[2]=b[2];
}

#endif