/*
Visualdebug.h
(c)2001 Ben Woodhouse

v1.0
__________________________________________________

Visual debugging tools for openGL applications)
*/

class CdebugPoint
{
	public:
		CdebugPoint()
		{
			size=3;
			colour[0]=1;
			colour[1]=0;
			colour[2]=0;
			colour[3]=1;
			exist=false;
		}

		void setPos(float x,float y,float z)
		{
			pos[0]=x;
			pos[1]=y;
			pos[2]=z;
			exist=true;
		}

		void setPosv(float pos_in[3])
		{
			pos[0]=pos_in[0];
			pos[1]=pos_in[1];
			pos[2]=pos_in[2];
			exist=true;
		}

		void setColour(float r, float g, float b)
		{
			colour[0]=r;
			colour[1]=g;
			colour[2]=b;
		}
		void setColourv(float colour_in[3])
		{
			colour[0]=colour_in[0];
			colour[1]=colour_in[1];
			colour[2]=colour_in[2];
		}

		void setSize(float size_in)
		{
			size=size_in;
		}

		void draw() 
		{
			if (exist) 
			{
				glPushAttrib(GL_ENABLE_BIT);

					//glDisable(GL_TEXTURE_2D);
					setTextureLevel(0);

					glDisable(GL_LIGHTING);
					glPointSize(size);
					glBegin(GL_POINTS);
						glColor4fv(colour);
						glVertex3fv(pos);
					glEnd();
				glPopAttrib();
			}
		}
	protected:
		float colour[4];
		float size;
		float pos[3];
		bool exist;

};


